// ********************************************************************
// ROOT macro: generate_ce_cs
// Reads EPICS 2017 data contained in EPDL2017.ALL for Compton effect 
// for all chemical elements (Z=1 to 100).
// Generates 100 cross section data files (one file per element) 
// in compliance with the livermore GEANT4 format in the directory, in which these files are placed :
// pairdataEPDL2017  => contains files for pure pair production "comp"
// Authors: Zhuxin LI, Claire MICHELET @CENBG,France
// 2019.12.09
// ********************************************************************

// main method

void compare_epdl97Vs2014()
{
	FILE * fp1 = fopen("EPDL97.DAT","r");
	// FILE * fp1 = fopen("test1.txt","r");  
	
	FILE * fp2 = fopen("EPDL2014.ALL","r");  
	// FILE * fp2 = fopen("test2.txt","r");  
	 
    double d1; 
    double d2; 
    double d3; 
    double d4; 
    double d5; 
    double d6; 
    double d7; 
    double d8; 
    double d9;


	double e1; 
    double e2; 
    double e3; 
    double e4; 
    double e5; 
    double e6; 
    double e7; 
    double e8; 
    double e9; 	
	
    Int_t ncols1 = 0;
    Int_t ncols2 = 0;
   
    
	Int_t z = 1;
	int count = 0;
	
    char data1[75] = "";	
	char data2[75] = "";	
    while(1)
    {
		if(fgets (data1, 75, fp1)!= NULL)
		{
			fgets (data2, 75, fp2);
			// cout<<"1__"<<data1<<endl;
			// cout<<"2__"<<data2<<endl;
			 ncols1 =  sscanf(data1,"%lf %lf %lf %lf %lf %lf %lf %lf %lf ",
								   &d1,&d2,&d3,&d4,&d5,&d6,&d7,&d8,&d9);
			 // cout<<ncols<<endl;
			 ncols2 =  sscanf(data2,"%lf %lf %lf %lf %lf %lf %lf %lf %lf ",
								   &e1,&e2,&e3,&e4,&e5,&e6,&e7,&e8,&e9);
			 count++;
			 cout<<count<<" "<<ncols1<<" "<<ncols2<<endl;
			 // return;
			 
			 // if(ncols1==9)
			 // {
				 // printf("%.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", d1, e1, d2, e2, d5, e5, d7, e7);
				 // getchar();
			 // }
			 // if(d1==d2 && e1 == e2)
			 if(d1!=e1 || d2!=e2 || d3!=e3 || d4!=e4 
					 || d5!=e5 || d6!=e6 || d7!=e7 || d8!=e8 || d9!=e9)
			 {
				 printf("%.9e %.9e\n", e1, e2);
				 cout<<count<<"fire "<<ncols1<<" "<<ncols2<<" "
				 <<d1<<" "<<e1<<" "
				 <<d2<<" "<<e2<<" "
				 <<d3<<" "<<e3<<" "
				 <<d4<<" "<<e4<<endl;
			 }
			 for(Int_t i =0;i<9;++i)
			 {
				 d1 = 0; 
				 d2 = 0; 
				 d3 = 0; 
				 d4 = 0; 
				 d5 = 0; 
				 d6 = 0; 
				 d7 = 0; 
				 d8 = 0; 
				 d9 = 0;
				 
				 e1 = 0; 
				 e2 = 0; 
				 e3 = 0; 
				 e4 = 0; 
				 e5 = 0; 
				 e6 = 0; 
				 e7 = 0; 
				 e8 = 0; 
				 e9 = 0;
			}
		}
		else {
			
			 cout<<"---ending---"<<count<<endl;
			 break;
			 
		}
		
		 
		
        
	}
	// fprintf (final, "%i           %i\n",-2,-2);
	fclose(fp1); 
	fclose(fp2); 
}