bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
	
	
 
	
	
	return false;
}
double eps=1e-15;//absolut difference
double releps=1e-10;//relative difference
// double releps=0.0001;//relative difference
// double releps=0.000001;//relative difference
 

void compare_fittingParametersBetweenG4AndReproduced2014()
{
	std::vector<double> fParamHigh[101];
	std::vector<double> fParamLow[101];
	double fLowLimits[101];
	double fHighLimits[101];
	int fNShells[101];

	std::ostringstream ost;
	ost << "./epics2017-master/fitPhotoElectricEffect/low_high_limits_final2.dat";
	std::ifstream fin(ost.str().c_str());
	for(int i = 0; i<1612; ++i) 
	{
		int z;
		double lowLimit;
		double highLimit;
		fin >> z >> lowLimit>>highLimit;
		fLowLimits[z] = lowLimit;
		fHighLimits[z] = highLimit;
	}
	
	// printf("Low limit = %.9e High limit = %.9e\n",fLowLimits[100],fHighLimits[100]);
	fin.close();


	double edgeMin, edgeMax;
	double x, y;
	int numberOfNodes;	
		  
	for(int z = 1;z<=100;z++)
	{
	//**************************************************************
		// read high energy fitting parameters
		std::ostringstream ost1;
		ost1 << "phot_epics2014/pe-high-" << z <<".dat";
		std::ifstream fin1(ost1.str().c_str());
		fin1 >> fNShells[z] >> x;
		fParamHigh[z].reserve(fNShells[z]*7+1);

		for(int i = 0; i<fNShells[z]*7+1;i++)
		{
			fin1 >> x;
			fParamHigh[z].push_back(x);
			// if(z ==1)  printf("yyyy%d %.9e\n", i, x);
		}
		fin1.close();
	//**************************************************************
	// read low energy fitting parameters
		std::ostringstream ost1_low;
		ost1_low << "phot_epics2014/pe-low-" << z <<".dat";
		std::ifstream fin1_low(ost1_low.str().c_str());
		fin1_low >> x >> x;
		fParamLow[z].reserve(fNShells[z]*7+1);
		for(int i = 0; i<fNShells[z]*7+1;i++)
		{
			fin1_low >> x;
			fParamLow[z].push_back(x);
		}
			fin1_low.close();
	}
	for(int z = 1;z<=100;z++)
	{
		if(!IsEqual(fLowLimits[z],fParamLow[z][0] , eps, releps))
		{
			printf("%d %.9e %.9e\n",z, fLowLimits[z], fParamLow[z][0]);
		}
		
		
	}
	cout<<endl;
	for(int z = 1;z<=100;z++)
	{
		if(!IsEqual(fHighLimits[z],fParamHigh[z][0] , eps, releps))
		{
			printf("%d %.9e %.9e\n",z, fHighLimits[z], fParamHigh[z][0]);
		}
	}
	
	
	
}