#include "TH1.h"
#include "TMath.h"
#include "TF1.h"
#include "TLegend.h"
#include "TGraphErrors.h"
#include "TCanvas.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
 
	
	
	return false;
}
double eps=1e-15;//absolut difference
double releps=1e-10;//relative difference
struct Info
{
 Info(int Z, int sub = 0, bool k = false)
 :z(Z), subshellIndex(sub),KvsLowLimit(k){}
 int z;
 int subshellIndex;
 bool KvsLowLimit;// to save if K binding energy equals to the low limit
 double ratio1Max; // for low fit
 double ratio2Max; // for high fit
};
struct Average
{
 Average(int Z, int sub = 0)
 :z(Z), subshellIndex(sub){}
 int z;
 int subshellIndex;
 double average1; // for low fit
 double average2; // for high fit
};

using namespace std;

Double_t XLIM = 0.0;
Double_t YLIM = 0.0;
Double_t P0 = 0.0;

Double_t XLIM_2 = 0.0;
Double_t YLIM_2 = 0.0;
Double_t P0_2 = 0.0;

Double_t x0= 0.0;
Double_t fx0=0.0;

Double_t myx0= 0.0;
Double_t myfx0=0.0;
Double_t a= 0.0;
Double_t fa=0.0;


Double_t GetP4_2(Double_t *par){
    Double_t x2 = XLIM_2*XLIM_2;
    Double_t x3 = XLIM_2*x2;
    Double_t x4 = x2*x2;
    Double_t p4 = (YLIM_2 - par[0])*x4 - par[1]*x3 - par[2]*x2 - par[3]*XLIM_2;
    return p4;
}

//LOW fit
Double_t fitf_2(Double_t *x, Double_t *par){
    Double_t x2 = x[0]*x[0];
    Double_t x3 = x2*x[0];
    Double_t x4 = x3*x[0];
    Double_t x5 = x4*x[0];
	
    Double_t fitVAL = P0_2 + par[0]/x[0] + par[1]/x2 + par[2]/x3 +par[3]/x4 + par[4]/x5;
    
    return fitVAL;
}



//HIGH fit
//* y = (1/x)*(a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)  <==> xy = Y = (a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)
Double_t fitf(Double_t *x, Double_t *par){
    Double_t x2 = x[0]*x[0];
    Double_t x3 = x2*x[0];
    Double_t x4 = x3*x[0];
    Double_t x5 = x4*x[0];
	
    Double_t fitVAL = P0 + par[0]/x[0] + par[1]/x2 + par[2]/x3 +par[3]/x4 + par[4]/x5;
    return fitVAL;
}

double myEval(double energy, double constant, Double_t *par)
{
    Double_t x2 = energy*energy;
    Double_t x3 = x2*energy;
    Double_t x4 = x3*energy;
    Double_t x5 = x4*energy;
    Double_t value = constant + par[0]/energy + par[1]/x2 + par[2]/x3 +par[3]/x4 + par[4]/x5;
    
    return value;

}

string sInt(Int_t number)
{
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
}

string sDouble(Double_t number)
{
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
}

// void fitForSubshellCS2017()
// {
	// gSystem->Exec("mkdir -p plots/fit/Histo_high");
	// gSystem->Exec("mkdir -p plots/fit/Histo_low");
	// gSystem->Exec("mkdir -p plots/fit/Histo_low_high");
	
	
	// // infoVec.reserve(2000);
	// std::vector<struct Info> infoVec;
	// std::vector<struct Average> averageVec;
    // gROOT->Reset();
    // gROOT->Reset();
    // gStyle->SetOptStat(0);
    // gStyle->SetOptFit();
    // Int_t Z;
    
    // Double_t elim = 0.055;// high fit limit
    // Double_t lowlim = 0.005;// low fit limit
    // Double_t deltaLim = elim - lowlim;
    // //Double_t elim = 0.0000052;// 0.0006->600eV - 0.006MeV->6KeV  It was Threshold value: 0.6 MeV --> 600KeV
    // //Double_t lowlim = 0;
    
    
    // Double_t eK = 1.0;
    
    // Double_t x, y;
    
    // //Fit of high energies
	// // 29 subshells at most
    // Double_t PP0[29];
    // Double_t PP1[29];
    // Double_t PP2[29];
    // Double_t PP3[29];
    // Double_t PP4[29];
    // Double_t PP5[29];
    // Double_t PP[6]; // 6 parameters
    
    // //Fit of low energies
    // Double_t PP0_2[29];
    // Double_t PP1_2[29];
    // Double_t PP2_2[29];
    // Double_t PP3_2[29];
    // Double_t PP4_2[29];
    // Double_t PP5_2[29];
    // Double_t PP_2[6];
    
  
	
    
    // char line[200];
    // char line_2[200];
    
    // Double_t xxx[2000];
    // Double_t yyy[2000];
    // Double_t xx1[2000];
    // Double_t yy1[2000];
    // Double_t erx[2000];
    // Double_t ery[2000];
    // Double_t energy[2000];
    // Double_t xx0[2000];
    // Double_t yy0[2000];
    
    // Double_t xxx_2[2000];
    // Double_t yyy_2[2000];
    // Double_t xx1_2[2000];
    // Double_t yy1_2[2000];
    // Double_t erx_2[2000];
    // Double_t ery_2[2000];
    // Double_t energy_2[2000];
    // Double_t xx0_2[2000];
    // Double_t yy0_2[2000];
    
    // Double_t alldatax[2000];
    // Double_t alldatay[2000];
    
    // for(int i=0 ; i<2000; i++)
    // {
        // xxx[i]=0;
        // yyy[i]=0;
        // xx1[i]=0;
        // yy1[i]=0;
        // erx[i]=0;
        // ery[i]=0;
        // energy[i]=0;
        // xx0[i]=0;
        // yy0[i]=0;
        // alldatax[i]=0;
        // alldatay[i]=0;
        
        // xxx_2[i]=0;
        // yyy_2[i]=0;
        // xx1_2[i]=0;
        // yy1_2[i]=0;
        // erx_2[i]=0;
        // ery_2[i]=0;
        // energy_2[i]=0;
        // xx0_2[i]=0;
        // yy0_2[i]=0;
        
    // }
    
    
    // Double_t delta=100000;
    // Double_t delta_2=100000;
    
    
	
	
    // string LowFitsFile ="lowFittingParams.dat";
    // ofstream LowFits(LowFitsFile.c_str(), ios::out);
	// LowFits.setf(ios::scientific);
	
	
	// string HighFitsFile ="highFittingParams.dat";
    // ofstream HighFits(HighFitsFile.c_str(), ios::out);	
	// HighFits.setf(ios::scientific);
	
	// string low_high_limits ="low_high_limits.dat";
    // ofstream LowHighLimits(low_high_limits.c_str(), ios::out);	
	// LowHighLimits.setf(ios::scientific);
	
	
    // for(Z=1; Z<=1; Z++)
    // {
		// // for(int i=0 ; i<27; i++)
		// // {
			// // PP0[i]=0;
			// // PP1[i]=0;
			// // PP2[i]=0;
			// // PP3[i]=0;
			// // PP4[i]=0;
			// // PP5[i]=0;
			
			// // PP0_2[i]=0;
			// // PP1_2[i]=0;
			// // PP2_2[i]=0;
			// // PP3_2[i]=0;
			// // PP4_2[i]=0;
			// // PP5_2[i]=0;
			
		// // }
	
		// struct Info info(Z);
		// struct Average average(Z);
        // elim = 0.07;// 0.0006->600eV - 0.006MeV->6KeV  It was Threshold value: 0.6 MeV --> 600KeV
        // lowlim = 0.006;//delta=
        // deltaLim = elim - lowlim;
        
        // // cout<<"yes"<<endl;
        // Int_t n0=0; // number of low-energy points for one shell
        // Int_t n1=0; // number of points for fit for one shell
        // Int_t n2=-1; // number of shells
        // Int_t n3=0; // number of shells
        // Int_t n5=0; // number of shells with low-energy data
        // Int_t n6=0; // first x-section file
        // Int_t N=0;
        
        
        // Int_t n0_2=0; // number of high-energy points for one shell
        // Int_t n1_2=0; // number of points available for low energy fit for one shell
        // Int_t n2_2=-1; // number of shells
        // Int_t n3_2=0; // number of shells
        // Int_t n5_2=0; // number of shells with low-energy data
        // Int_t n6_2=0; // first x-section file
        // //Int_t N_2=0;
        
        // cout <<  "========= Element " << Z << " =========" <<endl;
        // string s = sInt(Z);
        
        // TString datafile="./epics2017/phot_preliminary/pe-ss-cs-" + s + ".dat";
        
        
        // // string ffdata = (string)datafile;        
        // //IN
        // // ifstream  data_file(ffdata.c_str(), ios::in );
        // ifstream  data_file(datafile, ios::in );
        // if(data_file.fail()){
            // cout << "Error opening data file"  << endl;
        // }else {
            // cout << "data file " << datafile << " is opened" << endl;
        // }
        // if(!data_file) break;
        
        
        // for (N = 0; N < 99999; N++)
        // {
            // data_file >> x >> y;
			
            // if(x < -1.5) 
			// { 
                // break; 
                
            // } 
			// else if(0.0 == y) 
			// {
                
                // n0 = -1;    // number of low-energy points for one shell
                // n1 = -1;    // number of points for fit for one shell
                // n3 = 0;     // number of shells
                
                // n0_2 = -1;
                // n1_2 = -1;
                // n3_2 = 0;   // number of shells
                
                // delta = 100000;
                // delta_2 = 100000;
                
                // n2++;  //0  only at the first iteration // index of subshell
                // n2_2++;//0
                
                // energy[n2] = x;   //binding energies for subshell n2
                // energy_2[n2] = x;
                // // if(n2 ==1) return;
                // // if(n2 ==2 ) break;
				// info.subshellIndex = n2;
				// average.subshellIndex = n2;
                // if(0 == n2)
                // {
            
                    // printf("__Binding energy of K-shell:%.9e\n", energy[0]);
                    // printf("__1___lowlim: %.9e, elim: %.9e, deltaLim: %.9e\n", lowlim, elim, deltaLim);
                    // eK = energy[0];
                    
                    // if(Z<13) //* 1-12
                    // {
                        // lowlim=0.005;
                        // elim=0.07  ;
                    // }else if (Z==14)
                    // {
                        // lowlim=0.009;
                        // elim=0.15;
                    
                    // }
                    // else if(Z>12 && Z<30) //* 13 15-29
                    // {
                        // lowlim=0.006;
                        // elim=0.07;
                    // }
                    
                    // else if(Z>29 && Z<60) //* 30-59
                    // {
                        // lowlim=eK;
                        // elim=eK+deltaLim;

                    // }
                    // else if(Z>59 && Z<68) //*60-67  
                    // {
						
                        // deltaLim=0.055-0.005;
                        // elim=eK+5*deltaLim;
                    // }
                    // else if((Z>71 && Z<75) || (Z>81&&Z<88) || (Z>88&& Z<93)){ //*72-74 82-87 89-92
                    // //else if((Z>71 && Z<75) || (Z>81&&Z<88) || (Z>88)){
                        
                        // lowlim=eK+0.1;
                        // elim=lowlim+5*deltaLim;
                    
                    // }
                    // else if (Z==96)
                    // {
                        // elim=eK+5*deltaLim;
                    // }
                    // else if(Z>67){ // *68-71  75-81 88 93-100
                
                        // // lowlim=eK+0.1;
                        // elim=eK+5*deltaLim;

                    // }
					
                    // printf("__2___lowlim: %.9e, elim: %.9e, deltaLim: %.9e\n", lowlim, elim, deltaLim);
                    
                // }
            // }
            
            // //***********************
            // //
            // //DATA FOR LOW ENERGY FIT
            // //
            // //**********************
            // else if(x > lowlim && x < elim ) 
			// {
				
                // n0++;
                // xx0[n0] = x;
                // yy0[n0] = y;				
                
                // n1_2++;// * n1_2 is used to count the number of points for low fit
                // if(0 == n1_2) {
					
					// // n1_2 =0, means it is the first point in low fit range, 
					// //there is a possibility that the first point equals to binding energy of K shell, 
					// // that means now the low fit limit equals to K binding energy
					// // in this case of fit, this point will be repeated twice
					// // besides, the first point of high fit will be added in low fit too
					// if(x==energy[0])
					// {
						// XLIM_2=x;
						// YLIM_2=x*y;
						
						// xxx_2[0] = XLIM_2;
						// yyy_2[0] = YLIM_2;
						// erx_2[0] = 0.0;
						// ery_2[0] = YLIM_2*0.01;
					// }
					// else
					// {
						// // otherwise, the last point in NON fit range will be added to low fit range
						// XLIM_2=xx0_2[n0_2];
						// YLIM_2=xx0_2[n0_2]*yy0_2[n0_2];
						
						// xxx_2[0] = XLIM_2;
						// yyy_2[0] = YLIM_2;
						// erx_2[0] = 0.0;
						// ery_2[0] = yyy_2[0]*0.01;
					// }
    
					
                    // n1_2++;
                    // n0_2++;
                    // xx0_2[n0_2] = x;
                    // yy0_2[n0_2] = y;
                // }
                // xxx_2[n1_2] = x;				
                // yyy_2[n1_2] = y*x;
				
				// if(n1_2==1) printf("The first two points of low fit: (%.9e,%.9e), (%.9e,%.9e)\n", xxx_2[0], yyy_2[0], xxx_2[n1_2], yyy_2[n1_2]);
				
                // erx_2[n1_2] = 0.0;
                // ery_2[n1_2] = y*x*0.05;
                // if(abs(x - 1) < delta_2) {
                    // n3_2 = n1_2;
                    // delta_2 = abs(x - 1);
                // }
                
            // }
            
            // //LOW ENERGY DATA - NO FIT
            // else if (x > 0.0 && x <=lowlim )
            // {
				// // cout<<"******"<<x<<" "<<y<<endl;
                // //Important for the other two fits
                // n0++;
                // xx0[n0] = x;
                // yy0[n0] = y;
                // ///
                // n0_2++;
                // xx0_2[n0_2] = x;  //* n0_2 counts the points below low limit, last point will be counted to low fit as well if necessary
                // yy0_2[n0_2] = y;
                
            // }
            // //DATA FOR HIGH ENERGY FIT
            // else if(x > 0.0) 
			// {
                // n1++;// *n1 used to count the number of points for high fit
				// // similarly as low fit
				// // last point of low fit will be added to high fit
                // if(0 == n1) 
				// {
					// // this is the point before the current (x, y)
                    // XLIM = xx0[n0];
                    // YLIM = xx0[n0]*yy0[n0];
                    // xxx[0] = XLIM;
                    // yyy[0] = YLIM;
					
                    // erx[0] = 0.0;
                    // ery[0] = YLIM*0.001;
                    // n1++;
                    // n0++;
                    // xx0[n0] = x; //* n0 is used to count the total number of points below elim, with one point in
                    // yy0[n0] = y;// * the high fit range
                // }
                // xxx[n1] = x;
                // yyy[n1] = y*x;
				// if(n1==1) printf("The first two points of high fit: (%.9e,%.9e), (%.9e,%.9e)\n", xxx[0], yyy[0], xxx[n1], yyy[n1]);
				
                // erx[n1] = 0.0;
                // ery[n1] = y*x*0.05;
                // if(abs(x - 1) < delta) {
                    // n3 = n1;
                    // delta = abs(x - 1);
                // }
            
                // // negative number - end of a shell
            // }
            // else //is the end of one shell (ROW -1 -1 reached)
            // {
				// string s1 = sInt(n2);
				// if(IsEqual(xxx_2[0],energy[0] , eps, releps))
				// {
					// info.KvsLowLimit = true;
					
					
					// // continue;
				// }
                // ery[n3] = 0.2*ery[n3];
                // Double_t nn = n1+1; // number of high fit
				
                // n0++;
				
                // printf("*******High Energy fit:********\n");
                // printf("For subshell_%d,\n",n2);
                // printf("Number of points for fit: %f,\n",nn);
                // printf("High fit starts (%.9e, %.9e), ends (%.9e, %.9e)\n",xxx[0], yyy[0], xxx[n1], yyy[n1]);
                
                
                // //First fit: high energies
                
                // //***********************************
                // TCanvas *c = new TCanvas("c","GraphFit",xxx[0], xxx[n1], 700, 800);
                // TF1 *fitFcn = new TF1("fitFcn",fitf,xxx[0],xxx[n1],5);
                
               
                
                // P0 = yyy[n1];
                // Double_t p2 = (yyy[0] - P0)*xxx[0]*xxx[0];
                // Double_t p1 = (yyy[n3]- P0)*xxx[n3];
                // Double_t p3 = 0.0;
                // Double_t p4 = 0.0;
                // //new parameter added to improve the fit
                // Double_t p5 = 0.0;
                // fitFcn->SetParameters(p1,p2,p3,p4,p5);
				// c->Divide(1,2);
                // c->cd(1);
                // // c->SetLogy(1);
                // // c->SetLogx(1);
				// gPad->SetLogx();
				// gPad->SetLogy();
                // // c->Update();
                
                // TGraphErrors *gr = new TGraphErrors(nn, xxx, yyy, erx, ery);
                // gr->Fit(fitFcn);
                
                // gr->SetTitle("FF Fit");
                // gr->Draw("ALP*");
                
                // PP[0] =  P0;
                // PP[1] =  fitFcn->GetParameter(0);
                // PP[2] =  fitFcn->GetParameter(1);
                // PP[3] =  fitFcn->GetParameter(2);
                // PP[4] =  fitFcn->GetParameter(3);
                // PP[5] =  fitFcn->GetParameter(4);
                
                // //the first point of high-energy fit must be used as last point for the low-energy interval
                // // double parForSecFit[6];
                // // parForSecFit[0]=PP[0];
                // // parForSecFit[1]=PP[1];
                // // parForSecFit[2]=PP[2];
                // // parForSecFit[3]=PP[3];
                // // parForSecFit[4]=PP[4];
                // // parForSecFit[5]=PP[5];
                
                // PP0[n2]=PP[0];
                // PP1[n2]=PP[1];
                // PP2[n2]=PP[2];
                // PP3[n2]=PP[3];
                // PP4[n2]=PP[4];
                // PP5[n2]=PP[5];
				// for(int i = 0; i<=n2; ++i)
				// {
					// // cout<<"*********high fit for subshell: "<<i<<
					// // "        P0="<<PP0[i]<<" P1="<<PP1[i]<<" P2="<<PP2[i]<<" P3="<<PP3[i]
					// // <<" P4="<<PP4[i]<<" P5="<<PP5[i]<<endl;
					// // printf("*********high fit for subshell %d: %.9e %.9e %.9e %.9e %.9e %.9e\n", i, PP0[i], PP1[i], PP2[i], PP3[i], PP4[i], PP5[i] );
					
				// }
				
				// // for(int i = 0; i<=n2; ++i)
				// // {
					// // if(i)
					// // {
						// // PP[0] +=PP0[i];
						// // PP[1] +=PP1[i];
						// // PP[2] +=PP2[i];
						// // PP[3] +=PP3[i];
						// // PP[4] +=PP4[i];
						// // PP[5] +=PP5[i];
					// // }
					// // else{
						// // PP[0] =PP0[0];
						// // PP[1] =PP1[0];
						// // PP[2] =PP2[0];
						// // PP[3] =PP3[0];
						// // PP[4] =PP4[0];
						// // PP[5] =PP5[0];
					// // }
					
					// // // cout<<"*********sum of high fit for subshell: "<<i<<
					// // // " P0="<<PP[0]<<" P1="<<PP[1]<<" P2="<<PP[2]<<" P3="<<PP[3]
					// // // <<" P4="<<PP[4]<<" P5="<<PP[5]<<endl;
				// // }
				
				// c->cd(2);
				// gPad->SetLogx();
				// std::vector <Double_t> x;
				// std::vector <Double_t> y;
				// std::vector <Double_t> ratio;
				// double r2Max  =  0.0;
				// double sum2  =  0.0;
				// for(Int_t i =0; i<nn; ++i)
				// {
					// Double_t X = xxx[i];
					// x.push_back(X);
					// Double_t X2 = X*X;
					// Double_t X3 = X2*X;
					// Double_t X4 = X2*X2;
					// Double_t X5 = X4*X;
					// //*Y = (a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)
					// Double_t fitValue = PP0[n2] + PP1[n2]/X + PP2[n2]/X2 + PP3[n2]/X3 + PP4[n2]/X4 + PP5[n2]/X5;
					// Double_t ratioValue = (fitValue- yyy[i])/yyy[i]*100;
					// y.push_back(fitValue);
					// ratio.push_back(ratioValue);
					// // printf("%d %.9e %.9e\n",i, xxx[i], ratioValue);
					// if(abs(ratioValue)>abs(r2Max))
					// {
						// r2Max = ratioValue;
					// }	
					// sum2+=abs(ratioValue);
					// // if(n2==0)
					// // {
						// // printf("%d %.9e %.9e %.9e %.9e %.9e\n",i, xxx[i], yyy[i], fitValue, yyy[i]/xxx[i], fitValue/xxx[i]);

					// // }
				// }
				// info.ratio2Max = r2Max;
				// average.average2 = sum2/nn;
				
				
				// TGraph *graph1 = new TGraph(x.size(),x.data(),ratio.data());
				// graph1->SetMarkerStyle(24);  //red point
				// graph1->SetMarkerSize(1.0);
				// graph1->SetMarkerColor(kRed);
				// graph1->SetLineColor(kRed);	
				// graph1->Draw("AP");
				// graph1->GetXaxis()->SetTitle("Energy (MeV)");
				// graph1->GetYaxis()->SetTitle("Relative difference (%)");
                
				// TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
				// // leg->SetTextAlign(12);
				// leg->SetFillColor(0);	
				// leg->SetTextSize(0.04);
				
				// TString name1 = "High fit: - "+ sInt(x.size());	 + " points";
				
				// leg->AddEntry(graph1,name1);
				// //leg->DrawClone("Same");
				// leg->Draw();
				
                // c->Update();
                
                // string lowLimString = sDouble(lowlim);
                // string eLimString = sDouble(elim);
                // TString name="plots/fit/Histo_high/Ahisto_" + s + "_" +s1 + ".gif";
                
                // c->Print(name);
                // delete c;
                
                // std::cout<<"****** >>>>> "<<name<<std::endl;
                // //HIGH ENERGY FIT: END
                
                
                
                // //***********************************
                
                // //Second fit: low energies
                
                // //***********************************
                
                // ery_2[n3_2] = 0.2*ery_2[n3_2];
                // Double_t nn_2 = n1_2+1; //number of points for low fit
				// erx_2[n1_2] = 0.0;
                // ery_2[n1_2] = ery_2[n1_2]/5;
                // n0_2++;
				// n1_2++;
				// nn_2++;
                
              
				// xxx_2[n1_2]=xxx[1];  // add the second point of high fit in low fit
				// yyy_2[n1_2]=yyy[1];
				// erx_2[n1_2] = 0.0;
				// // ery_2[n1_2] = yyy[1]*xxx[1]*0.005; // it is not correct
				// ery_2[n1_2] = yyy[1]*0.005;  // it is correct
				
                // printf("*******Low Energy fit:********\n");
                // printf("For subshell_%d,\n",n2_2);
                // printf("Number of points for fit: %f,\n",nn_2);
                // printf("Low fit starts (%.9e, %.9e), ends (%.9e, %.9e)\n",xxx_2[0], yyy_2[0], xxx_2[n1_2], yyy_2[n1_2]);
                
                
                // P0_2=yyy[0];
                // int midBin=n3_2/2;
                // TCanvas *c_2 = new TCanvas("c_2","GraphFit_2",xxx_2[0], xxx_2[n1_2], 700, 800);
                // TF1 *fitFcn_2;
                // //TF1 *fitFcn_outer;
                // //TGraphErrors *gr_2;
                // // c_2->SetLogy(1);
                // // c_2->SetLogx(1);
                // // c_2->Update();
				// c_2->Divide(1,2);
				// c_2->cd(1);
				// // gPad->SetLogx();
				// gPad->SetLogy();
                
                
				// //*Y = (a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)
				// Double_t p2_2 = (YLIM_2 - P0_2)*XLIM_2*XLIM_2;
				// Double_t p1_2;
				// if(Z<68)
				// {
					// p1_2 = (yyy_2[0]- P0_2)*xxx_2[0];
				// }
				// else
				// {
				  
				   // p1_2 = (yyy_2[midBin]- P0_2)*xxx_2[midBin];
				// }
				// Double_t p3_2 = 0.0;
				// Double_t p4_2 = 0.0;
				// Double_t p5_2 = 0.0;
			
				// fitFcn_2 = new TF1("fitFcn_2",fitf_2,xxx_2[0],xxx_2[n1_2],5);
				// fitFcn_2->SetParameters(p1_2,p2_2,p3_2,p4_2, p5_2);
			
                // TGraphErrors *gr_2 = new TGraphErrors(nn_2, xxx_2, yyy_2, erx_2, ery_2);
                // gr_2->Fit(fitFcn_2);
                // gr_2->SetTitle("FF_2 Fit");
                // gr_2->Draw("ALP*");
                
              
               
                
                
               
                
                // if(n2==0)
                // {
                    // lowlim=xxx_2[0];
                    // elim=xxx[0];  //* pass the high limit for the rest of subshells
					
					// LowHighLimits<<setprecision(9)<<Z<<" "<<xxx_2[0]<<" "<<xxx[0]<<endl;
								
                // }
				
                
                // PP_2[0] =  P0_2;
                // PP_2[1] =  fitFcn_2->GetParameter(0);
                // PP_2[2] =  fitFcn_2->GetParameter(1);
                // PP_2[3] =  fitFcn_2->GetParameter(2);
                // PP_2[4] =  fitFcn_2->GetParameter(3);
                // PP_2[5] =  fitFcn_2->GetParameter(4);
                
                // //* better to use n2_2, though n2_2 =n2 always
                // PP0_2[n2]=PP_2[0];
                // PP1_2[n2]=PP_2[1];
                // PP2_2[n2]=PP_2[2];
                // PP3_2[n2]=PP_2[3];
                // PP4_2[n2]=PP_2[4];
                // PP5_2[n2]=PP_2[5];
				
				
				
				// for(int i = 0; i<=n2_2; ++i)
				// {
					// // cout<<"*********low fit for subshell: "<<i<<
					// // "        P0="<<PP0_2[i]<<" P1="<<PP1_2[i]<<" P2="<<PP2_2[i]<<" P3="<<PP3_2[i]
					// // <<" P4="<<PP4_2[i]<<" P5="<<PP5_2[i]<<endl;
					
					
					
				// }
				
				// for(int i = 0; i<=n2; ++i)
				// {
					// if(i)
					// {
						// PP_2[0] +=PP0_2[i];
						// PP_2[1] +=PP1_2[i];
						// PP_2[2] +=PP2_2[i];
						// PP_2[3] +=PP3_2[i];
						// PP_2[4] +=PP4_2[i];
						// PP_2[5] +=PP5_2[i];
					// }
					// else{
						// PP_2[0] =PP0_2[i];
						// PP_2[1] =PP1_2[i];
						// PP_2[2] =PP2_2[i];
						// PP_2[3] =PP3_2[i];
						// PP_2[4] =PP4_2[i];
						// PP_2[5] =PP5_2[i];
					// }
					
					// // cout<<"*********sum of low fit for subshell: "<<i<<
					// // " P0="<<PP_2[0]<<" P1="<<PP_2[1]<<" P2="<<PP_2[2]<<" P3="<<PP_2[3]
					// // <<" P4="<<PP_2[4]<<" P5="<<PP_2[5]<<endl;
				// }
				
                
				// c_2->cd(2);
				// // gPad->SetLogx();
				// std::vector <Double_t> x_2;
				// std::vector <Double_t> y_2;				
				// std::vector <Double_t> ratio_2;
				// double r1Max = 0.0;
				// double sum1 = 0.0;
				// //* because nn_2 did not add 1, therefore use i<=nn_2, rather thant i<nn_2
				// // for(Int_t i =0; i<nn_2; ++i)
				// for(Int_t i =0; i<nn_2; ++i)
				// {
					// Double_t X = xxx_2[i];
					// x_2.push_back(X);
					// Double_t X2 = X*X;
					// Double_t X3 = X2*X;
					// Double_t X4 = X2*X2;
					// Double_t X5 = X4*X;
					// //*Y = (a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)
					// Double_t fitValue = PP0_2[n2_2] + PP1_2[n2_2]/X + PP2_2[n2_2]/X2 + PP3_2[n2_2]/X3 + PP4_2[n2_2]/X4 + PP5_2[n2_2]/X5;
					// Double_t ratioValue = (fitValue- yyy_2[i])/yyy_2[i]*100;
					
					// y_2.push_back(fitValue);
					// ratio_2.push_back(ratioValue);
					// printf("Absolut %d %.9e %.9e\n",i, xxx_2[i], abs(ratioValue));
					// if(abs(ratioValue)>abs(r1Max))
					// {
						// r1Max = ratioValue;
					// }	
					// sum1+=abs(ratioValue);
					// if(n2_2==3)
					// {
						// // printf("%d %.9e %.9e %.9e %.9e %.9e\n",i, xxx[i], yyy[i], fitValue, yyy[i]/xxx[i], fitValue/xxx[i]);

					// }
					// // if(n2_2 ==1&&Z ==3) printf("%d %d %.9e\n", Z, n2_2, abs(ratioValue));
				// }
				// info.ratio1Max = r1Max;
				// average.average1 = sum1/(nn_2);
				
				// infoVec.push_back(info);
				// averageVec.push_back(average);
				// // int size = averageVec.size();
				// // printf("==================%d %d %.9e %.9e\n", averageVec[size-1].z, averageVec[size-1].subshellIndex, 
				// // averageVec[size-1].average1, averageVec[size-1].average2);
				
				// TGraph *graph2 = new TGraph(x_2.size(),x_2.data(),ratio_2.data());
				// graph2->SetMarkerStyle(24);  //red point
				// graph2->SetMarkerSize(1.0);
				// graph2->SetMarkerColor(kRed);
				// graph2->SetLineColor(kRed);	
				// graph2->Draw("AP");
				// graph2->GetXaxis()->SetTitle("Energy (MeV)");
				// graph2->GetYaxis()->SetTitle("Relative difference (%)");
                
				// TLegend* leg2 = new TLegend(0.65,0.7,0.9,0.9);
				// // leg->SetTextAlign(12);
				// // leg2->SetFillColor(0);	
				// leg2->SetFillStyle(0);	
				// leg2->SetTextSize(0.04);
				
				// TString name2 = "Low fit: - "+ sInt(x_2.size());	 + " points";
				
				// leg2->AddEntry(graph2,name2);
				// //leg->DrawClone("Same");
				// leg2->Draw();
				
				
                // c_2->Update();
                // string s1_2 = sInt(n2_2);
                // //TString name="Histo_oldData/Ahisto_" + s + "_" +s1 + ".gif";
                // TString name_2="plots/fit/Histo_low/Ahisto_" + s + "_" +s1_2 + ".gif";
                
                // c_2->Print(name_2);
                // delete c_2;
                
                // // very low-energy part: THIS IS NOT NECESSARY, WILL BE DONE BY THE LOW ENERGY FITTING
                
                // if(n0_2 > 0) {
                    // n5_2++;
                    // // fout_lowE << xx0_2[0] << " " << xx0_2[n0_2-1] << " " << n0_2 << " " << n2_2
                    // //<< endl;
                    // //cout << n0 << endl;
                    // //for(int i=0; i<n0_2; i++) {
                    // //    fout_lowE << xx0_2[i] << " " << xx0_2[i]*xx0_2[i]*xx0_2[i]*yy0_2[i] << endl;
                    // //}
                // }
				
				// //************combine high fit and low fit relative difference to verify the conjunction(begin)
			
			// TCanvas* mycanvas = new TCanvas((s+"_"+s1_2+"_RD").c_str(),(s+"_" + s1_2).c_str(),800, 50, 1000, 800);
			// mycanvas->SetGrid();
			
			// mycanvas->cd();
			// gPad->SetLogx();
			
			// TGraph *lowFit = new TGraph(x_2.size(),x_2.data(),ratio_2.data());
			// TGraph *highFit = new TGraph(x.size(),x.data(),ratio.data());
		
		
			// auto mg = new TMultiGraph();
		
			// //set graph parameters of EPICS2014
			// lowFit->SetMarkerStyle(24);  // red point
			// lowFit->SetMarkerSize(0.7);
			// lowFit->SetMarkerColor(kBlue);
			// //graph1->SetLineWidth(2);
			// lowFit->SetLineColor(kBlue);	
			// mg->Add(lowFit);
			
			// highFit->SetMarkerStyle(24);  //blue circle
			// highFit->SetMarkerSize(0.7);
			// highFit->SetMarkerColor(kRed);
			// highFit->SetLineColor(kRed);
			// mg->Add(highFit);
			
			// mg->Draw("AP");
			// TString title = "EPICS2017: Relative difference of fitted subshell cross sections using new fitting parameters for element " + s + "_" +s1_2;
			// mg->SetTitle(title);
						
			// mg->GetXaxis()->SetTitle("Energy (MeV)");
			// mg->GetYaxis()->SetTitle("Relative difference (%)");
			
			// // mg->GetXaxis()->SetTitleSize(0.06);
			// // mg->GetYaxis()->SetTitleSize(0.06);
			
			// mg->GetXaxis()->SetTitleOffset(1.3);
			// mg->GetYaxis()->SetTitleOffset(1.3);
			
			// // mg->GetXaxis()->SetLabelSize(0.05);
			// // mg->GetYaxis()->SetLabelSize(0.05);
			
			
			// mg->GetXaxis()->CenterTitle();
			// mg->GetYaxis()->CenterTitle();
			
			// TLatex latex1;
			
			// if(IsEqual(energy[0],lowlim , eps, releps))
			// {
				// latex1.SetTextSize(0.02);
				// latex1.SetTextAlign(22);
				// latex1.SetTextColor(kRed);
				// // RatioMax1 = sDouble(ratioMax1);
				// TString KBE= "K binding energy :" + sDouble(energy[0])+ "MeV";
				// TString lowlimS= "low limit = K binding energy";
				// TString highlimS= "high limit: " + sDouble(elim)+ "MeV";
				// latex1.DrawLatexNDC(0.7,0.8,KBE);
				// latex1.DrawLatexNDC(0.7,0.7,lowlimS);
				// latex1.DrawLatexNDC(0.7,0.6,highlimS);
			// }
			// else if(energy[0]<lowlim)
			// {
				// latex1.SetTextSize(0.02);
				// latex1.SetTextAlign(22);
				// latex1.SetTextColor(kRed);
				// // RatioMax1 = sDouble(ratioMax1);
				// TString KBE= "K binding energy: " + sDouble(energy[0])+ "MeV";
				// TString lowlimS= "low limit: " + sDouble(lowlim)+ "MeV";
				// TString highlimS= "high limit: " + sDouble(elim)+ "MeV";
				// latex1.DrawLatexNDC(0.7,0.8,KBE);
				// latex1.DrawLatexNDC(0.7,0.7,lowlimS);
				// latex1.DrawLatexNDC(0.7,0.6,highlimS);
			// }
			// else
			// {
				// latex1.SetTextSize(0.02);
				// latex1.SetTextAlign(22);
				// latex1.SetTextColor(kRed);
				// // RatioMax1 = sDouble(ratioMax1);
				// TString KBE= "K binding energy: " + sDouble(energy[0])+ "MeV";
				// TString lowlimS= "low limit: " + sDouble(lowlim)+ "MeV";
				// TString highlimS= "high limit: " + sDouble(elim)+ "MeV";
				
				// latex1.DrawLatexNDC(0.7,0.7,lowlimS);
				// latex1.DrawLatexNDC(0.7,0.8,KBE);
				// latex1.DrawLatexNDC(0.7,0.6,highlimS);
			// }
			
			// TLegend* leg1 = new TLegend(0.7,0.1,0.9,0.3);
			// // leg1->SetTextAlign(12);
			// // leg1->SetFillColor(0);	
			// // leg1->SetFillStyle(0);
			// leg1->SetTextSize(0.04);
			
			
			// TString rname3 = "Low fit";
			// TString rname4 = "High fit";
			
			// // leg1->AddEntry(Ratio21,rname1);
			// // leg1->AddEntry(Ratio22,rname2);
			// leg1->AddEntry(lowFit,rname3);
			// leg1->AddEntry(highFit,rname4);
			// //leg1->DrawClone("Same");
			// leg1->Draw();
		
			// TString total="plots/fit/Histo_low_high/Ahisto_RD_" + s + "_" +s1_2 + ".gif";
            // // cout<<"zhuxin"<<endl;
			// mycanvas->Update();
			// mycanvas->Print(total);
			// delete mycanvas;

			// //************combine high fit and low fit relative difference to verify the conjunction(end)
                
            // }//end of last else
        // }//end of for N
        
        // data_file.close();
		
		// for(int i =0; i<=n2; i++)
		// {
			// LowFits<<setprecision(9)<<Z<<" "<<i<<" "<<PP0_2[i]<<" "<<PP1_2[i]<<" "<<PP2_2[i]<<" "<<PP3_2[i] <<" "<<PP4_2[i]
			// <<" "<<PP5_2[i]<<endl;
						
			// HighFits<<setprecision(9)<<Z<<" "<<i<<" "<<PP0[i]<<" "<<PP1[i]<<" "<<PP2[i]<<" "<<PP3[i] <<" "<<PP4[i]
			// <<" "<<PP5[i]<<endl;
			// printf("ppppp__index_%d %.9e %.9e\n", i, PP0[i], PP1[i]);
			
		// }
		
        
        
    // }//for over atomic number
    
	// LowFits.close();
    // HighFits.close();
    // LowHighLimits.close();
	
	
	// FILE*pFile = fopen("MaxDifferenceForTwoFitsOfSubshellsUsingNewParametersFor2017.dat","w");	
	
	// for(int i =0; i<infoVec.size();i++)
	// {
		// // if(i==0) cout<<"zhuxin"<<infoVec.size()<<" "<<infoVec[i].subshellIndex<<endl;
		// fprintf(pFile, "%d %d %.9e %.9e\n", infoVec[i].z, infoVec[i].subshellIndex, infoVec[i].ratio1Max,infoVec[i].ratio2Max);
		// // printf("%d %d %.9e %.9e\n", infoVec[i].z, infoVec[i].subshellIndex, infoVec[i].ratio1Max,infoVec[i].ratio2Max);
		// if(infoVec[i].KvsLowLimit) 
		// {
			// printf("K binding energy == low limit: %d %d\n", infoVec[i].z, infoVec[i].subshellIndex);
		
		// }
	// }
	// fclose(pFile);
	
	// FILE*pFile1 = fopen("AverageDifferenceForTwoFitsOfSubshellsUsingNewParametersFor2017.dat","w");	
	
	// for(int i =0; i<averageVec.size();i++)
	// {
		// // if(i==0) cout<<"zhuxin"<<infoVec.size()<<" "<<infoVec[i].subshellIndex<<endl;
		// fprintf(pFile1, "%d %d %.9e %.9e\n", averageVec[i].z, averageVec[i].subshellIndex, averageVec[i].average1,averageVec[i].average2);
	// }
	// fclose(pFile1);
// }

// for the first publication

void fitForSubshellCS2017()
{
	gSystem->Exec("mkdir -p plots/fit/Histo_high");
	gSystem->Exec("mkdir -p plots/fit/Histo_low");
	gSystem->Exec("mkdir -p plots/fit/Histo_low_high");
	
	
	// infoVec.reserve(2000);
	std::vector<struct Info> infoVec;
	std::vector<struct Average> averageVec;
    gROOT->Reset();
    gROOT->Reset();
    gStyle->SetOptStat(0);
    gStyle->SetOptFit();
    Int_t Z;
    
    Double_t elim = 0.055;// high fit limit
    Double_t lowlim = 0.005;// low fit limit
    Double_t deltaLim = elim - lowlim;
    //Double_t elim = 0.0000052;// 0.0006->600eV - 0.006MeV->6KeV  It was Threshold value: 0.6 MeV --> 600KeV
    //Double_t lowlim = 0;
    
    
    Double_t eK = 1.0;
    
    Double_t x, y;
    
    //Fit of high energies
	// 29 subshells at most
    Double_t PP0[29];
    Double_t PP1[29];
    Double_t PP2[29];
    Double_t PP3[29];
    Double_t PP4[29];
    Double_t PP5[29];
    Double_t PP[6]; // 6 parameters
    
    //Fit of low energies
    Double_t PP0_2[29];
    Double_t PP1_2[29];
    Double_t PP2_2[29];
    Double_t PP3_2[29];
    Double_t PP4_2[29];
    Double_t PP5_2[29];
    Double_t PP_2[6];
    
  
	
    
    char line[200];
    char line_2[200];
    
    Double_t xxx[2000];
    Double_t yyy[2000];
    Double_t xx1[2000];
    Double_t yy1[2000];
    Double_t erx[2000];
    Double_t ery[2000];
    Double_t energy[2000];
    Double_t xx0[2000];
    Double_t yy0[2000];
    
    Double_t xxx_2[2000];
    Double_t yyy_2[2000];
    Double_t xx1_2[2000];
    Double_t yy1_2[2000];
    Double_t erx_2[2000];
    Double_t ery_2[2000];
    Double_t energy_2[2000];
    Double_t xx0_2[2000];
    Double_t yy0_2[2000];
    
    Double_t alldatax[2000];
    Double_t alldatay[2000];
    
    for(int i=0 ; i<2000; i++)
    {
        xxx[i]=0;
        yyy[i]=0;
        xx1[i]=0;
        yy1[i]=0;
        erx[i]=0;
        ery[i]=0;
        energy[i]=0;
        xx0[i]=0;
        yy0[i]=0;
        alldatax[i]=0;
        alldatay[i]=0;
        
        xxx_2[i]=0;
        yyy_2[i]=0;
        xx1_2[i]=0;
        yy1_2[i]=0;
        erx_2[i]=0;
        ery_2[i]=0;
        energy_2[i]=0;
        xx0_2[i]=0;
        yy0_2[i]=0;
        
    }
    
    
    Double_t delta=100000;
    Double_t delta_2=100000;
    
    
	
	
    string LowFitsFile ="lowFittingParams.dat";
    ofstream LowFits(LowFitsFile.c_str(), ios::out);
	LowFits.setf(ios::scientific);
	
	
	string HighFitsFile ="highFittingParams.dat";
    ofstream HighFits(HighFitsFile.c_str(), ios::out);	
	HighFits.setf(ios::scientific);
	
	string low_high_limits ="low_high_limits.dat";
    ofstream LowHighLimits(low_high_limits.c_str(), ios::out);	
	LowHighLimits.setf(ios::scientific);
	
	
    for(Z=1; Z<=100; Z++)
    {
		// if((Z != 1) && (Z != 13) && (Z != 82)) continue;
		
		// for(int i=0 ; i<27; i++)
		// {
			// PP0[i]=0;
			// PP1[i]=0;
			// PP2[i]=0;
			// PP3[i]=0;
			// PP4[i]=0;
			// PP5[i]=0;
			
			// PP0_2[i]=0;
			// PP1_2[i]=0;
			// PP2_2[i]=0;
			// PP3_2[i]=0;
			// PP4_2[i]=0;
			// PP5_2[i]=0;
			
		// }
	
		struct Info info(Z);
		struct Average average(Z);
        elim = 0.07;// 0.0006->600eV - 0.006MeV->6KeV  It was Threshold value: 0.6 MeV --> 600KeV
        lowlim = 0.006;//delta=
        deltaLim = elim - lowlim;
        
        // cout<<"yes"<<endl;
        Int_t n0=0; // number of low-energy points for one shell
        Int_t n1=0; // number of points for fit for one shell
        Int_t n2=-1; // number of shells
        Int_t n3=0; // number of shells
        Int_t n5=0; // number of shells with low-energy data
        Int_t n6=0; // first x-section file
        Int_t N=0;
        
        
        Int_t n0_2=0; // number of high-energy points for one shell
        Int_t n1_2=0; // number of points available for low energy fit for one shell
        Int_t n2_2=-1; // number of shells
        Int_t n3_2=0; // number of shells
        Int_t n5_2=0; // number of shells with low-energy data
        Int_t n6_2=0; // first x-section file
        //Int_t N_2=0;
        
        cout <<  "========= Element " << Z << " =========" <<endl;
        string s = sInt(Z);
        
        TString datafile="./epics2017/phot_preliminary/pe-ss-cs-" + s + ".dat";
        
        
        // string ffdata = (string)datafile;        
        //IN
        // ifstream  data_file(ffdata.c_str(), ios::in );
        ifstream  data_file(datafile, ios::in );
        if(data_file.fail()){
            cout << "Error opening data file"  << endl;
        }else {
            cout << "data file " << datafile << " is opened" << endl;
        }
        if(!data_file) break;
        
        
        for (N = 0; N < 99999; N++)
        {
            data_file >> x >> y;
			
            if(x < -1.5) 
			{ 
                break; 
                
            } 
			else if(0.0 == y) 
			{
                
                n0 = -1;    // number of low-energy points for one shell
                n1 = -1;    // number of points for fit for one shell
                n3 = 0;     // number of shells
                
                n0_2 = -1;
                n1_2 = -1;
                n3_2 = 0;   // number of shells
                
                delta = 100000;
                delta_2 = 100000;
                
                n2++;  //0  only at the first iteration // index of subshell
                n2_2++;//0
                
                energy[n2] = x;   //binding energies for subshell n2
                energy_2[n2] = x;
                // if(n2 ==1) break;  
                // if(n2 ==2 ) break;
				info.subshellIndex = n2;
				average.subshellIndex = n2;
                if(0 == n2)
                {
            
                    printf("__Binding energy of K-shell:%.9e\n", energy[0]);
                    printf("__1___lowlim: %.9e, elim: %.9e, deltaLim: %.9e\n", lowlim, elim, deltaLim);
                    eK = energy[0];
                    
                    if(Z<13) //* 1-12
                    {
                        lowlim=0.005;
                        elim=0.07  ;
                    }else if (Z==14)
                    {
                        lowlim=0.009;
                        elim=0.15;
                    
                    }
                    else if(Z>12 && Z<30) //* 13 15-29
                    {
                        lowlim=0.006;
                        elim=0.07;
                    }
                    
                    else if(Z>29 && Z<60) //* 30-59
                    {
                        lowlim=eK;
                        elim=eK+deltaLim;

                    }
                    else if(Z>59 && Z<68) //*60-67  
                    {
						
                        deltaLim=0.055-0.005;
                        elim=eK+5*deltaLim;
                    }
                    else if((Z>71 && Z<75) || (Z>81&&Z<88) || (Z>88&& Z<93)){ //*72-74 82-87 89-92
                    //else if((Z>71 && Z<75) || (Z>81&&Z<88) || (Z>88)){
                        
                        lowlim=eK+0.1;
                        elim=lowlim+5*deltaLim;
                    
                    }
                    else if (Z==96)
                    {
                        elim=eK+5*deltaLim;
                    }
                    else if(Z>67){ // *68-71  75-81 88 93-100
                
                        // lowlim=eK+0.1;
                        elim=eK+5*deltaLim;

                    }
					
                    printf("__2___lowlim: %.9e, elim: %.9e, deltaLim: %.9e\n", lowlim, elim, deltaLim);
                    
                }
            }
            
            //***********************
            //
            //DATA FOR LOW ENERGY FIT
            //
            //**********************
            else if(x > lowlim && x < elim ) 
			{
				
                n0++;
                xx0[n0] = x;
                yy0[n0] = y;				
                
                n1_2++;// * n1_2 is used to count the number of points for low fit
                if(0 == n1_2) {
					
					// n1_2 =0, means it is the first point in low fit range, 
					//there is a possibility that the first point equals to binding energy of K shell, 
					// that means now the low fit limit equals to K binding energy
					// in this case of fit, this point will be repeated twice
					// besides, the first point of high fit will be added in low fit too
					if(x==energy[0])
					{
						XLIM_2=x;
						YLIM_2=x*y;
						
						xxx_2[0] = XLIM_2;
						yyy_2[0] = YLIM_2;
						erx_2[0] = 0.0;
						ery_2[0] = YLIM_2*0.01;
					}
					else
					{
						// otherwise, the last point in NON fit range will be added to low fit range
						XLIM_2=xx0_2[n0_2];
						YLIM_2=xx0_2[n0_2]*yy0_2[n0_2];
						
						xxx_2[0] = XLIM_2;
						yyy_2[0] = YLIM_2;
						erx_2[0] = 0.0;
						ery_2[0] = yyy_2[0]*0.01;
					}
    
					
                    n1_2++;
                    n0_2++;
                    xx0_2[n0_2] = x;
                    yy0_2[n0_2] = y;
                }
                xxx_2[n1_2] = x;				
                yyy_2[n1_2] = y*x;
				
				if(n1_2==1) printf("The first two points of low fit: (%.9e,%.9e), (%.9e,%.9e)\n", xxx_2[0], yyy_2[0], xxx_2[n1_2], yyy_2[n1_2]);
				
                erx_2[n1_2] = 0.0;
                ery_2[n1_2] = y*x*0.05;
                if(abs(x - 1) < delta_2) {
                    n3_2 = n1_2;
                    delta_2 = abs(x - 1);
                }
                
            }
            
            //LOW ENERGY DATA - NO FIT
            else if (x > 0.0 && x <=lowlim )
            {
				// cout<<"******"<<x<<" "<<y<<endl;
                //Important for the other two fits
                n0++;
                xx0[n0] = x;
                yy0[n0] = y;
                ///
                n0_2++;
                xx0_2[n0_2] = x;  //* n0_2 counts the points below low limit, last point will be counted to low fit as well if necessary
                yy0_2[n0_2] = y;
                
            }
            //DATA FOR HIGH ENERGY FIT
            else if(x > 0.0) 
			{
                n1++;// *n1 used to count the number of points for high fit
				// similarly as low fit
				// last point of low fit will be added to high fit
                if(0 == n1) 
				{
					// this is the point before the current (x, y)
                    XLIM = xx0[n0];
                    YLIM = xx0[n0]*yy0[n0];
                    xxx[0] = XLIM;
                    yyy[0] = YLIM;
					
                    erx[0] = 0.0;
                    ery[0] = YLIM*0.001;
                    n1++;
                    n0++;
                    xx0[n0] = x; //* n0 is used to count the total number of points below elim, with one point in
                    yy0[n0] = y;// * the high fit range
                }
                xxx[n1] = x;
                yyy[n1] = y*x;
				if(n1==1) printf("The first two points of high fit: (%.9e,%.9e), (%.9e,%.9e)\n", xxx[0], yyy[0], xxx[n1], yyy[n1]);
				
                erx[n1] = 0.0;
                ery[n1] = y*x*0.05;
                if(abs(x - 1) < delta) {
                    n3 = n1;
                    delta = abs(x - 1);
                }
            
                // negative number - end of a shell
            }
            else //is the end of one shell (ROW -1 -1 reached)
            {
				string s1 = sInt(n2);
				if(IsEqual(xxx_2[0],energy[0] , eps, releps))
				{
					info.KvsLowLimit = true;
					
					
					// continue;
				}
                ery[n3] = 0.2*ery[n3];
                Double_t nn = n1+1; // number of high fit
				
                n0++;
				
                printf("*******High Energy fit:********\n");
                printf("For subshell_%d,\n",n2);
                printf("Number of points for fit: %f,\n",nn);
                printf("High fit starts (%.9e, %.9e), ends (%.9e, %.9e)\n",xxx[0], yyy[0], xxx[n1], yyy[n1]);
                
                
                //First fit: high energies
                
                //***********************************
                TCanvas *c = new TCanvas("c","GraphFit",xxx[0], xxx[n1], 700, 800);
                TF1 *fitFcn = new TF1("fitFcn",fitf,xxx[0],xxx[n1],5);
                
               
                
                P0 = yyy[n1];
                Double_t p2 = (yyy[0] - P0)*xxx[0]*xxx[0];
                Double_t p1 = (yyy[n3]- P0)*xxx[n3];
                Double_t p3 = 0.0;
                Double_t p4 = 0.0;
                //new parameter added to improve the fit
                Double_t p5 = 0.0;
                fitFcn->SetParameters(p1,p2,p3,p4,p5);
				c->Divide(1,2);
                c->cd(1);
                // c->SetLogy(1);
                // c->SetLogx(1);
				gPad->SetLogx();
				gPad->SetLogy();
                // c->Update();
                
                TGraphErrors *gr = new TGraphErrors(nn, xxx, yyy, erx, ery);
                gr->Fit(fitFcn);
                
                gr->SetTitle("FF Fit");
                gr->Draw("ALP*");
                
                PP[0] =  P0;
                PP[1] =  fitFcn->GetParameter(0);
                PP[2] =  fitFcn->GetParameter(1);
                PP[3] =  fitFcn->GetParameter(2);
                PP[4] =  fitFcn->GetParameter(3);
                PP[5] =  fitFcn->GetParameter(4);
                
                //the first point of high-energy fit must be used as last point for the low-energy interval
                // double parForSecFit[6];
                // parForSecFit[0]=PP[0];
                // parForSecFit[1]=PP[1];
                // parForSecFit[2]=PP[2];
                // parForSecFit[3]=PP[3];
                // parForSecFit[4]=PP[4];
                // parForSecFit[5]=PP[5];
                
                PP0[n2]=PP[0];
                PP1[n2]=PP[1];
                PP2[n2]=PP[2];
                PP3[n2]=PP[3];
                PP4[n2]=PP[4];
                PP5[n2]=PP[5];
				for(int i = 0; i<=n2; ++i)
				{
					// cout<<"*********high fit for subshell: "<<i<<
					// "        P0="<<PP0[i]<<" P1="<<PP1[i]<<" P2="<<PP2[i]<<" P3="<<PP3[i]
					// <<" P4="<<PP4[i]<<" P5="<<PP5[i]<<endl;
					// printf("*********high fit for subshell %d: %.9e %.9e %.9e %.9e %.9e %.9e\n", i, PP0[i], PP1[i], PP2[i], PP3[i], PP4[i], PP5[i] );
					
				}
				
				// for(int i = 0; i<=n2; ++i)
				// {
					// if(i)
					// {
						// PP[0] +=PP0[i];
						// PP[1] +=PP1[i];
						// PP[2] +=PP2[i];
						// PP[3] +=PP3[i];
						// PP[4] +=PP4[i];
						// PP[5] +=PP5[i];
					// }
					// else{
						// PP[0] =PP0[0];
						// PP[1] =PP1[0];
						// PP[2] =PP2[0];
						// PP[3] =PP3[0];
						// PP[4] =PP4[0];
						// PP[5] =PP5[0];
					// }
					
					// // cout<<"*********sum of high fit for subshell: "<<i<<
					// // " P0="<<PP[0]<<" P1="<<PP[1]<<" P2="<<PP[2]<<" P3="<<PP[3]
					// // <<" P4="<<PP[4]<<" P5="<<PP[5]<<endl;
				// }
				
				c->cd(2);
				gPad->SetLogx();
				std::vector <Double_t> x;
				std::vector <Double_t> y_tab;
				std::vector <Double_t> y;
				std::vector <Double_t> ratio;
				double r2Max  =  0.0;
				double sum2  =  0.0;
				for(Int_t i =0; i<nn; ++i)
				{
					Double_t X = xxx[i];
					x.push_back(X);
					Double_t X2 = X*X;
					Double_t X3 = X2*X;
					Double_t X4 = X2*X2;
					Double_t X5 = X4*X;
					//*Y = (a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)
					Double_t fitValue = PP0[n2] + PP1[n2]/X + PP2[n2]/X2 + PP3[n2]/X3 + PP4[n2]/X4 + PP5[n2]/X5;
					Double_t ratioValue = (fitValue- yyy[i])/yyy[i]*100;
					y_tab.push_back(yyy[i]);
					y.push_back(fitValue);
					ratio.push_back(ratioValue);
					// printf("%d %.9e %.9e\n",i, xxx[i], ratioValue);
					if(abs(ratioValue)>abs(r2Max))
					{
						r2Max = ratioValue;
					}	
					sum2+=abs(ratioValue);
					// if(n2==0)
					// {
						// printf("%d %.9e %.9e %.9e %.9e %.9e\n",i, xxx[i], yyy[i], fitValue, yyy[i]/xxx[i], fitValue/xxx[i]);

					// }
				}
				info.ratio2Max = r2Max;
				average.average2 = sum2/nn;
				
				
				TGraph *graph1 = new TGraph(x.size(),x.data(),ratio.data());
				graph1->SetMarkerStyle(24);  //red point
				graph1->SetMarkerSize(1.0);
				graph1->SetMarkerColor(kRed);
				graph1->SetLineColor(kRed);	
				graph1->Draw("AP");
				graph1->GetXaxis()->SetTitle("Energy (MeV)");
				graph1->GetYaxis()->SetTitle("Relative difference (%)");
                
				TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
				// leg->SetTextAlign(12);
				leg->SetFillColor(0);	
				leg->SetTextSize(0.04);
				
				TString name1 = "High fit: - "+ sInt(x.size());	 + " points";
				
				leg->AddEntry(graph1,name1);
				//leg->DrawClone("Same");
				leg->Draw();
				
                c->Update();
                
                string lowLimString = sDouble(lowlim);
                string eLimString = sDouble(elim);
                TString name="plots/fit/Histo_high/Ahisto_" + s + "_" +s1 + ".gif";
                
                c->Print(name);
                delete c;
                
                std::cout<<"****** >>>>> "<<name<<std::endl;
                //HIGH ENERGY FIT: END
                
                
                
                //***********************************
                
                //Second fit: low energies
                
                //***********************************
                
                ery_2[n3_2] = 0.2*ery_2[n3_2];
                Double_t nn_2 = n1_2+1; //number of points for low fit
				erx_2[n1_2] = 0.0;
                ery_2[n1_2] = ery_2[n1_2]/5;
                n0_2++;
				n1_2++;
				nn_2++;
                
              
				xxx_2[n1_2]=xxx[1];  // add the second point of high fit in low fit
				yyy_2[n1_2]=yyy[1];
				erx_2[n1_2] = 0.0;
				// ery_2[n1_2] = yyy[1]*xxx[1]*0.005; // it is not correct
				ery_2[n1_2] = yyy[1]*0.005;  // it is correct
				
                printf("*******Low Energy fit:********\n");
                printf("For subshell_%d,\n",n2_2);
                printf("Number of points for fit: %f,\n",nn_2);
                printf("Low fit starts (%.9e, %.9e), ends (%.9e, %.9e)\n",xxx_2[0], yyy_2[0], xxx_2[n1_2], yyy_2[n1_2]);
                
                
                P0_2=yyy[0];
                int midBin=n3_2/2;
                TCanvas *c_2 = new TCanvas("c_2","GraphFit_2",xxx_2[0], xxx_2[n1_2], 700, 800);
                TF1 *fitFcn_2;
                //TF1 *fitFcn_outer;
                //TGraphErrors *gr_2;
                // c_2->SetLogy(1);
                // c_2->SetLogx(1);
                // c_2->Update();
				c_2->Divide(1,2);
				c_2->cd(1);
				// gPad->SetLogx();
				gPad->SetLogy();
                
                
				//*Y = (a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)
				Double_t p2_2 = (YLIM_2 - P0_2)*XLIM_2*XLIM_2;
				Double_t p1_2;
				if(Z<68)
				{
					p1_2 = (yyy_2[0]- P0_2)*xxx_2[0];
				}
				else
				{
				  
				   p1_2 = (yyy_2[midBin]- P0_2)*xxx_2[midBin];
				}
				Double_t p3_2 = 0.0;
				Double_t p4_2 = 0.0;
				Double_t p5_2 = 0.0;
			
				fitFcn_2 = new TF1("fitFcn_2",fitf_2,xxx_2[0],xxx_2[n1_2],5);
				fitFcn_2->SetParameters(p1_2,p2_2,p3_2,p4_2, p5_2);
			
                TGraphErrors *gr_2 = new TGraphErrors(nn_2, xxx_2, yyy_2, erx_2, ery_2);
                gr_2->Fit(fitFcn_2);
                gr_2->SetTitle("FF_2 Fit");
                gr_2->Draw("ALP*");
                
              
               
                
                
               
                
                if(n2==0)
                {
                    lowlim=xxx_2[0];
                    elim=xxx[0];  //* pass the high limit for the rest of subshells
					
					LowHighLimits<<setprecision(9)<<Z<<" "<<xxx_2[0]<<" "<<xxx[0]<<endl;
								
                }
				
                
                PP_2[0] =  P0_2;
                PP_2[1] =  fitFcn_2->GetParameter(0);
                PP_2[2] =  fitFcn_2->GetParameter(1);
                PP_2[3] =  fitFcn_2->GetParameter(2);
                PP_2[4] =  fitFcn_2->GetParameter(3);
                PP_2[5] =  fitFcn_2->GetParameter(4);
                
                //* better to use n2_2, though n2_2 =n2 always
                PP0_2[n2]=PP_2[0];
                PP1_2[n2]=PP_2[1];
                PP2_2[n2]=PP_2[2];
                PP3_2[n2]=PP_2[3];
                PP4_2[n2]=PP_2[4];
                PP5_2[n2]=PP_2[5];
				
				
				
				for(int i = 0; i<=n2_2; ++i)
				{
					// cout<<"*********low fit for subshell: "<<i<<
					// "        P0="<<PP0_2[i]<<" P1="<<PP1_2[i]<<" P2="<<PP2_2[i]<<" P3="<<PP3_2[i]
					// <<" P4="<<PP4_2[i]<<" P5="<<PP5_2[i]<<endl;
					
					
					
				}
				
				for(int i = 0; i<=n2; ++i)
				{
					if(i)
					{
						PP_2[0] +=PP0_2[i];
						PP_2[1] +=PP1_2[i];
						PP_2[2] +=PP2_2[i];
						PP_2[3] +=PP3_2[i];
						PP_2[4] +=PP4_2[i];
						PP_2[5] +=PP5_2[i];
					}
					else{
						PP_2[0] =PP0_2[i];
						PP_2[1] =PP1_2[i];
						PP_2[2] =PP2_2[i];
						PP_2[3] =PP3_2[i];
						PP_2[4] =PP4_2[i];
						PP_2[5] =PP5_2[i];
					}
					
					// cout<<"*********sum of low fit for subshell: "<<i<<
					// " P0="<<PP_2[0]<<" P1="<<PP_2[1]<<" P2="<<PP_2[2]<<" P3="<<PP_2[3]
					// <<" P4="<<PP_2[4]<<" P5="<<PP_2[5]<<endl;
				}
				
                
				c_2->cd(2);
				// gPad->SetLogx();
				std::vector <Double_t> x_2;
				std::vector <Double_t> y_2;				
				std::vector <Double_t> y_2_tab;				
				std::vector <Double_t> ratio_2;
				double r1Max = 0.0;
				double sum1 = 0.0;
				//* because nn_2 did not add 1, therefore use i<=nn_2, rather thant i<nn_2
				// for(Int_t i =0; i<nn_2; ++i)
				for(Int_t i =0; i<nn_2; ++i)
				{
					Double_t X = xxx_2[i];
					x_2.push_back(X);
					Double_t X2 = X*X;
					Double_t X3 = X2*X;
					Double_t X4 = X2*X2;
					Double_t X5 = X4*X;
					//*Y = (a0 + a1/x + a2/x2 + a3/x3 + a4/x4 + a5/x5)
					Double_t fitValue = PP0_2[n2_2] + PP1_2[n2_2]/X + PP2_2[n2_2]/X2 + PP3_2[n2_2]/X3 + PP4_2[n2_2]/X4 + PP5_2[n2_2]/X5;
					Double_t ratioValue = (fitValue- yyy_2[i])/yyy_2[i]*100;
					
					
					y_2_tab.push_back(yyy_2[i]);
					y_2.push_back(fitValue);
					ratio_2.push_back(ratioValue);
					// printf("Absolut %d %.9e %.9e\n",i, xxx_2[i], abs(ratioValue));
					if(abs(ratioValue)>abs(r1Max))
					{
						r1Max = ratioValue;
					}	
					sum1+=abs(ratioValue);
					if(n2_2==3)
					{
						// printf("%d %.9e %.9e %.9e %.9e %.9e\n",i, xxx[i], yyy[i], fitValue, yyy[i]/xxx[i], fitValue/xxx[i]);

					}
					// if(n2_2 ==1&&Z ==3) printf("%d %d %.9e\n", Z, n2_2, abs(ratioValue));
				}
				info.ratio1Max = r1Max;
				average.average1 = sum1/(nn_2);
				
				infoVec.push_back(info);
				averageVec.push_back(average);
				// int size = averageVec.size();
				// printf("==================%d %d %.9e %.9e\n", averageVec[size-1].z, averageVec[size-1].subshellIndex, 
				// averageVec[size-1].average1, averageVec[size-1].average2);
				
				TGraph *graph2 = new TGraph(x_2.size(),x_2.data(),ratio_2.data());
				graph2->SetMarkerStyle(24);  //red point
				graph2->SetMarkerSize(1.0);
				graph2->SetMarkerColor(kRed);
				graph2->SetLineColor(kRed);	
				graph2->Draw("AP");
				graph2->GetXaxis()->SetTitle("Energy (MeV)");
				graph2->GetYaxis()->SetTitle("Relative difference (%)");
                
				TLegend* leg2 = new TLegend(0.65,0.7,0.9,0.9);
				// leg->SetTextAlign(12);
				// leg2->SetFillColor(0);	
				leg2->SetFillStyle(0);	
				leg2->SetTextSize(0.04);
				
				TString name2 = "Low fit: - "+ sInt(x_2.size());	 + " points";
				
				leg2->AddEntry(graph2,name2);
				//leg->DrawClone("Same");
				leg2->Draw();
				
				
                c_2->Update();
                string s1_2 = sInt(n2_2);
                //TString name="Histo_oldData/Ahisto_" + s + "_" +s1 + ".gif";
                TString name_2="plots/fit/Histo_low/Ahisto_" + s + "_" +s1_2 + ".gif";
                
                c_2->Print(name_2);
                delete c_2;
                
                // very low-energy part: THIS IS NOT NECESSARY, WILL BE DONE BY THE LOW ENERGY FITTING
                
                if(n0_2 > 0) {
                    n5_2++;
                    // fout_lowE << xx0_2[0] << " " << xx0_2[n0_2-1] << " " << n0_2 << " " << n2_2
                    //<< endl;
                    //cout << n0 << endl;
                    //for(int i=0; i<n0_2; i++) {
                    //    fout_lowE << xx0_2[i] << " " << xx0_2[i]*xx0_2[i]*xx0_2[i]*yy0_2[i] << endl;
                    //}
                }
				
				//************combine high fit and low fit relative difference to verify the conjunction(begin)
			
			
			// cross section begin
			
			TCanvas* mycanvas = new TCanvas((s+"_"+s1_2).c_str(),(s+"_" + s1_2).c_str(),800, 50, 400, 400);
			mycanvas->SetGrid();
			
			mycanvas->cd();
			gPad->SetLogx();
			gPad->SetLogy();
			gPad->SetBottomMargin(0.15);
			gPad->SetLeftMargin(0.15);
			
			
			TGraph *lowFitdata = new TGraph(x_2.size(),x_2.data(),y_2.data());
			TGraph *highFitdata = new TGraph(x.size(),x.data(),y.data());
			
			TGraph *lowFitdata_tab = new TGraph(x_2.size(),x_2.data(),y_2_tab.data());
			TGraph *highFitdata_tab = new TGraph(x.size(),x.data(),y_tab.data());
			
		
			auto mg = new TMultiGraph();
		
			//set graph parameters of EPICS2014
			lowFitdata->SetMarkerStyle(21);  // red point
			lowFitdata->SetMarkerSize(0.8);
			lowFitdata->SetMarkerColor(kBlue);
			//graph1->SetLineWidth(2);
			lowFitdata->SetLineColor(kBlue);	
			mg->Add(lowFitdata);
			
			highFitdata->SetMarkerStyle(24);  //blue circle
			highFitdata->SetMarkerSize(1);
			highFitdata->SetMarkerColor(kRed);
			highFitdata->SetLineColor(kRed);
			mg->Add(highFitdata);
			
			// tabulated data
			
			lowFitdata_tab->SetMarkerStyle(20);  // red point
			lowFitdata_tab->SetMarkerSize(0.3);
			lowFitdata_tab->SetMarkerColor(kGreen);
			//graph1->SetLineWidth(2);
			lowFitdata_tab->SetLineColor(kGreen);	
			mg->Add(lowFitdata_tab);
			
			highFitdata_tab->SetMarkerStyle(20);  //blue circle
			highFitdata_tab->SetMarkerSize(0.3);
			highFitdata_tab->SetMarkerColor(kGreen);
			highFitdata_tab->SetLineColor(kGreen);
			mg->Add(highFitdata_tab);
			
			
			mg->Draw("AP");
			TString title = "Fitted subshell CS compared to tabulated values for element " + s + "_" +s1_2;
			TLatex latex;
			latex.SetTextSize(0.03);
			latex.SetTextFont(42);
			latex.SetTextAlign(12);
			latex.DrawLatexNDC(0.12,0.95,title);
			
			mg->GetXaxis()->SetTitle("Energy (MeV)");
			mg->GetYaxis()->SetTitle("Cross section (barn)");
			
			// mg->GetXaxis()->SetTitleSize(0.06);
			// mg->GetYaxis()->SetTitleSize(0.06);
			
			mg->GetXaxis()->SetTitleOffset(1.5);
			mg->GetYaxis()->SetTitleOffset(2);
			
			// mg->GetXaxis()->SetLabelSize(0.05);
			// mg->GetYaxis()->SetLabelSize(0.05);
			
			
			mg->GetXaxis()->CenterTitle();
			mg->GetYaxis()->CenterTitle();
			
			
			TGaxis *axisX = new TGaxis(TMath::Power(10, gPad->GetUxmin()),TMath::Power(10, gPad->GetUymax()),
			TMath::Power(10, gPad->GetUxmax()), TMath::Power(10, gPad->GetUymax()),
			mg->GetXaxis()->GetXmin(),
			mg->GetXaxis()->GetXmax(), 510,"GU-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX->Draw("");
				
			
			TGaxis *axisY = new TGaxis(TMath::Power(10, gPad->GetUxmax()), TMath::Power(10, gPad->GetUymin()) ,
				TMath::Power(10, gPad->GetUxmax()), TMath::Power(10, gPad->GetUymax()) ,
			mg->GetYaxis()->GetXmin(),
			mg->GetYaxis()->GetXmax(), 510,"GU+");
			
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisY->Draw();
			
		
			TString total="plots/fit/Histo_low_high/Ahisto_" + s + "_" +s1_2 + ".gif";
            // cout<<"zhuxin"<<endl;
			mycanvas->Update();
			mycanvas->Print(total);
			delete mycanvas;
			
			// cross section end
			
			// ratio begin
			TCanvas* mycanvas1 = new TCanvas((s+"_"+s1_2+"_RD").c_str(),(s+"_" + s1_2).c_str(),800, 50, 400, 400);
			mycanvas1->SetGrid();
			
			gPad->SetLogx();
			gPad->SetBottomMargin(0.15);
			gPad->SetLeftMargin(0.15);
		
			
			TGraph *lowFit = new TGraph(x_2.size(),x_2.data(),ratio_2.data());
			TGraph *highFit = new TGraph(x.size(),x.data(),ratio.data());
			
		
		
			auto mg1 = new TMultiGraph();
		
			//set graph parameters of EPICS2014
			lowFit->SetMarkerStyle(21);  // red point
			lowFit->SetMarkerSize(0.8);
			lowFit->SetMarkerColor(kBlue);
			//graph1->SetLineWidth(2);
			lowFit->SetLineColor(kBlue);	
			mg1->Add(lowFit);
			
			highFit->SetMarkerStyle(24);  //blue circle
			highFit->SetMarkerSize(1);
			highFit->SetMarkerColor(kRed);
			highFit->SetLineColor(kRed);
			mg1->Add(highFit);
			
			mg1->Draw("AP");
			mg1->GetXaxis()->SetTitle("Energy (MeV)");
			mg1->GetYaxis()->SetTitle("Relative difference (%)");
			
			// mg->GetXaxis()->SetTitleSize(0.06);
			// mg->GetYaxis()->SetTitleSize(0.06);
			
			mg1->GetXaxis()->SetTitleOffset(1.5);
			mg1->GetYaxis()->SetTitleOffset(2);
			
			// mg->GetXaxis()->SetLabelSize(0.05);
			// mg->GetYaxis()->SetLabelSize(0.05);
			
			
			mg1->GetXaxis()->CenterTitle();
			mg1->GetYaxis()->CenterTitle();
			
			TGaxis *axisX1 = new TGaxis(TMath::Power(10, gPad->GetUxmin()),gPad->GetUymax(),
			TMath::Power(10, gPad->GetUxmax()),gPad->GetUymax(),
			mg1->GetXaxis()->GetXmin(),
			mg1->GetXaxis()->GetXmax(), 510,"GU-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX1->Draw("");
			
			
				
			
			TGaxis *axisY1 = new TGaxis(TMath::Power(10, gPad->GetUxmax()), gPad->GetUymin(),
				TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
			mg1->GetYaxis()->GetXmin(),
			mg1->GetYaxis()->GetXmax(), 510,"U+");
			
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisY1->Draw();
			
			
			
		
			TString total1="plots/fit/Histo_low_high/Ahisto_RD_" + s + "_" +s1_2 + ".gif";
            // cout<<"zhuxin"<<endl;
			// mycanvas1->Update();
			mycanvas1->Print(total1);
			delete mycanvas1;
			// ratio end
			
			//************combine high fit and low fit relative difference to verify the conjunction(end)
                
            }//end of last else
        }//end of for N
        
        data_file.close();
		
		for(int i =0; i<=n2; i++)
		{
			LowFits<<setprecision(9)<<Z<<" "<<i<<" "<<PP0_2[i]<<" "<<PP1_2[i]<<" "<<PP2_2[i]<<" "<<PP3_2[i] <<" "<<PP4_2[i]
			<<" "<<PP5_2[i]<<endl;
						
			HighFits<<setprecision(9)<<Z<<" "<<i<<" "<<PP0[i]<<" "<<PP1[i]<<" "<<PP2[i]<<" "<<PP3[i] <<" "<<PP4[i]
			<<" "<<PP5[i]<<endl;
			printf("ppppp__index_%d %.9e %.9e\n", i, PP0[i], PP1[i]);
			
		}
		
        
        
    }//for over atomic number
    
	LowFits.close();
    HighFits.close();
    LowHighLimits.close();
	
	
	FILE*pFile = fopen("MaxDifferenceForTwoFitsOfSubshellsUsingNewParametersFor2017.dat","w");	
	
	for(int i =0; i<infoVec.size();i++)
	{
		// if(i==0) cout<<"zhuxin"<<infoVec.size()<<" "<<infoVec[i].subshellIndex<<endl;
		fprintf(pFile, "%d %d %.9e %.9e\n", infoVec[i].z, infoVec[i].subshellIndex, infoVec[i].ratio1Max,infoVec[i].ratio2Max);
		// printf("%d %d %.9e %.9e\n", infoVec[i].z, infoVec[i].subshellIndex, infoVec[i].ratio1Max,infoVec[i].ratio2Max);
		if(infoVec[i].KvsLowLimit) 
		{
			printf("K binding energy == low limit: %d %d\n", infoVec[i].z, infoVec[i].subshellIndex);
		
		}
	}
	fclose(pFile);
	
	FILE*pFile1 = fopen("AverageDifferenceForTwoFitsOfSubshellsUsingNewParametersFor2017.dat","w");	
	
	for(int i =0; i<averageVec.size();i++)
	{
		// if(i==0) cout<<"zhuxin"<<infoVec.size()<<" "<<infoVec[i].subshellIndex<<endl;
		fprintf(pFile1, "%d %d %.9e %.9e\n", averageVec[i].z, averageVec[i].subshellIndex, averageVec[i].average1,averageVec[i].average2);
	}
	fclose(pFile1);
}

