string sInt(Int_t number)
{
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
}
bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
	
	
 
	
	
	return false;
}
double eps=1e-15;//absolut difference
double releps=1e-10;//relative difference
  
std::vector<double> fParamHigh[101];
std::vector<double> fParamLow[101];
double fLowLimits[101];
double fHighLimits[101];


std::vector<double> designator_1[101];
std::vector<double> be_1[101];
  
  
void ReadData()
{
	
	//**************************************************************
	// read high energy fitting parameters
	std::ostringstream ost1;
	ost1 << "highFittingParams_final.dat";
	std::ifstream fin1(ost1.str().c_str());
	for(int i = 0; i<1612; ++i) 
	{
		int z;		
		int subshell_index;
		double P[6];
		fin1 >> z >> subshell_index;
		fParamHigh[z].push_back(subshell_index);
		for(int i = 0; i<6; i++)
		{
			 fin1 >> P[i];
			 fParamHigh[z].push_back(P[i]);
			 
		}	
	 
	}
	
		
   fin1.close();
   printf("High fit parameters: %.9e\n", fParamHigh[100][188]);
	//**************************************************************
	// read low energy fitting parameters 
	std::ostringstream ost1_low;
	ost1_low << "lowFittingParams_final.dat";
	std::ifstream fin1_low(ost1_low.str().c_str());
	for(int i = 0; i<1612; ++i) 
	{
		int z;		
		int subshell_index;
		double P[6];
		fin1_low >> z >> subshell_index;
		fParamLow[z].push_back(subshell_index);
		for(int i = 0; i<6; i++)
		{
			 fin1_low >> P[i];
			 fParamLow[z].push_back(P[i]);
			 
		}		
	 
	}
	fin1_low.close();
	printf("Low fit parameters: %.9e\n", fParamLow[100][188]);
	
	//**************************************************************		  

	
	FILE*fp3 = fopen("./epics2017/phot_preliminary/bindingEnergy/binding.dat","r");	
	
	
	double d1; 
	double e1; 
    Int_t Ncols = 0;
	Int_t count = 0;
	
    for(int i=1; i<=100; ++i)  // there are 100 elements
	{
		
		
		while(1)
		{


			count++;
			Ncols = fscanf(fp3,"%lf %lf",&d1,&e1);
			
			
			// if(d1 ==d2 && d1 == -1)
			if(d1 == -1)
			{
				// cout<<"---ending---"<<i<<" "<<count<<endl;

				break;
			}
			
			else{
				
			 
				designator_1[i].push_back(d1);
				be_1[i].push_back(e1);
			 
			
			}
			 
			
		}	
		
	}
	fclose(fp3);
	
	//**************************************************************
	// read low and high limits 
	std::ostringstream ost2;
	ost2 << "low_high_limits_final.dat";
	std::ifstream fin2(ost2.str().c_str());
	for(int i = 0; i<1612; ++i) 
	{
		int z;
		double lowLimit;
		double highLimit;
		fin2 >> z >> lowLimit>>highLimit;
		fLowLimits[z] = lowLimit;
		fHighLimits[z] = highLimit;
	}
	
	printf("Low limit = %.9e High limit = %.9e\n",fLowLimits[100],fHighLimits[100]);
	fin2.close();
}
void generate_outputs()
{
	ReadData();
	gSystem->Exec("mkdir -p epics2017/phot");
	double e; //energy 
	double cs; // cross section
    Int_t ncols = 0;
	for (int z =1; z<=100;z++)
	{
		
		char filenameFormat[64] = "epics2017/phot_preliminary/pe-cs-%d.dat"; 
		char filename[64];
		sprintf (filename,filenameFormat,z); //appends z to the file name
		cout <<"Read: "<<filename << endl; 

		FILE * fp1 = fopen(filename,"r");
		int num1 = 0;
		int loop=0;
		char str[64] = "";
		// cout<<"yes"<<endl;
		while(1)  
		{	
			loop++;
			// if loop = 1 we read the first header line
			fgets (str, 64, fp1);
			// cout<<str<<endl;
			if(loop ==2)
			{
				// now loop = 2, we read the second header line, namely the number of points
				num1 = stoi(str);  
				// cout<<"number of total pair production points:"<<num1<<endl;
				break;
			}		
			
		}
		std::vector<double>  x_0;
		std::vector<double>  y_0; // tabulated total cs	
		// to remove repeated points
		std::vector<double>  x_1;// energy higher than binding energy K, but below low energy limit
		std::vector<double>  y_1; 
		std::vector<double>  x_2;// energy below K shell
		std::vector<double>  y_2; 
		
		
		
		for(Int_t i = 0;i<num1;++i)
		{
			// read one line energy cross section
			ncols = fscanf(fp1,"%lf %lf",&e,&cs); 
			x_0.push_back(e);  
			y_0.push_back(cs);
			
			if(e<=be_1[z][0]) 
			{
				x_2.push_back(e);
				y_2.push_back(cs);
				if(IsEqual(e, be_1[z][0], eps, releps))
				{
					x_1.push_back(e);  
					y_1.push_back(cs);
				}
				continue;
			}		
			
			
			x_1.push_back(e);  
			y_1.push_back(cs);
			
			if(e>fLowLimits[z])
			{	
				break;
			}
			// printf("--%d %.9e %.9e\n", i+1, e, cs);
		}
		fclose(fp1);
		
		//(1)*************for pe-cs-z.dat***begin
		char filenameFormat1[64] = "epics2017/phot/pe-cs-%d.dat"; 
		char filename1[64];
		sprintf (filename1,filenameFormat1,z); //appends z to the file name		
		FILE * fp2 = fopen(filename1,"w");
		cout <<"--------------Write total CS above K shell binding energy: "<<filename1<< endl;
		
		char headers [100]; //a temporary variable			
		string input = "";
		double startEnergy, endEnergy; 
		loop = x_1.size();
		for(Int_t i = 0;i<loop;++i)
		{
		
					
			char energy_csE3 [80] = ""; 
			sprintf(energy_csE3,"%.9e %.9e\n",x_1[i],x_1[i]*x_1[i]*x_1[i]*y_1[i]); 
					
			//sprintf(energy_csE3,"%.9E %.9E\n",e,cs);
							
			// concatenate energy-cross section one by one
			input = input + energy_csE3;  
			// counts the number of data points (lines)
			
		}
		
		//save the two header lines in the variable headers
		sprintf(headers,"%.9e %.9e %d\n%d\n", x_1[0], x_1[loop-1], loop,loop ); 
		input = headers + input; //concatenate two header lines with data table
		// write the complete data for one element in fp2 file
		fprintf(fp2,"%s",input.c_str());
		fclose(fp2);
		
		cout<<"--------------ending---------"<<endl<<endl;
		
		
	//(1)*************for pe-cs-z.dat***end
	
	//(2)*************for pe-le-cs-z.dat***begin
	char filenameFormat2[64] = "epics2017/phot/pe-le-cs-%d.dat"; 
	char filename2[64];
	sprintf (filename2,filenameFormat2,z); //appends z to the file name	
	FILE * fp3 = fopen(filename2,"w");	
	cout <<"--------------Write total CS below K shell binding energy: "<<filename2<< endl;
	
	input = "";
	char headers1[100]; //a temporary variable	
	loop = x_2.size();
	for(Int_t i = 0;i<loop;++i)
	{
		char energy_csE3 [80] = ""; 
		sprintf(energy_csE3,"%.9e %.9e\n",x_2[i],x_2[i]*x_2[i]*x_2[i]*y_2[i]); 
				
		//sprintf(energy_csE3,"%.9E %.9E\n",e,cs);
						
		// concatenate energy-cross section one by one
		input = input + energy_csE3;  
		// counts the number of data points (lines)
		
	}
		
	//save the two header lines in the variable headers
	sprintf(headers1,"%.9e %.9e %d\n%d\n", x_2[0], x_2[loop-1], loop,loop ); 
	input = headers1 + input; //concatenate two header lines with data table
	// write the complete data for one element in fp3 file
	fprintf(fp3,"%s",input.c_str());	
	fclose(fp3);
	cout<<"--------------ending---------"<<endl<<endl;		
	//(2)*************for pe-le-cs-z.dat***end
		
	//(3)*************for pe-high-z.dat***begin
		char filenameFormat3[64] = "epics2017/phot/pe-high-%d.dat"; 
		char filename3[64];
		sprintf (filename3,filenameFormat3,z); //appends z to the file name
		
		cout <<"--------------Write high parameters: "<<filename3<< endl;
		
		FILE * fp4 = fopen(filename3,"w");
		char headers2[200] = "";
		loop = be_1[z].size();
		sprintf(headers2,"%d %d %.9e\n", loop, loop, fHighLimits[z]); 
		input = "";
		input = headers2 + input;
		double PP0 = 0;
		double PP1 = 0;
		double PP2 = 0;
		double PP3 = 0;
		double PP4 = 0;
		double PP5 = 0;
		
		for(int i=0; i<loop; i++)
		{
			char linedata[200] = "";
			int idx = 7*i+1;
		
			PP0 += fParamHigh[z][0+idx];
			PP1 += fParamHigh[z][1+idx];
			PP2 += fParamHigh[z][2+idx];
			PP3 += fParamHigh[z][3+idx];
			PP4 += fParamHigh[z][4+idx];
			PP5 += fParamHigh[z][5+idx];
				
			// printf("%.9e\n", fParamHigh[z][6]);
			sprintf(linedata,"%.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
			be_1[z][i], PP0, PP1, PP2, PP3, PP4, PP5);			
			input = input + linedata;
		}
		fprintf(fp4,"%s",input.c_str());	
		fclose(fp4);
		cout<<"--------------ending---------"<<endl<<endl;
		
		
	//(3)*************for pe-high-z.dat***end
	
	//(4)*************for pe-low-z.dat***begin
	
		char filenameFormat4[64] = "epics2017/phot/pe-low-%d.dat"; 
		char filename4[64];
		sprintf (filename4,filenameFormat4,z); //appends z to the file name
		FILE * fp5 = fopen(filename4,"w");
		cout <<"--------------Write low parameters: "<<filename4<< endl;
		
		char headers4[200] = "";
		sprintf(headers4,"%d %d %.9e\n", loop, loop, fLowLimits[z]); 
		input = "";
		input = headers4 + input;
		PP0 = 0;
		PP1 = 0;
		PP2 = 0;
		PP3 = 0;
		PP4 = 0;
		PP5 = 0;
		for(int i=0; i<loop; i++)
		{
			char linedata[200] = "";
			int idx = 7*i+1;
		
			PP0 += fParamLow[z][0+idx];
			PP1 += fParamLow[z][1+idx];
			PP2 += fParamLow[z][2+idx];
			PP3 += fParamLow[z][3+idx];
			PP4 += fParamLow[z][4+idx];
			PP5 += fParamLow[z][5+idx];
				
			// printf("%.9e\n", fParamLow[z][6]);
			sprintf(linedata,"%.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
			be_1[z][i], PP0, PP1, PP2, PP3, PP4, PP5);			
			input = input + linedata;
		}
		fprintf(fp5,"%s",input.c_str());	
		fclose(fp5);
		cout<<"--------------ending---------"<<endl<<endl;
	//(4)*************for pe-low-z.dat***end
	
	
	//(5)*************for pe-ss-cs.dat***begin
		string s = sInt(z);
		TString datafile="./epics2017/phot_preliminary/pe-ss-cs-" + s + ".dat";
        ifstream  data_file(datafile, ios::in );		
		cout <<"Read: "<<datafile<< endl;
		double x, y;
		int subshell_index = -1;
		int nb = -1; // number of counted points
		vector<double> x_3[loop]; 
		vector<double> y_3[loop]; 
		bool fAdd = false; //add the first point higher than low limit
		for (int N = 0; N < 99999; N++)
        {
			
            data_file >> x >> y;
			
            if(x < -1.5) 
			{ 
                break; 
                
            } 
			else if(0.0 == y) 
			{
				fAdd = false;
				subshell_index++;
				nb = 0;
			}
			else if(x == -1)
			{
				
			}			
			else
			{
				
				if(x>fLowLimits[z] )
				// if(x>fHighLimits[z] )   // In the implementation of Marilena, she keeps points below high fit limit; 
				{						  // in the new implementation, points below low limit are choosen
					if(fAdd)
					{
						continue;
					}
					else 
					{
						x_3[subshell_index].push_back(x);
						y_3[subshell_index].push_back(x*x*x*y);
						nb++;
						fAdd = true;
					}
				}
				else
				{
					x_3[subshell_index].push_back(x);
					y_3[subshell_index].push_back(x*x*x*y);
					nb++;
				}
			
			}
		}
		
		data_file.close();
		
		
		
		TString outF ="./epics2017/phot/pe-ss-cs-" + s + ".dat";
		ofstream outFile(outF, ios::out);
		outFile.setf(ios::scientific);
		cout <<"--------------Write subshell CS: "<<outF<< endl;
		for(int i = 0; i<loop; i++)
		{
			int size = x_3[i].size();
			// printf("%.9e\n",x_3[i][size-1]);
			outFile<<setprecision(9)<<x_3[i][0]<<" "<<x_3[i][size-1]<<" "<<size<<" "<<i<<endl;
			for(int j =0; j<size; j++)
			{
				outFile<<setprecision(9)<<x_3[i][j]<<" "<<y_3[i][j]<<endl;
			}
			
		}
		outFile.close();
		cout<<"--------------ending---------"<<endl<<endl;
	//*************for pe-ss-cs-z.dat***end
	
	
	
	}
	
}	
		
	           
            	
    
   