bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
		
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
	
	
	return false;
}
double eps=1e-20;//absolut difference
double releps=1e-10;//relative difference
 
void generate_ss_cs_2014()
{
	gSystem->Exec("mkdir -p epics2014/phot_preliminary");
	 
	FILE * fp = fopen("EPDL2014.ALL","r"); 
	
	FILE * fp2;	
	// FILE * fp3 = fopen("NumberOfSubshellFor2014","w"); 
    double e; //energy 
	double cs; // cross section
    Int_t ncols = 0;
   
    char str[64]= "";   
	Int_t z = 1;
	Int_t record = 0;
	Int_t count = 0;
    
    while (1)
    {
		
        //read one line of 63 characters		
        if(fgets (str, 64, fp)!= NULL ) 
        {
// ********************************************************************
// Read compton effect cross section data for 100 elements
// ********************************************************************
			// for(int i=0;i<strlen (str);++i)
			// {
				// printf("--%d\n", str[i]);
			// }
			//starting from this line :
			// "72  0  0  0.0         0.0         0.0         0.0         0.0", 
			// which is typical for compton effect for one element
			
			char flag[14] = "";
			strncpy(flag, str, 13);
			if(strcmp(flag, "73  0 91  0.0")) continue;
			
			
			for(int i=1; i<62;++i) // index of subshell
			{
				char si[5] = ""; 
				char shell [64] = "73  0 91  0.0         ";
				sprintf(si,"%d",i);
				strcat(shell,si);
				if(i<10)
				{
					strcat(shell,".          0.0         0.0         0.0\r\n");
					
				}
				else 
				{
					strcat(shell,".         0.0         0.0         0.0\r\n");
					
				}
				// getchar();
				// if (!strcmp(str,
                        // "73  0 91  0.0         1.          0.0         0.0         0.0\r\n"))
				if (!strcmp(str,shell))		
				{
					if(record>=i)
					{
						fprintf (fp2, "%i %i\n",-2,0);
						fprintf (fp2, "%i %i\n",-2,-2);
						fclose(fp2);
						count=0;
						z++;
					}
					count++; //number of subshells for an element
					
					if(count==1) 
					{
						// cout<< "************************ Z=" << z << endl; // atomic number
						char filenameFormat[64] = "epics2014/phot_preliminary/pe-ss-cs-%d.dat"; 
						char filename[64];
						sprintf (filename,filenameFormat,z); //appends z to the file name						
						// cout << filename << endl;
						fp2= fopen(filename,"w");
					}					
					
						
					// variable input will contain all energy-cross section table for one element				
					string input = ""; 
					// to calculate the total number of eneryg-cross section points
					Int_t loop = 0; 
					// to keep the minimum and maximum energy of the points for one element
					double startEnergy, endEnergy;
					double tempEnergy = 0;
					double tempCS = 0;
					while (1)
					{
						char energy_cs [80] = "";  // a temporary variable
						char data[73] = "";					
						// read the data line (energy - coss section) line by line
						// each line is terminated by a \n which interrupts the reading
						fgets (data, 73, fp); 
						//each table line ends by  "           1"   with 1 written at column 72
						if (strcmp(data,
							"                                                                       1")==0) 
						{
							// we finish reading the energy - cross section data for the element
							// so now we create the two header lines and put them 
							// at the beginning of the table
							// cout<<"ending---------shell designator = "<<i<<", "<<"shell index = "<< (count-1)<<", Nb = "<<loop<<endl;
							endEnergy = e;
							char header [100]; //a temporary variable
							
							//save the two header lines in the variable headers
							// sprintf(header,"%.9e %.9e %d %d\n", startEnergy, endEnergy, loop, (count-1)); 
							// sprintf(header,"%.9e %.9e %d %d %d\n", startEnergy, endEnergy, loop, (count-1), i); 
							sprintf(header,"%.9e %.9e \n", startEnergy, 0.); 
							input = header + input; //concatenate one header line with data table
							// write the complete data for one element in fp2 file
							fprintf(fp2,"%s",input.c_str());
							//****add -1 -1 
							fprintf (fp2, "%i %i\n",-1,-1);	
							if(z ==100 && (count == 27))
							{
								fprintf (fp2, "%i %i\n",-2,0);
								fprintf (fp2, "%i %i\n",-2,-2);
								fclose(fp2);
								
							}
							
							break;
						}
						// variable data contains one line energy-cross section					
						ncols =  sscanf(data,"%lf %lf",&e,&cs); // read energy and cross section respectively from the 
																// valable data keeping the same significant numbers
						// MeV3*barn
						// cs = e*e*e*cs;
						
						if(loop)
						{
							 
							// if(IsEqual(e,tempEnergy, eps, releps) /* && IsEqual(cs,tempCS, eps, releps) */ )
							// {
								
								// if(IsEqual(cs,tempCS, eps, releps)) 
								// {
									// printf("Z = %d subshell_%d (%.9e %.9e) Completely repeated\n", z, i, e,cs);
								// }
									
								// continue;
							// }
							
							if(IsEqual(cs,tempCS, eps, releps))
							{
								
								printf("Z = %d subshell_%d (%.9e %.9e) %.9e\n", z, i, e,cs,tempCS);
								
							}
							
						}
						tempEnergy = e;
						tempCS = cs;
						// save energy-cross section point in the variable energy_cs
						sprintf(energy_cs,"%.9e %.9e\n",e,cs); 
						
						
						//sprintf(energy_cs,"%.9E %.9E\n",e,cs);
						if (loop == 0) 
						{
							startEnergy = e;
						}				
						// concatenate energy-cross section one by one
						input = input + energy_cs;  
						// counts the number of data points (lines)
						loop++; 
						
					}
					record = i;
					
					break;
									   
				} 
				
			
					
			}
            
		}
		else break;
		
	}
}
