// **************************************************************************
// ROOT macro: plot_total.c
// Plots the figures of total pair production cross section data. 
// There is one figure (now in png format, it can be modified) per element.
// -	cross section data of EPICS2014 (Z: 1-100) 
// -	cross section data of Livermore (Z: 1-99)   
// -	comparison of cross section data between Livermore and EPICS2014 (Z: 1-99) 
// The generated figures are saved in the corresponding directory:
// -	plots/total/comparison
// -	plots/total/epics2017
// -	plots/total/livermore

// Authors: Zhuxin LI @CENBG,France
// 2019.12.09
// **************************************************************************
TString sInt(Int_t number)
  {
    stringstream ss;
    ss << number;
	TString ts = ss.str();
    return ts;
  }
TString sDouble(Double_t number)
  {
    stringstream ss;
	ss << number;
    TString ts = ss.str();
    return ts;
  }
 struct RatioInfo
 {
	 int z;
	 double ratioPositive;
	 double ratioNegative;
	 double designatorPositive;
	 double designatorNegative;	 
	 
 };
int RatioMax_x[101];
double RatioMax[101];
double RatioAverage[101];
  
 
		
std::vector<RatioInfo> ratioMaxV;


int Results1=0;
int Results2=0;
int Results3=0;
int Results4=0;

int results=0;
int results1=0;
std::vector<int> resultsV;
int results2=0;
int results3=0;
int results4=0;
int results5=0;
std::vector<int> results5V;

string subShellDesignators[62] = {"K(1s1/2)",    "L(2)",     "L1(2s1/2)",  "L23(2p)",   "L2(2p1/2)", 
								  "L3(2p3/2)",   "M(3)",      "M1(3s1/2)", "M23(3p)",   "M2(3p1/2)",
								  "M3(3p3/2)",   "M45(3d)",   "M4(3d3/2)", "M5(3d5/2)", "N(4)",
								  "N1(4s1/2)",   "N23(4p)",   "N2(4p1/2)", "N3(4p3/2)", "N45(4d)", 
								  "N4(4d3/2)",   "N5(4d5/2)", "N67(4f)",   "N6(4f5/2)", "N7(4f7/2)",
								  "O(5)",        "O1(5s1/2)", "O23(5p)",   "O2(5p1/2)", "O3(5p3/2)",
								  "O45(5d)",     "O4(5d3/2)", "O5(5d5/2)", "O67(5f)",   "O6(5f5/2)",
								  "O7(5f7/2)",   "O89(5g)",   "O8(5g7/2)", "O9(5g9/2)", "P(6)",
								  "P1(6s1/2)",   "P23(6p)",   "P2(6p1/2)", "P3(6p3/2)", "P45(6d)",
								  "P4(6d3/2)",   "P5(6d5/2)", "P67(6f)",   "P6(6f5/2)", "P7(6f7/2)", 
								  "P89(6g)",     "P8(6g7/2)", "P9(6g9/2)", "P1011(6h)", "P10(6h9/2)",
								  "P11(6h11/2)", "Q(7)",      "Q1(7s1/2)", "Q23(7p)",   "Q2(7p1/2)", 
								  "Q3(7p3/2)"};




// void plot(int z,int index, int designator, std::vector<double> subShEnergy1, std::vector<double> subShCS1, 
                          // std::vector<double> subShEnergy2, std::vector<double> subShCS2)
// void plot(Int_t z, std::vector<double>& x_1, std::vector<double>& y_1, std::vector<double>& x_2, std::vector<double>& y_2)
// {
	
	// gROOT->Reset();
		
	// TString S = sInt(z); 
	// TString title1;
	
	
	// // TString indexS = sInt(index);
	// title1 = "Binding energy for element Z = " + S;
	
	
	
	// int num1 = x_1.size();
	// int num2 = x_2.size();
	

		
		// TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",800, 50, 1200, 1000);
		
		// mycanvas->SetGrid();
		// mycanvas->Divide(1,2);
		
		
		
		// mycanvas->cd(1);
		// gPad->SetGrid();
		// // gPad->SetLogx();
		// gPad->SetLogy();
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetLeftMargin(0.01);
		// //gPad->SetLogy();
					
		// // TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// // TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// TGraph *graph1 = new TGraph(num1,x_1.data(),y_1.data());
		// TGraph *graph2 = new TGraph(num2,x_2.data(),y_2.data());
		
		// auto mg1 = new TMultiGraph();
		
		
		
		// //set graph parameters of EPICS2014
		// graph1->SetMarkerStyle(20);  // red point
		// graph1->SetMarkerSize(1);
		// graph1->SetMarkerColor(2);
		// //graph1->SetLineWidth(2);
		// graph1->SetLineColor(2);	
		// // graph1->Draw("PL");
		
		// mg1->Add(graph1);	
		
		// //set graph parameters of livermore
		// graph2->SetMarkerStyle(4);  //blue circle
		// graph2->SetMarkerSize(1.5);
		// graph2->SetMarkerColor(4);
		// graph2->SetLineColor(4);
		
		// // graph2->Draw("APL");
	    // mg1->Add(graph2);
		
		// mg1->Draw("AP");
		// mg1->SetTitle(title1);
	
		// mg1->GetXaxis()->SetTitle("Subshell designator ");
		// mg1->GetYaxis()->SetTitle("Binding Energy (MeV)");
		
		// mg1->GetXaxis()->SetTitleSize(0.05);
		// mg1->GetYaxis()->SetTitleSize(0.05);
		// mg1->GetXaxis()->SetTitleOffset(1.2);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		// mg1->GetXaxis()->CenterTitle();
		// mg1->GetYaxis()->CenterTitle();
	
	   
		// // mg1->GetXaxis()->SetLimits(0,x_1[num1-1]+2);
		
		// if(z ==1 || z ==2)
		// {
			// mg1->SetMaximum(1e-4); 
			// mg1->SetMinimum(1e-5);
		// }
		
		// // // graph2->SetMinimum(1e-35); 
		
		
		// TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// // leg->SetTextAlign(12);
		// leg->SetFillColor(0);	
		// leg->SetTextSize(0.04);
		
		
		// TString Tnum1 = sInt(num1);		
		// TString Tnum2 = sInt(num2);	
		
		
		// TString name1 = "EADL2017 - " + Tnum1 + " subshell(s)" ;
		
		
		// TString name2 = "EADL2014 - " + Tnum2 + " subshell(s)" ;		
		
		// leg->AddEntry(graph1,name1);
		// leg->AddEntry(graph2,name2);
		// leg->Draw();
		
		
		
		// std::vector<double> r(num1, 0.);
		
		// for(int i=0; i<x_1.size();++i)
		// {
			// if(y_1[i] == y_2[i])
			// {
				// // r[i] = 0;
				// continue;
			// }
			// else{
				// r[i] = (y_1[i] - y_2[i])/y_2[i]*100;
			// }
			
		// }
// // to calculate the maximal ratia and average ratio
		// double ratioMax = 0;
		// double sum = 0;
		
			
		
		
		// for(int i=0;i<x_1.size();i++)
		// {
			// printf("Z= %d %.9e\n", z, r[i]);
			// if(abs(r[i])>abs(ratioMax))
			// {
				// ratioMax = r[i];
			// }
			// sum+=abs(r[i]);
			
		// }
		// sum = sum/x_1.size();
		// RatioMax_x[z] = z;
		// RatioMax[z] = ratioMax;
        // RatioAverage[z] = sum;
		
		// mycanvas->cd(2);
		// gPad->SetGrid();
		// // gPad->SetLogx();
		
		// // gPad->SetTopMargin(0.12);
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetBottomMargin(0.15);
		// // gPad->SetGrid();
		// // gStyle->SetTitleW(0.9);  //per cent of the pad width
		// // gStyle->SetTitleH(0.9);
		// // gStyle->SetTitleFontSize(0.9);
		
		// // // pad21->SetLeftMargin(0.10); //10%
		
		
		// char nameRatio[100] = "Relative difference of EADL2017 compared to EADL2014(EADL97)";	
		
		// TGraph *ratio = new TGraph(num1,x_1.data(), r.data());
		// ratio->SetMarkerStyle(26);
		// ratio->SetMarkerSize(2);
		// ratio->SetMarkerColor(2);
		// ratio->SetLineColor(2);
		// auto mg2 = new TMultiGraph();
		// mg2->Add(ratio);
		
		// mg2->SetTitle(nameRatio);
		// mg2->Draw("AP");
		
		// mg2->GetXaxis()->SetTitle("Subshell designator ");
		// mg2->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg2->GetXaxis()->SetTitleSize(0.05);
		// mg2->GetYaxis()->SetTitleSize(0.05);
		// mg2->GetXaxis()->SetTitleOffset(1.2);
		
		// mg2->GetXaxis()->SetLabelSize(0.05);
		// mg2->GetYaxis()->SetLabelSize(0.05);
		
		
		// mg2->GetXaxis()->CenterTitle();
		// mg2->GetYaxis()->CenterTitle();
		// // mg2->GetXaxis()->SetLimits(0,x_1[num1-1]+2);
		
		
		// // ratio->Draw();
		
		// // ratio->GetXaxis()->SetTitle("Subshell designator");
		// // ratio->GetYaxis()->SetTitle("Relative Difference (%)");
		
		// // ratio->GetXaxis()->SetTitleSize(0.06);
		// // ratio->GetYaxis()->SetTitleSize(0.06);
		// // ratio->GetYaxis()->SetTitleOffset(0.9);
		
		// // ratio->GetXaxis()->SetLabelSize(0.05);
		// // ratio->GetYaxis()->SetLabelSize(0.05);
			
		// // ratio->GetXaxis()->CenterTitle();
		// // ratio->GetYaxis()->CenterTitle();
		
		// // ratio->SetMarkerStyle(8);
		// // ratio->SetMarkerSize(0.5);
		// // ratio->SetMarkerColor(2);
		// // ratio->SetLineColor(2);
		
		// mycanvas->Print("plots/bindingEnergy_comparison/2014VS2017/2014Vs2017-"+ S + ".png");
		// // mycanvas->Close();
		// delete mycanvas;
		// mycanvas = NULL;
// }

// version for the first publication
void plot_2(Int_t z, std::vector<double>& x_1, std::vector<double>& y_1, std::vector<double>& x_2, std::vector<double>& y_2)
{
	
	gROOT->Reset();
		
	TString S = sInt(z); 
	TString title1;
	
	
	// TString indexS = sInt(index);
	title1 = "Binding energies for element Z = " + S;
	
	
	
	int num1 = x_1.size();
	int num2 = x_2.size();
	

		
		TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",800, 50, 400, 400);
		
		mycanvas->SetGrid();
		
		gPad->SetGrid();
		// gPad->SetLogx();
		gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		TGraph *graph1 = new TGraph(num1,x_1.data(),y_1.data());
		TGraph *graph2 = new TGraph(num2,x_2.data(),y_2.data());
		
		auto mg1 = new TMultiGraph();
		
		
		
		//set graph parameters of EPICS2014
		graph1->SetMarkerStyle(24);  // red point
		graph1->SetMarkerSize(1.4);
		graph1->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph1->SetLineColor(kRed);	
		// graph1->Draw("PL");
		
		mg1->Add(graph1);	
		
		//set graph parameters of livermore
		graph2->SetMarkerStyle(21);  //blue circle
		graph2->SetMarkerSize(0.8);
		graph2->SetMarkerColor(kBlue);
		graph2->SetLineColor(kBlue);
		
		// graph2->Draw("APL");
	    mg1->Add(graph2);
		
		mg1->Draw("AP");
		mg1->SetTitle(title1);
	
		mg1->GetXaxis()->SetTitle("Subshell designator ");
		mg1->GetYaxis()->SetTitle("Binding Energy (MeV)");
		
		// mg1->GetXaxis()->SetTitleSize(0.05);
		// mg1->GetYaxis()->SetTitleSize(0.05);
		// mg1->GetXaxis()->SetTitleOffset(1.2);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		mg1->GetXaxis()->SetTitleOffset(1.5);
		mg1->GetYaxis()->SetTitleOffset(2);
	    
		// mg1->GetXaxis()->SetLimits(0,x_1[num1-1]+2);
		
		if(z ==1 || z ==2)
		{
			mg1->SetMaximum(1e-4); 
			mg1->SetMinimum(1e-5);
			mg1->GetXaxis()->SetLimits(0,10);
		
			
			TGaxis *axisX = new TGaxis(0,1e-4,
			10, 1e-4,
			mg1->GetXaxis()->GetXmin(),
			mg1->GetXaxis()->GetXmax(), 510,"U-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX->Draw("");
			
			
			  TGaxis *axisY = new TGaxis(10,1e-5 ,10,1e-4,1e-5,1e-4,50510,"GU+");
			  axisY->Draw();
			   
			
			cout<<TMath::Power(10, gPad->GetUymin())<<" "<<TMath::Power(10, gPad->GetUymax())<<endl;
			
			
		
		}
		
		if(z ==13)
		{
			
			mg1->GetXaxis()->SetLimits(0,12);
			
			TGaxis *axisX = new TGaxis(0,TMath::Power(10, gPad->GetUymax()) ,
			12, TMath::Power(10, gPad->GetUymax()),
			mg1->GetXaxis()->GetXmin(),
			mg1->GetXaxis()->GetXmax(), 510,"U-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX->Draw("");
			
			TGaxis *axisY = new TGaxis(12,TMath::Power(10, gPad->GetUymin()) ,
			12, TMath::Power(10, gPad->GetUymax()) ,
			mg1->GetYaxis()->GetXmin(),
			mg1->GetYaxis()->GetXmax(), 510,"GU+");
			
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisY->Draw();
			cout<<TMath::Power(10, gPad->GetUymin())<<" "<<TMath::Power(10, gPad->GetUymax())<<endl;
		}
		
		if(z ==82)
		{
			mg1->GetXaxis()->SetLimits(0,45);
			
			
			
			TGaxis *axisX = new TGaxis(0,TMath::Power(10, gPad->GetUymax()) ,
			45, TMath::Power(10, gPad->GetUymax()),
			mg1->GetXaxis()->GetXmin(),
			mg1->GetXaxis()->GetXmax(), 510,"U-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX->Draw("");
			
			TGaxis *axisY = new TGaxis(45,TMath::Power(10, gPad->GetUymin()) ,
			45, TMath::Power(10, gPad->GetUymax()) ,
			mg1->GetYaxis()->GetXmin(),
			mg1->GetYaxis()->GetXmax(), 510,"GU+");
			
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisY->Draw();
			
			
			
	
			
		}
		
		
			
			
		
		// // graph2->SetMinimum(1e-35); 
		
		
		TLegend* leg = new TLegend(.65,.7,.9,.9);
		leg->SetFillColor(0);	
		// leg->SetTextSize(0.06);
		
		TString Tnum1 = sInt(num1);		
		TString Tnum2 = sInt(num2);	
		
		// TString name1 = "EPICS2017 - "+ Tnum1 + " points";
		// TString name2 = "Livermore - "+ Tnum2 + " points";		
		
		TString name1 = "EPICS2017";
		TString name2 = "EPDL97";	
		
		leg->AddEntry(graph1,name1);
		leg->AddEntry(graph2,name2);
		//leg->DrawClone("Same");
		leg->Draw();
		
		
		mycanvas->Print("plots/bindingEnergy_comparison/2014VS2017/2014Vs2017_publication-"+ S + ".png");
		delete mycanvas;
		mycanvas = NULL;
		
		
	// 
	TCanvas* mycanvas1 = new TCanvas(S,"Ratio",800, 50, 400, 400);
		
		// mycanvas1->SetGrid();
		
		gPad->SetGrid();
		// gPad->SetLogx();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		
		std::vector<double> r(num1, 0.);
		
		for(int i=0; i<x_1.size();++i)
		{
			if(y_1[i] == y_2[i])
			{
				// r[i] = 0;
				continue;
			}
			else{
				r[i] = (y_1[i] - y_2[i])/y_2[i]*100;
			}
			
		}
// to calculate the maximal ratia and average ratio
		double ratioMax = 0;
		double sum = 0;
		
			
		
		
		for(int i=0;i<x_1.size();i++)
		{
			printf("Z= %d %.9e\n", z, r[i]);
			if(abs(r[i])>abs(ratioMax))
			{
				ratioMax = r[i];
			}
			sum+=abs(r[i]);
			
		}
		sum = sum/x_1.size();
		RatioMax_x[z] = z;
		RatioMax[z] = ratioMax;
        RatioAverage[z] = sum;
		
		gPad->SetGrid();
		// gPad->SetLogx();
		
		// gPad->SetTopMargin(0.12);
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetBottomMargin(0.15);
		// gPad->SetGrid();
		// gStyle->SetTitleW(0.9);  //per cent of the pad width
		// gStyle->SetTitleH(0.9);
		// gStyle->SetTitleFontSize(0.9);
		
		// // pad21->SetLeftMargin(0.10); //10%
		
		
		char nameRatio[100] = "Relative difference of EADL2017 compared to EADL2014(EADL97)";	
		
		TGraph *ratio = new TGraph(num1,x_1.data(), r.data());
		ratio->SetMarkerStyle(24);
		ratio->SetMarkerSize(1);
		ratio->SetMarkerColor(kRed);
		ratio->SetLineColor(kRed);
		auto mg2 = new TMultiGraph();
		mg2->Add(ratio);
		
		// mg2->SetTitle(nameRatio);
		mg2->Draw("AP");
		
		mg2->GetXaxis()->SetTitle("Subshell designator ");
		mg2->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg2->GetXaxis()->CenterTitle();
		mg2->GetYaxis()->CenterTitle();
		
		mg2->GetXaxis()->SetTitleOffset(1.5);
		mg2->GetYaxis()->SetTitleOffset(1.5);
		
	
		
		if(z ==1 || z ==2)
		{
			
			mg2->GetXaxis()->SetLimits(0,10);
		
			
			TGaxis *axisX1 = new TGaxis(0, gPad->GetUymax(),
			10,  gPad->GetUymax(),
			mg2->GetXaxis()->GetXmin(),
			mg2->GetXaxis()->GetXmax(), 510,"U-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX1->Draw("");
			
			
			
		  TGaxis *axisY1 = new TGaxis(10,gPad->GetUymin() ,10,gPad->GetUymax(),mg2->GetYaxis()->GetXmin(),mg2->GetYaxis()->GetXmax(),510,"U+");
		  axisY1->Draw();
			   
			
			
			
		
		}
		
		if(z ==13)
		{
			
			mg2->GetXaxis()->SetLimits(0,12);
			
			TGaxis *axisX1 = new TGaxis(0,TMath::Power(10, gPad->GetUymax()) ,
			12, TMath::Power(10, gPad->GetUymax()),
			mg2->GetXaxis()->GetXmin(),
			mg2->GetXaxis()->GetXmax(), 510,"U-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX1->Draw("");
			
			TGaxis *axisY1 = new TGaxis(12,gPad->GetUymin(),
			12, gPad->GetUymax(),
			mg2->GetYaxis()->GetXmin(),
			mg2->GetYaxis()->GetXmax(), 510,"U+");
			
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisY1->Draw();
			cout<<TMath::Power(10, gPad->GetUymin())<<" "<<TMath::Power(10, gPad->GetUymax())<<endl;
		}
		
		if(z ==82)
		{
			mg2->GetXaxis()->SetLimits(0,45);
			
			
			
			TGaxis *axisX1 = new TGaxis(0,gPad->GetUymax() ,
			45, gPad->GetUymax(),
			mg2->GetXaxis()->GetXmin(),
			mg2->GetXaxis()->GetXmax(), 510,"U-");
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisX1->Draw("");
			
			TGaxis *axisY1 = new TGaxis(45,TMath::Power(10, gPad->GetUymin()) ,
			45, gPad->GetUymax(),
			mg2->GetYaxis()->GetXmin(),
			mg2->GetYaxis()->GetXmax(), 510,"U+");
			
			// axis->SetLineColor(kRed);
			// axis->SetLabelColor(kRed);
			axisY1->Draw();
			
			
			
	
			
		}
		
		
		mycanvas1->Print("plots/bindingEnergy_comparison/2014VS2017/2014Vs2017_RD-"+ S + ".png");
		mycanvas1->Close();
		
}



void plot_bindingEnergy(){
	
	gROOT->Reset();
	
	gSystem->Exec("mkdir -p plots/bindingEnergy_comparison/2014VS2017");
	// return;
	double d1; 
	double e1; 
	double d2; 
	double e2; 
    Int_t ncols = 0;
	Int_t count = 0;
	
	
 	
 	FILE* fp1 = fopen("epics2017/phot_preliminary/bindingEnergy/binding.dat","r"); 
	// FILE* fp1 = fopen("test1.dat","r"); 
	// FILE* fp2 = fopen("test2.dat","r");
	FILE* fp2 = fopen("epics2014/phot_preliminary/bindingEnergy/binding.dat","r");
	// Int_t z = 1;
	
	std::vector<double> designator_1[101];
	std::vector<double> be_1[101];
	
	
	std::vector<double> designator_2[101];
	std::vector<double> be_2[101];
// this loop is to read binding data
// do not modify************************	
	for(int i=1; i<=100; ++i)  // there are 100 elements to read, i is the atomic number
	{
// do not modify************************		
		
		
		
		while(1)
		{
			count++;
			ncols =  fscanf(fp1,"%lf %lf",&d1,&e1);
			// cout<<"yes"<<endl;
			ncols =  fscanf(fp2,"%lf %lf",&d2,&e2);
			
			
			
			if(d1 ==d2 && d1 == -1)
			{
				// cout<<"---ending---"<<i<<" "<<count<<endl;
				// z++;
				break;
			}
			else{
				
				// printf("%d %.9e %.9e %.9e %.9e\n",count, d1, e1, d2, e2);
			 
				designator_1[i].push_back(d1);
				be_1[i].push_back(e1);
				designator_2[i].push_back(d2);
				be_2[i].push_back(e2);
			 
			
			}
			 
			
		}	
		
	}
	fclose(fp1);
	fclose(fp2);
// do not modify************************

// to plot
	for(int z =1;z<=100; z++)
	{
		// if((z != 1) && (z != 13) && (z != 82)&& (z != 55)) continue;
	
		// plot(z, designator_1[z], be_1[z], designator_2[z],be_2[z]);
		plot_2(z, designator_1[z], be_1[z], designator_2[z],be_2[z]);
	}
	
	FILE* out = fopen("ratioMax_ratioAverage_ForBindingEnergy_2014_2017.dat", "w");
	
	
  
    for(int i=1; i<101;i++)
	{
		fprintf(out,"%d %.9e %.9e \n", i, RatioMax[i], RatioAverage[i]);
		
		
	}
	
		
	fclose(out);
}