// **************************************************************************
// ROOT macro: plot_total.c
// Plots the figures of total pair production cross section data. 
// There is one figure (now in png format, it can be modified) per element.
// -	cross section data of EPICS2014 (Z: 1-100) 
// -	cross section data of Livermore (Z: 1-99)   
// -	comparison of cross section data between Livermore and EPICS2014 (Z: 1-99) 
// The generated figures are saved in the corresponding directory:
// -	plots/total/comparison
// -	plots/total/epics2017
// -	plots/total/livermore

// Authors: Zhuxin LI @CENBG,France
// 2019.12.09
// **************************************************************************
TString sInt(Int_t number)
  {
    stringstream ss;
    ss << number;
	TString ts = ss.str();
    return ts;
  }
TString sDouble(Double_t number)
  {
    stringstream ss;
	ss << number;
    TString ts = ss.str();
    return ts;
  }
 	double RatioMax3[100];
	double RatioMax3_x[100];
	double RatioMax4[100];
	double RatioMax4_x[100];
 
  std::vector<double> fCrossSection_x[101];
  std::vector<double> fCrossSection[101];
  
  std::vector<double> fCrossSectionLE_x[101];
  std::vector<double> fCrossSectionLE[101];
  
  std::vector<double> fParamHigh[101];
  std::vector<double> fParamLow[101];
  int fNShells[101];
  
  
  
  
 
std::map<int, double> ratioMax;
  
int results=0;
int results1=0;
std::vector<int> resultsV;
int results2=0;
int results3=0;
int results4=0;
int results5=0;
std::vector<int> results5V;
int results6=0;
std::vector<int> results6V;
int results7=0;
std::vector<int> results7V;
int results8=0;
int results9=0;
	
	
void plot2(std::vector<double>& Z, std::vector<double>& r_13, std::vector<double>& r_14, std::vector<double>& r_23, std::vector<double>& r_24)
{
	gROOT->Reset();
	
	TString title1;
	TString title2;
	title1 = "Maximal difference of low fit using existing parameters according to Z";
	title2 = "Maximal difference of high fit using existing parameters according to Z";
		
	TCanvas* mycanvas = new TCanvas("g","Conversion of electrons and gammas",800, 50, 1000, 800);
		
		mycanvas->SetGrid();
		mycanvas->Divide(1,2);
		//TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// pad1->Draw();
		// pad2->Draw();
		
		// pad2->cd();
		// TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// pad21->Draw();
		// pad22->Draw();
		
		
		mycanvas->cd(1);
		gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// int size = sizeof(RatioMax_x)/sizeof(double);
		// cout<<size<<endl;
		TGraph *graph13 = new TGraph(100,Z.data(),r_13.data());
		// TGraph *graph14 = new TGraph(100,Z.data(),r_14.data());
		
		TGraph *graph23 = new TGraph(100,Z.data(),r_23.data());
		// TGraph *graph24 = new TGraph(100,Z.data(),r_24.data());
		
		
		auto mg = new TMultiGraph();
		
		
		//region 3
		graph13->SetMarkerStyle(24);  // red point
		graph13->SetMarkerSize(1);
		graph13->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph13->SetLineColor(kRed);	
		mg->Add(graph13);
		
		
		
		
		
		graph23->SetMarkerStyle(24);  // red point
		graph23->SetMarkerSize(1);
		graph23->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph23->SetLineColor(kBlue);	
		mg->Add(graph23);
		
		
		
		
		// // //set graph parameters of livermore
		
		
		mg->Draw("APL");
				
		mg->SetTitle(title1);		
		mg->GetXaxis()->SetTitle("Atomic number Z");
		mg->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg->GetXaxis()->SetTitleSize(0.06);
		mg->GetYaxis()->SetTitleSize(0.06);
		
		mg->GetXaxis()->SetLabelSize(0.05);
		mg->GetYaxis()->SetLabelSize(0.05);
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		mg->GetXaxis()->SetLimits(0, 101);
		
		TLegend* leg1 = new TLegend(0.7,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
		TString rname13 = "EPDL2017";
		TString rname14 = "EPDL2017";
		
		TString rname23 = "EPDL2014";
		TString rname24 = "EPDL2014";
		
		leg1->AddEntry(graph13,rname13);
		// leg1->AddEntry(graph14,rname14);
		
		leg1->AddEntry(graph23,rname23);
		// leg1->AddEntry(graph24,rname24);
		
		//leg1->DrawClone("Same");
		leg1->Draw();
		
		
		
	//******************	
		
		mycanvas->cd(2);
		gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// int size = sizeof(RatioMax_x)/sizeof(double);
		// cout<<size<<endl;
		// TGraph *graph13 = new TGraph(100,Z.data(),r_13.data());
		TGraph *graph14 = new TGraph(100,Z.data(),r_14.data());
		
		// TGraph *graph23 = new TGraph(100,Z.data(),r_23.data());
		TGraph *graph24 = new TGraph(100,Z.data(),r_24.data());
		
		
		auto mg1 = new TMultiGraph();
		
		
		
		
		//region 4
		graph14->SetMarkerStyle(24);  // red point
		graph14->SetMarkerSize(1);
		graph14->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph14->SetLineColor(kRed);	
		mg1->Add(graph14);
		
		
		
		
		//region 4
		graph24->SetMarkerStyle(24);  // red point
		graph24->SetMarkerSize(1);
		graph24->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph24->SetLineColor(kBlue);	
		mg1->Add(graph24);
		
		
		// // //set graph parameters of livermore
		
		
		mg1->Draw("APL");
				
		mg1->SetTitle(title2);		
		mg1->GetXaxis()->SetTitle("Atomic number Z");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg1->GetXaxis()->SetTitleSize(0.06);
		mg1->GetYaxis()->SetTitleSize(0.06);
		
		mg1->GetXaxis()->SetLabelSize(0.05);
		mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		mg1->GetXaxis()->SetLimits(0, 101);
		TLegend* leg2 = new TLegend(0.7,0.7,0.9,0.9);
		// leg2->SetTextAlign(12);
		// leg2->SetFillColor(0);
		leg2->SetFillStyle(0);		
		leg2->SetTextSize(0.04);
		
		
		
		// leg2->AddEntry(graph13,rname13);
		leg2->AddEntry(graph14,rname14);
		
		// leg2->AddEntry(graph23,rname23);
		leg2->AddEntry(graph24,rname24);
		
		//leg2->DrawClone("Same");
		leg2->Draw();
		
		
		// mg->GetXaxis()->SetLimits(1e-6,1e5);
		mycanvas->Print("plots/ratioMax2014VS2017.png");
		// mycanvas->Close();
		
	
		
}



void plot3(std::vector<double>& Z, std::vector<double>& r_13, std::vector<double>& r_14, 
std::vector<double>& r_23, std::vector<double>& r_24,
std::vector<double>& r_33, std::vector<double>& r_34)
{
	gROOT->Reset();
	
	TString title1;
	TString title2;
	title1 = "Maximal difference of low fit for total cross section according to Z";
	title2 = "Maximal difference of high fit for total cross section according to Z";
		
	TCanvas* mycanvas = new TCanvas("g","Conversion of electrons and gammas",800, 50, 1000, 800);
		
		mycanvas->SetGrid();
		mycanvas->Divide(1,2);
		//TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// pad1->Draw();
		// pad2->Draw();
		
		// pad2->cd();
		// TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// pad21->Draw();
		// pad22->Draw();
		
		
		mycanvas->cd(1);
		gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// int size = sizeof(RatioMax_x)/sizeof(double);
		// cout<<size<<endl;
		TGraph *graph13 = new TGraph(100,Z.data(),r_13.data());
		// TGraph *graph14 = new TGraph(100,Z.data(),r_14.data());
		
		TGraph *graph23 = new TGraph(100,Z.data(),r_23.data());
		TGraph *graph33 = new TGraph(100,Z.data(),r_33.data());
		// TGraph *graph24 = new TGraph(100,Z.data(),r_24.data());
		
		
		auto mg = new TMultiGraph();
		
		
		//region 3
		graph13->SetMarkerStyle(24);  // red point
		graph13->SetMarkerSize(1);
		graph13->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph13->SetLineColor(kBlue);	
		mg->Add(graph13);
		
		
		
		graph23->SetMarkerStyle(22);  // red point
		graph23->SetMarkerSize(1.2);
		graph23->SetMarkerColor(kTeal+4);
		//graph1->SetLineWidth(2);
		graph23->SetLineColor(kTeal+4);	
		mg->Add(graph23);
		
		graph33->SetMarkerStyle(5);  // red point
		graph33->SetMarkerSize(1.3);
		graph33->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph33->SetLineColor(kRed);	
		mg->Add(graph33);
		
		
		
		// // //set graph parameters of livermore
		
		
		mg->Draw("AP");
				
		mg->SetTitle(title1);		
		mg->GetXaxis()->SetTitle("Atomic number Z");
		mg->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg->GetXaxis()->SetTitleSize(0.06);
		mg->GetYaxis()->SetTitleSize(0.06);
		
		mg->GetXaxis()->SetLabelSize(0.05);
		mg->GetYaxis()->SetLabelSize(0.05);
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		mg->GetXaxis()->SetLimits(0, 101);
		
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		TLegend* leg1 = new TLegend(0.55,0.15,0.9,0.3);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
		TString rname13 = "EPDL2014 using existing fitting parameters";
		
		TString rname23 = "EPDL2017 using existing fitting parameters";
		TString rname33 = "EPDL2017 using new fitting parameters";
		
		leg1->AddEntry(graph13,rname13);
		
		leg1->AddEntry(graph23,rname23);
		leg1->AddEntry(graph33,rname33);
		
		//leg1->DrawClone("Same");
		leg1->Draw();
		
		
		
	//******************	
		
		mycanvas->cd(2);
		gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// int size = sizeof(RatioMax_x)/sizeof(double);
		// cout<<size<<endl;
		// TGraph *graph13 = new TGraph(100,Z.data(),r_13.data());
		TGraph *graph14 = new TGraph(100,Z.data(),r_14.data());
		
		// TGraph *graph23 = new TGraph(100,Z.data(),r_23.data());
		TGraph *graph24 = new TGraph(100,Z.data(),r_24.data());
		TGraph *graph34 = new TGraph(100,Z.data(),r_34.data());
		
		
		auto mg1 = new TMultiGraph();
		
		
		
		
		//region 4
		graph14->SetMarkerStyle(24);  // red point
		graph14->SetMarkerSize(1);
		graph14->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph14->SetLineColor(kBlue);	
		mg1->Add(graph14);
		
		
		
		
		//region 4
		graph24->SetMarkerStyle(22);  // red point
		graph24->SetMarkerSize(1.2);
		graph24->SetMarkerColor(kTeal+4);
		//graph1->SetLineWidth(2);
		graph24->SetLineColor(kTeal+4);	
		mg1->Add(graph24);
		
		
			//region 4
		graph34->SetMarkerStyle(5);  // red point
		graph34->SetMarkerSize(1.3);
		graph34->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph34->SetLineColor(kRed);	
		mg1->Add(graph34);
		
		
		
		
		// // //set graph parameters of livermore
		
		
		mg1->Draw("AP");
				
		mg1->SetTitle(title2);		
		mg1->GetXaxis()->SetTitle("Atomic number Z");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg1->GetXaxis()->SetTitleSize(0.06);
		mg1->GetYaxis()->SetTitleSize(0.06);
		
		mg1->GetXaxis()->SetLabelSize(0.05);
		mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		mg1->GetXaxis()->SetLimits(0, 101);
		TLegend* leg2 = new TLegend(0.55,0.75,0.9,0.9);
		// leg2->SetTextAlign(12);
		// leg2->SetFillColor(0);
		leg2->SetFillStyle(0);		
		leg2->SetTextSize(0.04);
		
		
		
		// leg2->AddEntry(graph13,rname13);
		leg2->AddEntry(graph14,rname13);
		
		leg2->AddEntry(graph24,rname23);
		leg2->AddEntry(graph34,rname33);
		
		//leg2->DrawClone("Same");
		leg2->Draw();
		
		
		// mg->GetXaxis()->SetLimits(1e-6,1e5);
		mycanvas->Print("plots/MaximalDifferenceOfFittedTotalCS_2014_2017.png");
		// mycanvas->Close();
		
	
		
}


void plot_first_publication(std::vector<double>& Z, std::vector<double>& r_13, std::vector<double>& r_14, 
std::vector<double>& r_23, std::vector<double>& r_24,
std::vector<double>& r_33, std::vector<double>& r_34)
{
	gROOT->Reset();
	
	TString title1;
	TString title2;
	title1 = "Maximal difference of low fit for total cross section according to Z";
	title2 = "Maximal difference of high fit for total cross section according to Z";
		
	TCanvas* mycanvas = new TCanvas("g","Conversion of electrons and gammas",800, 50, 400, 400);
		
		mycanvas->SetGrid();
		//TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// pad1->Draw();
		// pad2->Draw();
		
		// pad2->cd();
		// TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// pad21->Draw();
		// pad22->Draw();
		
		
		gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// int size = sizeof(RatioMax_x)/sizeof(double);
		// cout<<size<<endl;
		TGraph *graph13 = new TGraph(100,Z.data(),r_13.data());
		// TGraph *graph14 = new TGraph(100,Z.data(),r_14.data());
		
		TGraph *graph23 = new TGraph(100,Z.data(),r_23.data());
		TGraph *graph33 = new TGraph(100,Z.data(),r_33.data());
		// TGraph *graph24 = new TGraph(100,Z.data(),r_24.data());
		
		
		auto mg = new TMultiGraph();
		
		
		//region 3
		graph13->SetMarkerStyle(21);  // red point
		graph13->SetMarkerSize(1);
		graph13->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph13->SetLineColor(kBlue);	
		mg->Add(graph13);
		
		
		
		graph23->SetMarkerStyle(22);  // red point
		graph23->SetMarkerSize(1.2);
		graph23->SetMarkerColor(kTeal+4);
		//graph1->SetLineWidth(2);
		graph23->SetLineColor(kTeal+4);	
		// mg->Add(graph23);
		
		graph33->SetMarkerStyle(24);  // red point
		graph33->SetMarkerSize(1.2);
		graph33->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph33->SetLineColor(kRed);	
		mg->Add(graph33);
		
		
		
		// // //set graph parameters of livermore
		
		
		mg->Draw("AP");
				
		// mg->SetTitle(title1);		
		mg->GetXaxis()->SetTitle("Atomic number Z");
		mg->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg->GetXaxis()->SetTitleSize(0.06);
		// mg->GetYaxis()->SetTitleSize(0.06);
		
		// mg->GetXaxis()->SetLabelSize(0.05);
		// mg->GetYaxis()->SetLabelSize(0.05);
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		mg->GetXaxis()->SetLimits(0, 101);
		mg->GetXaxis()->SetTitleOffset(1.5);
		mg->GetYaxis()->SetTitleOffset(1.5);
		
		TGaxis *axisX = new TGaxis(0,gPad->GetUymax(),
		101, gPad->GetUymax(),
		mg->GetXaxis()->GetXmin(),
		mg->GetXaxis()->GetXmax(), 510,"U-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX->Draw();
		
		
		TGaxis *axisY = new TGaxis(101,gPad->GetUymin(),
		101,  gPad->GetUymax(),
		mg->GetYaxis()->GetXmin(),
		mg->GetYaxis()->GetXmax(), 510,"U+");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY->Draw();
		
		
		
		
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		TLegend* leg1 = new TLegend(0.55,0.15,0.9,0.3);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
		TString rname13 = "EPDL2014 using existing fitting parameters";
		
		TString rname23 = "EPDL2017 using existing fitting parameters";
		TString rname33 = "EPDL2017 using new fitting parameters";
		
		leg1->AddEntry(graph13,rname13);
		
		leg1->AddEntry(graph23,rname23);
		leg1->AddEntry(graph33,rname33);
		
		//leg1->DrawClone("Same");
		// leg1->Draw();
		
		mycanvas->Print("plots/MaximalDifferenceOfFittedTotalCS_2014_2017_low_fit.png");
		
		
	//******************	
		
		TCanvas* mycanvas1 = new TCanvas("S","Conversion of electrons and gammas",800, 50, 400,400);
		
		gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// int size = sizeof(RatioMax_x)/sizeof(double);
		// cout<<size<<endl;
		// TGraph *graph13 = new TGraph(100,Z.data(),r_13.data());
		TGraph *graph14 = new TGraph(100,Z.data(),r_14.data());
		
		// TGraph *graph23 = new TGraph(100,Z.data(),r_23.data());
		TGraph *graph24 = new TGraph(100,Z.data(),r_24.data());
		TGraph *graph34 = new TGraph(100,Z.data(),r_34.data());
		
		
		auto mg1 = new TMultiGraph();
		
		
		
		
		//region 4
		graph14->SetMarkerStyle(21);  // red point
		graph14->SetMarkerSize(1);
		graph14->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph14->SetLineColor(kBlue);	
		mg1->Add(graph14);
		
		
		
		
		//region 4
		graph24->SetMarkerStyle(22);  // red point
		graph24->SetMarkerSize(1.2);
		graph24->SetMarkerColor(kTeal+4);
		//graph1->SetLineWidth(2);
		graph24->SetLineColor(kTeal+4);	
		// mg1->Add(graph24);
		
		
			//region 4
		graph34->SetMarkerStyle(24);  // red point
		graph34->SetMarkerSize(1.2);
		graph34->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph34->SetLineColor(kRed);	
		mg1->Add(graph34);
		
		
		
		
		// // //set graph parameters of livermore
		
		
		mg1->Draw("AP");
				
		// mg1->SetTitle(title2);		
		mg1->GetXaxis()->SetTitle("Atomic number Z");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg1->GetXaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleSize(0.06);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		mg1->GetXaxis()->SetLimits(0, 101);
		
		mg1->GetXaxis()->SetTitleOffset(1.5);
		mg1->GetYaxis()->SetTitleOffset(1.5);
		
		TGaxis *axisX1 = new TGaxis(0,gPad->GetUymax(),
		101, gPad->GetUymax(),
		mg1->GetXaxis()->GetXmin(),
		mg1->GetXaxis()->GetXmax(), 510,"U-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX1->Draw();
		
		
		TGaxis *axisY1 = new TGaxis(101,gPad->GetUymin(),
		101,  gPad->GetUymax(),
		mg1->GetYaxis()->GetXmin(),
		mg1->GetYaxis()->GetXmax(), 510,"U+");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY1->Draw();
		
		
		TLegend* leg2 = new TLegend(0.55,0.75,0.9,0.9);
		// leg2->SetTextAlign(12);
		// leg2->SetFillColor(0);
		leg2->SetFillStyle(0);		
		leg2->SetTextSize(0.04);
		
		
		
		// leg2->AddEntry(graph13,rname13);
		leg2->AddEntry(graph14,rname13);
		
		leg2->AddEntry(graph24,rname23);
		leg2->AddEntry(graph34,rname33);
		
		//leg2->DrawClone("Same");
		// leg2->Draw();
		
		
		// mg->GetXaxis()->SetLimits(1e-6,1e5);
		mycanvas1->Print("plots/MaximalDifferenceOfFittedTotalCS_2014_2017_high_fit.png");
		// mycanvas->Close();
		
	
		
}




void plot_compare_MaximalDifferenceOfFittedTotalCS_2014_2017(){
	
	gROOT->Reset();	
	gSystem->Exec("mkdir -p plots/");
	

	std::vector<double> Z;
	std::vector<double> r_13;
	std::vector<double> r_14;
	std::vector<double> r_23;
	std::vector<double> r_24;
	std::vector<double> r_33;
	std::vector<double> r_34;


	double r3, r4;	
	double z;
	std::ostringstream ost;
	ost <<"ratioMaxForFittedTotalCSUsingExistingParametersFor2017_plotting_final.dat";
	std::ifstream fin(ost.str().c_str());
	for(int i = 0; i<100;i++)
	{
		fin >> z >> r3>>r4;
		r_13.push_back(r3);
		r_14.push_back(r4);
		Z.push_back(z);
	}

	fin.close();

	std::ostringstream ost1;
	ost1 << "ratioMaxForFittedTotalCS2014_plotting_final.dat";
	std::ifstream fin1(ost1.str().c_str());
	for(int i = 0; i<100;i++)
	{
		fin1 >> z >> r3>>r4;
		r_23.push_back(r3);
		r_24.push_back(r4);
		printf("----EPDL97 %d %.9e %.9e\n", i+1, r3, r4);
	}
	fin1.close();


	std::ostringstream ost2;
	ost2 <<"ratioMaxForFittedTotalCSUsingNewParams2017_plotting_final.dat";
	// ost2 <<"ratioMaxForFittedTotalCSUsingExistingParametersFor2017_plotting_final.dat";
	std::ifstream fin2(ost2.str().c_str());
	for(int i = 0; i<100;i++)
	{
		fin2 >> z >> r3>>r4;
		r_33.push_back(r3);
		r_34.push_back(r4);
		printf("---EPICS2017 %f %.9e %.9e\n", z, r3, r4);
	}

	fin2.close();
	
	// plot2(Z, r_13, r_14, r_23, r_24);
	// plot3(Z, r_23, r_24, r_13, r_14, r_33, r_34);
	plot_first_publication(Z, r_23, r_24, r_13, r_14, r_33, r_34);

// calculate the factor of fit precision improved by new fit method
	double sum1, sum2;
	for(int i = 0; i<100;i++)
	{
		sum1+=abs((r_23[i]/r_33[i]));
		sum2+=abs((r_24[i]/r_34[i]));
	}
	
	printf("------factor on average for region 3 low energy fit = %.9e\n", sum1/100);
	printf("------factor on average for region 4 high energy fit = %.9e\n", sum2/100);
	

}