// **************************************************************************
// ROOT macro: plot_total.c
// Plots the figures of total pair production cross section data. 
// There is one figure (now in png format, it can be modified) per element.
// -	cross section data of EPDL2014 (Z: 1-100) 
// -	cross section data of Livermore (Z: 1-99)   
// -	comparison of cross section data between Livermore and EPDL2014 (Z: 1-99) 
// The generated figures are saved in the corresponding directory:
// -	plots/total/comparison
// -	plots/total/epics2017
// -	plots/total/livermore

// Authors: Zhuxin LI @CENBG,France
// 2019.12.09
// **************************************************************************
TString sInt(Int_t number)
  {
    stringstream ss;
    ss << number;
	TString ts = ss.str();
    return ts;
  }
TString sDouble(Double_t number)
  {
    stringstream ss;
	ss << number;
    TString ts = ss.str();
    return ts;
  }

bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
		
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
	
	
	return false;
}
double eps=1e-20;//absolut difference
double releps=1e-10;//relative difference
 
 
std::map<int, double> ratioMax;
  
int results=0;
int results1=0;
std::vector<int> resultsV;
int results2=0;
int results3=0;
int results4=0;
int results5=0;
std::vector<int> results5V;
int results6=0;
std::vector<int> results6V;
int results7=0;
std::vector<int> results7V;
int results8=0;
int results9=0;
	
	
// void plotComparison(Int_t z, char*dir1, char*dir2, std::vector<double>& be_1, std::vector<double>& be_2)
// {
	
	// gROOT->Reset();
		
	// TString S = sInt(z); 
	// TString title;
	// title = "Cross section of total photoelectric reaction for element Z = " + S;
		
		
	// Int_t num1 = 0;  
	// Int_t num2 = 0; 
	
	
	// Int_t ncols;
	// double e, cs;
	// Int_t loop = 0;
	// char str[64] = "";
	// cout<<"------------element "<<z<<"-------------------------"<<endl;
	// FILE * fp1 = fopen(dir1,"r");
	
		// while(1)  
		// {	
			// loop++;
			// // if loop = 1 we read the first header line
			// fgets (str, 64, fp1);
			// // cout<<str<<endl;
			// if(loop ==2)
			// {
				// // now loop = 2, we read the second header line, namely the number of points
				// num1 = stoi(str);  
				// // cout<<"number of total pair production points:"<<num1<<endl;
				// break;
			// }		
			
		// }
		
		// // double x_1[num1];		
		// // double y_1[num1]; 
		
		
		// std::vector<double>  x_1;
		// std::vector<double>  y_1;
	
		// std::vector<int> vec1;
		// std::vector<int> vec2;
		
		// bool test =true;
		// for(Int_t i = 0;i<num1;++i)
		// {
			// // read one line energy cross section
			// ncols = fscanf(fp1,"%lf %lf",&e,&cs); 
			// // x_1[i]=e;   // keep energy
			// // y_1[i]=cs;  // keep cross section
			// x_1.push_back(e);  
			// y_1.push_back(cs);
			
			// // to test if EPDL2017 has the repeated points (edge) as EPDL2014 has
			// if(i==0) continue;
			// if(i && IsEqual(x_1[i],x_1[i-1], eps, releps))
			// {	
				// test =false;
				// vec1.push_back(i);
				// printf("epics2017---%.9e %.9e\n",x_1[i], x_1[i-1]);
			// }
			// // printf("%.9e %.9e\n",x_1[i],y_1[i]);
		// }
		// fclose(fp1);
		// cout<<endl;
		
		
		// // if(test) 
		// // {
			// // results4++;
			// // cout<<"***********************************"<<endl;
		// // }
		
		
		
		// FILE * fp2 = fopen(dir2,"r");		
		// loop =0;
		
		// while(1)
		// {	
			// loop++;
			// // if loop = 1 we read the first header line
			// fgets (str, 64, fp2);
			// if(loop ==2)
			// {
				// // now loop = 2, we read the second header line, namely the number of points
				// num2 = stoi(str);  
				// // cout<<"number of total pair production points:"<<num2<<endl;
				// break;
			// }		
			
		// }
		
		// // double x_2[num2]; 
		// // double y_2[num2]

		// std::vector<double>  x_2;
		// std::vector<double>  y_2;
		
		// std::vector<double>  x_22;
		// std::vector<double>  y_22;
		
		
		
		
		// for(Int_t i = 0;i<num2;++i)
		// {
			// // read one line energy cross section
			// ncols = fscanf(fp2,"%lf %lf",&e,&cs); 
			// // x_2[i]=e; // keep energy
			// // y_2[i]=cs; // keep cross section
			
			// x_2.push_back(e);  
			// y_2.push_back(cs);
			
			
			// //printf("%.9e %.9e\n",x_2[i],y_2[i]);
			// if(i && IsEqual(x_2[i],x_2[i-1], eps, releps)) 
			// {
				// vec2.push_back(i);
				// printf("epics2014---%.9e %.9e\n", x_2[i], x_2[i-1]);				
				
			// }
		// }
		// fclose(fp2);
		
		// cout<<vec1.size()<<" "<<vec2.size()<<endl;;
		
		// bool test2 = true;
		// int nb = 0;  //the number of repeated pairs of EPDL2014, which are not found due to
					// // the minumum energy of EPDL2017
		
		// for(int i=0; i<vec2.size();i++) // EPDL2014
		// {
			// if(x_2[vec2[i]]<x_1[0]) 
			// {
				// nb++;
			// }
			// for(int j = 0; j<vec1.size();j++) //EPDL2017
			// {
				// if(IsEqual(x_2[vec2[i]],x_1[vec1[j]], eps, releps))
				// {
					// test2 = false;
					// // printf("********EPDL2014: %.9e %.9e %.9e %.9e EPDL2017 %.9e %.9e %.9e %.9e  \n",
					// // x_2[vec2[i]-1],  y_2[vec2[i]-1],
					// // x_2[vec2[i]],    y_2[vec2[i]], 
					// // x_1[vec1[j]-1],  y_1[vec1[j]-1],
					// // x_1[vec1[j]],    y_1[vec1[j]]);
										
					// // getchar();
				// }
			// }
		// }
		// if(!test2) 
		// {
			// results6++;
			// results6V.push_back(z);
		// }
// // to see both for EPDL2014 and EPDL2017, if the repeated energies are the binding energy***begin
		
		// int count1 = 0;
		// for(int i=0; i<vec1.size();i++) // EPDL2017
		// {
			// for(int j = 0;j<be_1.size();j++)
			// {
				// if(IsEqual(x_1[vec1[i]],be_1[j], eps, releps)) 
				// {
					// // printf("%.9e %.9e\n", x_1[vec1[i]], be_1[j] );
					// count1++;
					// break;
				// }
			// }
			
		// }
		// if(count1 == vec1.size())
		// {
			// results8++;
			// // cout<<"--epics2017 "<<z<<endl;
		// }
		
		// int count2 = 0;
		// for(int i=0; i<vec2.size();i++) // EPDL2014
		// {
			// for(int j = 0;j<be_2.size();j++)
			// {
				// if(IsEqual(x_2[vec2[i]],be_2[j], eps, releps)) 
				// {
					// count2++;
					// break;
				// }
			// }
		// }
		
		// if(count2 == vec2.size())
		// {
			// results9++;
			// // cout<<"--epics2014 "<<z<<endl;
		// }

// // to see both for EPDL2014 and EPDL2017, if the repeated energies are the binding energy***end		
		// TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",800, 50, 1200, 1000);
		
		// mycanvas->SetGrid();
		// mycanvas->Divide(1,2);
		// //TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// // TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// // TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// // pad1->Draw();
		// // pad2->Draw();
		
		// // pad2->cd();
		// // TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// // TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// // pad21->Draw();
		// // pad22->Draw();
		
		
		// mycanvas->cd(1);
		// gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetLogy();
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetLeftMargin(0.01);
		// //gPad->SetLogy();
					
		// // TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// // TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// TGraph *graph1 = new TGraph(x_1.size(),x_1.data(),y_1.data());
		// TGraph *graph2 = new TGraph(x_2.size(),x_2.data(),y_2.data());
		
		// auto mg = new TMultiGraph();
		
		// graph2->SetMarkerStyle(4);  //blue circle
		// graph2->SetMarkerSize(0.7);
		// graph2->SetMarkerColor(4);
		// graph2->SetLineColor(4);
		// mg->Add(graph2);
	
		
		
		// //set graph parameters of EPDL2014
		// graph1->SetMarkerStyle(7);  // red point
		// graph1->SetMarkerSize(2);
		// graph1->SetMarkerColor(2);
		// //graph1->SetLineWidth(2);
		// graph1->SetLineColor(2);	
		// mg->Add(graph1);
		
		
		
		// //set graph parameters of livermore
		
		
		// mg->Draw("APL");
				
		// mg->SetTitle(title);		
		// mg->GetXaxis()->SetTitle("Energy (MeV)");
		// mg->GetYaxis()->SetTitle("Cross section (barn)");
		
		// mg->GetXaxis()->SetTitleSize(0.06);
		// mg->GetYaxis()->SetTitleSize(0.06);
		
		// mg->GetXaxis()->SetTitleOffset(1.2);
		// mg->GetYaxis()->SetTitleOffset(1.0);
		
		// mg->GetXaxis()->SetLabelSize(0.05);
		// mg->GetYaxis()->SetLabelSize(0.05);
		
		
		// mg->GetXaxis()->CenterTitle();
		// mg->GetYaxis()->CenterTitle();
		
		// mg->GetXaxis()->SetLimits(1e-6,1e5);
		
		
		
		
		// // graph2->SetMaximum(5e-25); 
		// // graph2->SetMinimum(1e-35); 
		
		
		// TLegend* leg = new TLegend(0.45,0.7,0.9,0.9);
		// // leg->SetTextAlign(12);
		// leg->SetFillColor(0);	
		// leg->SetTextSize(0.04);
		
		
		// TString Tnum1 = sInt(num1);		
		// TString Tnum2 = sInt(num2);	
		// TString Tnum11 = sInt(vec1.size());		
		// TString Tnum22 = sInt(vec2.size());	
		
		// TString name1 = "EPDL2017 - "+ Tnum1 + " points, with " + Tnum11 + " repeated pair(s)";
		// TString name2 = "EPDL2014 - "+ Tnum2 + " points, with " + Tnum22 + " repeated pair(s)";
		
		// leg->AddEntry(graph1,name1);
		// leg->AddEntry(graph2,name2);
		// //leg->DrawClone("Same");
		// leg->Draw();
		
		// int flag=0;
		// int flag1=0;
		// int flag2=0;
		// int exception = 0;
		// //for containing the ratio;
		
		// double y_3[num2]; //to save the identical points of same energy
		// int num = 0; // to save the number of pairs of identical points 
		
		// double r[num2];  // ratio (%): (EPDL2014-Livermore)/Livermore *100 ;
		
		// for(int i=0;i<num2;++i)
		// {
			// r[i] = 10000000000;
		// }
		
		// bool isFound = false;
		// for(Int_t i=0;i<num2;++i)  //EPDL2014  
		// {
			// // if(x_2[i] == 1.7307e-3) cout<<"hhhhhhhhh"<<i<<endl;  //i =403
			// for(Int_t j=0;j<num1;++j) //EPDL2017
			// {
				 
				 
				// if(IsEqual(x_1[j],x_2[i], eps, releps))
				// {				
					// // cout<<flag<<"-----"<<x_2[i]<<endl;
					// flag1++;
					// if(IsEqual(y_2[i],y_1[j], eps, releps)) //if(i==0)
					// {
						
						// r[i]=0;
						// // cout<<flag<<" "<<i+1<<" "<<x_2[i]<<r[i]<<"-------------------Same---1"<<endl;
						// // printf("%d %.9e %.9e--------------------Same---1\n",i+1,x_2[i], r[i]);
					// }
					// else 
					// {
													
						// r[i] = (y_1[j] - y_2[i])/y_2[i]*100;  //percentage
						// // cout<<flag<<" "<<i+1<<" "<<x_2[i]<<" "<<r[i]<<"     1"<<endl;
						// // printf("%d %.9e %.9e %.9e %.9e    1\n",i+1,x_2[i],y_2[i], y_1[j], r[i]);
						// if(IsEqual(x_1[j],x_1[j+1], eps, releps) && (j< (num1-1)))
						// {
							// double temp = (y_1[j+1] - y_2[i])/y_2[i]*100;
							// if((abs(temp) - abs(r[i]))<0)
							// {
								// // printf("1zhuxin %d %.9e %.9e %.9e %.9e %.9e  1\n",j+1,x_2[i], y_1[j], y_1[j+1], r[i], temp);
								// r[i] = temp;
								
							// }
						// }
						
					// }
					
					// //cout<<i<<"-----EPDL2014=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
					// isFound = true;
					// break;			
					
				// }				
			// }
			// if(!isFound)
			// {
				// for(Int_t j=0;j<num1;++j) //EPDL2014
				// {
					
					
					// if(abs((x_1[j]-x_2[i])/x_2[i])<0.0001) // 0.0001 at first
					// // if(abs(x_1[j]-x_2[i])<0.001)
					// {
						// flag2++;
						// if(IsEqual(y_2[i],y_1[j], eps, releps)) //if(i==0)
						// {
							
							// r[i]=0;
							// // cout<<flag<<" "<<i+1<<" "<<x_2[i]<<r[i]<<"--------------------Same---2"<<endl;
							// // printf("%d %.9e %.9e %.9e--------------------Same---2\n",i+1,x_2[i], x_1[j], r[i]);
						// }
						// else 
						// {
							
							// r[i] = (y_1[j] - y_2[i])/y_2[i]*100;  //percentage
							// // cout<<flag<<" "<<i+1<<" "<<x_2[i]<<" "<<x_1[j]<<" "<<r[i]<<"     2"<<endl;
							// // printf("%d %.9e %.9e %.9e %.9e %.9e   2\n",i+1,x_2[i], y_2[i],x_1[j], y_1[j], r[i]);
							// if(IsEqual(x_1[j],x_1[j+1], eps, releps))
							// {
								// double temp = (y_1[j+1] - y_2[i])/y_2[i]*100;
								// if((abs(temp) - abs(r[i]))<0)
								// {
									// // printf("2zhuxin %d %.9e %.9e %.9e %.9e %.9e %.9e   1\n",j+1,x_2[i],x_1[j], y_1[j], y_1[j+1], r[i], temp);
									// r[i] = temp;
								// }
							// }
						// }
						
						// //cout<<i<<"-----EPDL2014=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
						// isFound = true;
						// break;
					// }
					
					
				// }				
				
				
			// }		
			// isFound = false;		
			
		// }
		
		
		
		
		// flag = flag1+flag2;
		// // cout<<sizeof(r)/sizeof(r[0])<<endl;
		// // cout<<sizeof(r_x)/sizeof(r_x[0])<<endl;
		// double r_x[flag];
		// double R[flag]; 
		// int k = 0;
		
		
		// bool test1 = true;
		// for(int j=0;j<num2;++j)
		// {
			// if(r[j]==10000000000)
			// {
				// // cout<<j+1<<" "<<x_2[j]<<" "<<r[j]<<"----------------3"<<endl;
				// // printf("%d %.9e %.9e %.9e-----------------3\n",j+1,x_2[j],y_2[j], r[j]);
				// exception++;
				
				// //if this is satisfied, for this element, means the exception 
				// //is due to the precision, instead of the minimum energy of EPDL2017
				// if(x_2[j]>=x_1[0])  
				// {
					// test1 =false;
				// }
				// continue;
				
			// }
			// else
			// {
				
				// if(x_2[j]!=x_2[j-1])
				// {
					// r_x[k] = x_2[j];
					// R[k] = r[j];
					// k++;
				// }
				// else
				// {
					// if((abs(r[j]) - abs(r[j-1]))<0)
					// {
						// R[k-1] = r[j];
					// }
					
				// }
				
				
			// }
			
						
		// }
		// double max = R[0];
		// for(int i=0;i<k;i++)
		// {
			// if(abs(R[i])>abs(max))
			// {
				// max = R[i];
			// }
		// }		
		
		// ratioMax.insert(map<int, double>::value_type (z, max));
		
		
		// bool test3 = true;
		// // cout<<" nb"<<nb<<endl;
		// if((exception + vec2.size()+ k + nb) != num2)
		// {
			// test3 = false;
			
		// }
		// if(!test3)
		// {
			// // cout<<z<<endl;
			// results7++;
			// results7V.push_back(z);
		// }
			
		// // for(int i = 0;i<k;i++)
		// // {
			// // printf("----------%d %.9e %.9e---------\n",i+1,r_x[i], R[i]);
		// // }
		
		
		
		// if(!test1) 
		// {
			// results5++;
			// results5V.push_back(z);
			// // if(exception)
			// // {
				// // cout<<"jjjjjjjj exceptions are all detected for element "<<z<<"jjjjjjjjjjjjjjjjjjjj"<<endl;
			// // }
			// // else cout<<"xxxxxxx exceptions are not all detected for element "<<z<<"xxxxxxxxxxxxxxxxxxxxx"<<endl;
			
		// }
		
		
		
		// // for(int i=0;i<flag;++i)
		// // {
			// // cout<<i+1<<" "<<R[i]<<endl;
		// // }
		
		
		// // cout<<"num2="<<num2<<", flag="<<flag<<" || flag1="<<flag1<<", flag2="<<flag2<<", exception="<<exception<<" k="<<k<<endl;
		// // if(flag==num2) 
		// // {
			// // results++;
			// // resultsV.push_back(z);
			// // // cout<<"flag=="<<flag<<endl;
			// // if(flag2==0)
			// // {
				// // results2++;
				// // cout<<"flag==num2,totally match for all points energy for element "<<z<<"****************************"<<endl;	
			// // }
			// // else
			// // {
				// // results3++;
				// // cout<<"flag==num2,some points are mathched with 0.001% precision for element "<<z<<"##############################"<<endl;
			// // }
			
		// // }
		// // else{
			// // results1++;						
			// // cout<<"Some points in EPDL2014 are not found for element "<<z<<"-------------------------"<<endl;
		// // }
		
		
		
		
		// mycanvas->cd(2);
		// gPad->SetLogx();
		
		// // gPad->SetTopMargin(0.12);
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetBottomMargin(0.15);
		// // gPad->SetGrid();
		// // gStyle->SetTitleW(0.9);  //per cent of the pad width
		// // gStyle->SetTitleH(0.9);
		// // gStyle->SetTitleFontSize(0.9);
		
		// // // pad21->SetLeftMargin(0.10); //10%
		
		
		// char nameRatio[100] = "Relative difference of EPDL2017 compared to EPDL2014";	
		
		// TGraph *ratio = new TGraph(k,r_x,R);
		// ratio->SetTitle(nameRatio);
		// ratio->Draw();
		// ratio->GetXaxis()->SetTitle("Energy (MeV)");
		// ratio->GetYaxis()->SetTitle("Relative Difference (%)");
		
		// ratio->GetXaxis()->SetTitleSize(0.06);
		// ratio->GetYaxis()->SetTitleSize(0.06);
		
		// ratio->GetXaxis()->SetLabelSize(0.05);
		// ratio->GetYaxis()->SetLabelSize(0.05);
		// ratio->GetYaxis()->SetTitleOffset(1.0);
		// ratio->GetXaxis()->SetTitleOffset(1.2);
			
		// ratio->GetXaxis()->CenterTitle();
		// ratio->GetYaxis()->CenterTitle();
		
		// ratio->SetMarkerStyle(8);
		// ratio->SetMarkerSize(0.5);
		// ratio->SetMarkerColor(2);
		// ratio->SetLineColor(2);
		
		// ratio->GetXaxis()->SetLimits(1e-6,1e5);
		
	
		
		// TLatex latex;
		// latex.SetTextSize(0.05);
		// latex.SetTextAlign(22);
		// latex.DrawLatexNDC(0.7,0.8,"RD = #frac{EPDL2017-EPDL2014}{EPDL2014} x 100");
		
		
		// TString Tflag = sInt(k);	
		// Tflag += " points in comparison";
		// latex.SetTextColor(2);
		// latex.DrawLatexNDC(0.7,0.7,Tflag);
		
		
		
		
		// // TLegend* leg212 =  new TLegend(0.12,0.7,0.3,0.88);
		// // TString Tnum4 = sInt(num2);
		// // TString name4 = Tnum4 + " points in comparison";		
		// // leg212->AddEntry(ratio,name4);
		// // leg212->SetTextAlign(22);
		// // leg212->SetFillStyle(0);
		// // leg212->Draw();
		// // leg212->SetTextSize(0.05);
		
		
		
		
		// //***********(begin)for the zoomin of the ratio 
		
		
		
		// mycanvas->Print("plots/totalCS_comparison/2014vs2017comparison-pe-cs-"+ S +".png");
		// // delete mycanvas;
		// // mycanvas = NULL;
		
// }


//for the first publication
void plotComparison_2(Int_t z, char*dir1, char*dir2, std::vector<double>& be_1, std::vector<double>& be_2)
{
	
	gROOT->Reset();
		
	TString S = sInt(z); 
	TString title;
	title = "Total cross section of photoelectric effect for element Z = " + S;
		
		
	Int_t num1 = 0;  
	Int_t num2 = 0; 
	
	
	Int_t ncols;
	double e, cs;
	Int_t loop = 0;
	char str[64] = "";
	cout<<"------------element "<<z<<"-------------------------"<<endl;
	FILE * fp1 = fopen(dir1,"r");
	
		while(1)  
		{	
			loop++;
			// if loop = 1 we read the first header line
			fgets (str, 64, fp1);
			// cout<<str<<endl;
			if(loop ==2)
			{
				// now loop = 2, we read the second header line, namely the number of points
				num1 = stoi(str);  
				// cout<<"number of total pair production points:"<<num1<<endl;
				break;
			}		
			
		}
		
		// double x_1[num1];		
		// double y_1[num1]; 
		
		
		std::vector<double>  x_1;
		std::vector<double>  y_1;
	
		std::vector<int> vec1;
		std::vector<int> vec2;
		
		bool test =true;
		for(Int_t i = 0;i<num1;++i)
		{
			// read one line energy cross section
			ncols = fscanf(fp1,"%lf %lf",&e,&cs); 
			// x_1[i]=e;   // keep energy
			// y_1[i]=cs;  // keep cross section
			x_1.push_back(e);  
			y_1.push_back(cs);
			
			// to test if EPDL2017 has the repeated points (edge) as EPDL2014 has
			if(i==0) continue;
			if(i && IsEqual(x_1[i],x_1[i-1], eps, releps))
			{	
				test =false;
				vec1.push_back(i);
				printf("epics2017---%.9e %.9e\n",x_1[i], x_1[i-1]);
			}
			// printf("%.9e %.9e\n",x_1[i],y_1[i]);
		}
		fclose(fp1);
		cout<<endl;
		
		
		// if(test) 
		// {
			// results4++;
			// cout<<"***********************************"<<endl;
		// }
		
		
		
		FILE * fp2 = fopen(dir2,"r");		
		loop =0;
		
		while(1)
		{	
			loop++;
			// if loop = 1 we read the first header line
			fgets (str, 64, fp2);
			if(loop ==2)
			{
				// now loop = 2, we read the second header line, namely the number of points
				num2 = stoi(str);  
				// cout<<"number of total pair production points:"<<num2<<endl;
				break;
			}		
			
		}
		
		// double x_2[num2]; 
		// double y_2[num2]

		std::vector<double>  x_2;
		std::vector<double>  y_2;
		
		std::vector<double>  x_22;
		std::vector<double>  y_22;
		
		
		
		
		for(Int_t i = 0;i<num2;++i)
		{
			// read one line energy cross section
			ncols = fscanf(fp2,"%lf %lf",&e,&cs); 
			// x_2[i]=e; // keep energy
			// y_2[i]=cs; // keep cross section
			
			x_2.push_back(e);  
			y_2.push_back(cs);
			
			
			//printf("%.9e %.9e\n",x_2[i],y_2[i]);
			if(i && IsEqual(x_2[i],x_2[i-1], eps, releps)) 
			{
				vec2.push_back(i);
				printf("epics2014---%.9e %.9e\n", x_2[i], x_2[i-1]);				
				
			}
		}
		fclose(fp2);
		
		cout<<vec1.size()<<" "<<vec2.size()<<endl;;
		
		bool test2 = true;
		int nb = 0;  //the number of repeated pairs of EPDL2014, which are not found due to
					// the minumum energy of EPDL2017
		
		for(int i=0; i<vec2.size();i++) // EPDL2014
		{
			if(x_2[vec2[i]]<x_1[0]) 
			{
				nb++;
			}
			for(int j = 0; j<vec1.size();j++) //EPDL2017
			{
				if(IsEqual(x_2[vec2[i]],x_1[vec1[j]], eps, releps))
				{
					test2 = false;
					// printf("********EPDL2014: %.9e %.9e %.9e %.9e EPDL2017 %.9e %.9e %.9e %.9e  \n",
					// x_2[vec2[i]-1],  y_2[vec2[i]-1],
					// x_2[vec2[i]],    y_2[vec2[i]], 
					// x_1[vec1[j]-1],  y_1[vec1[j]-1],
					// x_1[vec1[j]],    y_1[vec1[j]]);
										
					// getchar();
				}
			}
		}
		if(!test2) 
		{
			results6++;
			results6V.push_back(z);
		}
// to see both for EPDL2014 and EPDL2017, if the repeated energies are the binding energy***begin
		
		int count1 = 0;
		for(int i=0; i<vec1.size();i++) // EPDL2017
		{
			for(int j = 0;j<be_1.size();j++)
			{
				if(IsEqual(x_1[vec1[i]],be_1[j], eps, releps)) 
				{
					// printf("%.9e %.9e\n", x_1[vec1[i]], be_1[j] );
					count1++;
					break;
				}
			}
			
		}
		if(count1 == vec1.size())
		{
			results8++;
			// cout<<"--epics2017 "<<z<<endl;
		}
		
		int count2 = 0;
		for(int i=0; i<vec2.size();i++) // EPDL2014
		{
			for(int j = 0;j<be_2.size();j++)
			{
				if(IsEqual(x_2[vec2[i]],be_2[j], eps, releps)) 
				{
					count2++;
					break;
				}
			}
		}
		
		if(count2 == vec2.size())
		{
			results9++;
			// cout<<"--epics2014 "<<z<<endl;
		}

// to see both for EPDL2014 and EPDL2017, if the repeated energies are the binding energy***end		
		TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",800, 50, 400, 400);
		
		mycanvas->SetGrid();
		//TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// pad1->Draw();
		// pad2->Draw();
		
		// pad2->cd();
		// TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// pad21->Draw();
		// pad22->Draw();
		
		
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		TGraph *graph1 = new TGraph(x_1.size(),x_1.data(),y_1.data());
		TGraph *graph2 = new TGraph(x_2.size(),x_2.data(),y_2.data());
		
		auto mg = new TMultiGraph();
		
		
	
		
			//set graph parameters of EPICS2017
		graph1->SetMarkerStyle(24);  // red point
		graph1->SetMarkerSize(1.4);
		graph1->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		// graph1->SetLineColor(kRed);	
		mg->Add(graph1);
		
		//set graph parameters of livermore
		graph2->SetMarkerStyle(21);  //blue circle
		graph2->SetMarkerSize(0.8);
		graph2->SetMarkerColor(kBlue);
		graph2->SetLineColor(kBlue);
		
		mg->Add(graph2);
	   
		
		//set graph parameters of livermore
		
		
		mg->Draw("AP");
				
		mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Energy (MeV)");
		mg->GetYaxis()->SetTitle("Cross section (barn)");
		
	
		mg->GetXaxis()->SetTitleOffset(1.5);	
		
		mg->GetYaxis()->SetTitleOffset(2);
		
		
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		
		mg->GetXaxis()->SetLimits(1e-6,1e5);
		
		
		
		TGaxis *axisX = new TGaxis(1e-6,TMath::Power(10, gPad->GetUymax()),
		1e5, TMath::Power(10, gPad->GetUymax()),
		mg->GetXaxis()->GetXmin(),
		mg->GetXaxis()->GetXmax(), 510,"GU-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX->Draw("");
			
		
		TGaxis *axisY = new TGaxis(1e5,TMath::Power(10, gPad->GetUymin()) ,
			1e5, TMath::Power(10, gPad->GetUymax()) ,
		mg->GetYaxis()->GetXmin(),
		mg->GetYaxis()->GetXmax(), 510,"GU+");
		
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY->Draw();
			
		// graph2->SetMaximum(5e-25); 
		// graph2->SetMinimum(1e-35); 
		
		
		TLegend* leg1 = new TLegend(.65,.7,.90,.9);
		leg1->SetFillColor(0);	
		// leg->SetTextSize(0.06);
		
		
			
		
		TString name11 = "EPICS2017";
		TString name22 = "EPDL97";	
		
		leg1->AddEntry(graph1,name11);
		leg1->AddEntry(graph2,name22);
		//leg->DrawClone("Same");
		leg1->Draw();
		
		
		
		
		
		
		TLegend* leg = new TLegend(0.45,0.7,0.9,0.9);
		// leg->SetTextAlign(12);
		leg->SetFillColor(0);	
		leg->SetTextSize(0.04);
		
		
		TString Tnum1 = sInt(num1);		
		TString Tnum2 = sInt(num2);	
		TString Tnum11 = sInt(vec1.size());		
		TString Tnum22 = sInt(vec2.size());	
		
		TString name1 = "EPDL2017 - "+ Tnum1 + " points, with " + Tnum11 + " repeated pair(s)";
		TString name2 = "EPDL2014 - "+ Tnum2 + " points, with " + Tnum22 + " repeated pair(s)";
		
		leg->AddEntry(graph1,name1);
		leg->AddEntry(graph2,name2);
		//leg->DrawClone("Same");
		// leg->Draw();
		
		mycanvas->Print("plots/totalCS_comparison/2014vs2017comparison-pe-cs-"+ S +".png");
		delete mycanvas;
		mycanvas = NULL;
		
		TString S2 = S + "RD";
		
		TCanvas* mycanvas1 = new TCanvas(S2,"Conversion of electrons and gammas",800, 50, 400, 400);
		
		mycanvas1->SetGrid();
		//TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// pad1->Draw();
		// pad2->Draw();
		
		// pad2->cd();
		// TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// pad21->Draw();
		// pad22->Draw();
		
		
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		
		int flag=0;
		int flag1=0;
		int flag2=0;
		int exception = 0;
		//for containing the ratio;
		
		double y_3[num2]; //to save the identical points of same energy
		int num = 0; // to save the number of pairs of identical points 
		
		double r[num2];  // ratio (%): (EPDL2014-Livermore)/Livermore *100 ;
		
		for(int i=0;i<num2;++i)
		{
			r[i] = 10000000000;
		}
		
		bool isFound = false;
		for(Int_t i=0;i<num2;++i)  //EPDL2014  
		{
			// if(x_2[i] == 1.7307e-3) cout<<"hhhhhhhhh"<<i<<endl;  //i =403
			for(Int_t j=0;j<num1;++j) //EPDL2017
			{
				 
				 
				if(IsEqual(x_1[j],x_2[i], eps, releps))
				{				
					// cout<<flag<<"-----"<<x_2[i]<<endl;
					flag1++;
					if(IsEqual(y_2[i],y_1[j], eps, releps)) //if(i==0)
					{
						
						r[i]=0;
						// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<r[i]<<"-------------------Same---1"<<endl;
						// printf("%d %.9e %.9e--------------------Same---1\n",i+1,x_2[i], r[i]);
					}
					else 
					{
													
						r[i] = (y_1[j] - y_2[i])/y_2[i]*100;  //percentage
						// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<" "<<r[i]<<"     1"<<endl;
						// printf("********%d %.9e %.9e %.9e %.9e    1\n",i+1,x_2[i],y_2[i], y_1[j], r[i]);
						if(IsEqual(x_1[j],x_1[j+1], eps, releps) && (j< (num1-1)))
						{
							double temp = (y_1[j+1] - y_2[i])/y_2[i]*100;
							
							if((abs(temp) - abs(r[i]))<0)  
							{
								printf("---------1zhuxin %d %.9e %.9e %.9e %.9e %.9e  1\n",j+1,x_2[i], y_1[j], y_1[j+1], r[i], temp);
								r[i] = temp;
								printf("---------2zhuxin %d %.9e %.9e %.9e %.9e %.9e  1\n",j+1,x_2[i], y_1[j], y_1[j+1], r[i], temp);
								
								
							}
						}
						
					}
					
					//cout<<i<<"-----EPDL2014=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
					isFound = true;
					break;			
					
				}				
			}
			if(!isFound)
			{
				for(Int_t j=0;j<num1;++j) //EPDL2017
				{
					
					
					if(abs((x_1[j]-x_2[i])/x_2[i])<0.0001) // 0.0001 at first
					// if(abs(x_1[j]-x_2[i])<0.001)
					{
						flag2++;
						if(IsEqual(y_2[i],y_1[j], eps, releps)) //if(i==0)
						{
							
							r[i]=0;
							// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<r[i]<<"--------------------Same---2"<<endl;
							// printf("%d %.9e %.9e %.9e--------------------Same---2\n",i+1,x_2[i], x_1[j], r[i]);
						}
						else 
						{
							
							r[i] = (y_1[j] - y_2[i])/y_2[i]*100;  //percentage
							// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<" "<<x_1[j]<<" "<<r[i]<<"     2"<<endl;
							// printf("%d %.9e %.9e %.9e %.9e %.9e   2\n",i+1,x_2[i], y_2[i],x_1[j], y_1[j], r[i]);
							if(IsEqual(x_1[j],x_1[j+1], eps, releps))
							{
								double temp = (y_1[j+1] - y_2[i])/y_2[i]*100;
								if((abs(temp) - abs(r[i]))<0)
								{
									printf("_____3zhuxin %d %.9e %.9e %.9e %.9e %.9e %.9e   1\n",j+1,x_2[i],x_1[j], y_1[j], y_1[j+1], r[i], temp);
									r[i] = temp;
								}
							}
						}
						
						//cout<<i<<"-----EPDL2014=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
						isFound = true;
						break;
					}
					
					
				}				
				
				
			}		
			isFound = false;		
			
		}
		
		
		
		
		flag = flag1+flag2;
		// cout<<sizeof(r)/sizeof(r[0])<<endl;
		// cout<<sizeof(r_x)/sizeof(r_x[0])<<endl;
		double r_x[flag];
		double R[flag]; 
		int k = 0;
		
		
		bool test1 = true;
		for(int j=0;j<num2;++j)
		{
			if(r[j]==10000000000)
			{
				// cout<<j+1<<" "<<x_2[j]<<" "<<r[j]<<"----------------3"<<endl;
				// printf("%d %.9e %.9e %.9e-----------------3\n",j+1,x_2[j],y_2[j], r[j]);
				exception++;
				
				//if this is satisfied, for this element, means the exception 
				//is due to the precision, instead of the minimum energy of EPDL2017
				if(x_2[j]>=x_1[0])  
				{
					test1 =false;
				}
				continue;
				
			}
			else
			{
				
				if(x_2[j]!=x_2[j-1])
				{
					r_x[k] = x_2[j];
					R[k] = r[j];
					k++;
				}
				else
				{
					if((abs(r[j]) - abs(r[j-1]))<0)
					{
						R[k-1] = r[j];
					}
					
				}
				
				
			}
			
						
		}
		double max = R[0];
		for(int i=0;i<k;i++)
		{
			if(abs(R[i])>abs(max))
			{
				max = R[i];
			}
		}		
		
		ratioMax.insert(map<int, double>::value_type (z, max));
		
		
		bool test3 = true;
		// cout<<" nb"<<nb<<endl;
		if((exception + vec2.size()+ k + nb) != num2)
		{
			test3 = false;
			
		}
		if(!test3)
		{
			// cout<<z<<endl;
			results7++;
			results7V.push_back(z);
		}
			
		// for(int i = 0;i<k;i++)
		// {
			// printf("----------%d %.9e %.9e---------\n",i+1,r_x[i], R[i]);
		// }
		
		
		
		if(!test1) 
		{
			results5++;
			results5V.push_back(z);
			// if(exception)
			// {
				// cout<<"jjjjjjjj exceptions are all detected for element "<<z<<"jjjjjjjjjjjjjjjjjjjj"<<endl;
			// }
			// else cout<<"xxxxxxx exceptions are not all detected for element "<<z<<"xxxxxxxxxxxxxxxxxxxxx"<<endl;
			
		}
		
		
		
		// for(int i=0;i<flag;++i)
		// {
			// cout<<i+1<<" "<<R[i]<<endl;
		// }
		
		
		// cout<<"num2="<<num2<<", flag="<<flag<<" || flag1="<<flag1<<", flag2="<<flag2<<", exception="<<exception<<" k="<<k<<endl;
		// if(flag==num2) 
		// {
			// results++;
			// resultsV.push_back(z);
			// // cout<<"flag=="<<flag<<endl;
			// if(flag2==0)
			// {
				// results2++;
				// cout<<"flag==num2,totally match for all points energy for element "<<z<<"****************************"<<endl;	
			// }
			// else
			// {
				// results3++;
				// cout<<"flag==num2,some points are mathched with 0.001% precision for element "<<z<<"##############################"<<endl;
			// }
			
		// }
		// else{
			// results1++;						
			// cout<<"Some points in EPDL2014 are not found for element "<<z<<"-------------------------"<<endl;
		// }
		
		
	
		// gPad->SetBottomMargin(0.15);
		// gPad->SetGrid();
		// gStyle->SetTitleW(0.9);  //per cent of the pad width
		// gStyle->SetTitleH(0.9);
		// gStyle->SetTitleFontSize(0.9);
		
		// // pad21->SetLeftMargin(0.10); //10%
		
		
		char nameRatio[100] = "Relative difference of EPDL2017 compared to EPDL2014";	
		
		TGraph *ratio = new TGraph(k,r_x,R);
		auto mg1 = new TMultiGraph();
		
		ratio->SetMarkerStyle(24);
		ratio->SetMarkerSize(1);
		ratio->SetMarkerColor(kRed);
		ratio->SetLineColor(kRed);
		mg1->Add(ratio);
		
		mg1->Draw("AP");
		
		mg1->GetXaxis()->SetTitle("Energy (MeV)");
		mg1->GetYaxis()->SetTitle("Relative Difference (%)");
		
		// mg1->GetXaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleSize(0.06);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
		
		mg1->GetYaxis()->SetTitleOffset(2);
		mg1->GetXaxis()->SetTitleOffset(1.5);
			
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		
		
		
		mg1->GetXaxis()->SetLimits(1e-6,1e5);
		
	
		TGaxis *axisX1 = new TGaxis(1e-6,gPad->GetUymax(),
		1e5, gPad->GetUymax(),
		mg1->GetXaxis()->GetXmin(),
		mg1->GetXaxis()->GetXmax(), 510,"GU-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX1->Draw("");
			
		
		TGaxis *axisY1 = new TGaxis(1e5,gPad->GetUymin(),
			1e5, gPad->GetUymax(),
		mg1->GetYaxis()->GetXmin(),
		mg1->GetYaxis()->GetXmax(), 510,"U+");
		
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY1->Draw();
		
		
		
		
		//***********(begin)for the zoomin of the ratio 
		
		
		
		mycanvas1->Print("plots/totalCS_comparison/2014vs2017comparison_RD-pe-cs-"+ S +".png");
		delete mycanvas1;
		mycanvas1 = NULL;
		
}


void plot_pe_cs(){
	
	gROOT->Reset();
	gSystem->Exec("mkdir -p plots/totalCS_comparison");
	
	
// do not modify*******************************************************************begin	
//this is to read the binding energy for epics2017 and epics2014,
//the data read will be used to verify if the repeated energy  
//is equal to the binding energy	
	FILE*fp3 = fopen("epics2017/phot_preliminary/bindingEnergy/binding.dat","r");	
	FILE*fp4 = fopen("epics2014/phot_preliminary/bindingEnergy/binding.dat","r");	
	
	std::vector<double> designator_1[101];
	std::vector<double> be_1[101];
	
	
	std::vector<double> designator_2[101];
	std::vector<double> be_2[101];
	double d1; 
	double e1; 
	double d2; 
	double e2; 
    Int_t Ncols = 0;
	Int_t count = 0;
	
    for(int i=1; i<=100; ++i)  // there are 100 elements
	{
		
		while(1)
		{
			count++;
			Ncols = fscanf(fp3,"%lf %lf",&d1,&e1);
			// cout<<"yes"<<endl;
			Ncols = fscanf(fp4,"%lf %lf",&d2,&e2);
			
			
			
			if(d1 ==d2 && d1 == -1)
			{
				// cout<<"---ending---"<<i<<" "<<count<<endl;

				break;
			}
			else{
				
				// printf("%d %.9e %.9e %.9e %.9e\n",count, d1, e1, d2, e2);
			 
				designator_1[i].push_back(d1);
				be_1[i].push_back(e1);
				designator_2[i].push_back(d2);
				be_2[i].push_back(e2);
			 
			
			}
			 
			
		}	
		
	}
	fclose(fp3);
	fclose(fp4);
// do not modify**********************************************************************end

    
	for (Int_t z = 1;z<=100;++z)// number of element Z, from 1 to 100
	{
		
		// if((z != 1) && (z != 13) && (z != 82)) continue;
		char path1Format[128] = "epics2017/phot_preliminary/pe-cs-%d.dat"; //prefix of the name of original data file
		char path1[128];
		
		char path2Format[128] = "epics2014/phot_preliminary/pe-cs-%d.dat"; //prefix of the name of original data file
		char path2[128];
		
		sprintf(path1,path1Format, z);
		sprintf(path2,path2Format, z);
		
		// plotSingle(z,1,path1);
		// plotSingle(z,2,path2);

	
		// plotComparison(z, path1, path2, be_1[z], be_2[z]);
		plotComparison_2(z, path1, path2, be_1[z], be_2[z]);
		
			
	}
	
	
	// FILE* out = fopen("ratioMaxForTotalCS.txt", "w");
	// map<int, double>::iterator iter;
	// map<int, double>::iterator iter_begin = ratioMax.begin(); 
	// int final_z;
	// double final_ratioMax;
	// final_z = (*iter_begin).first;
	// final_ratioMax = (*iter_begin).second;
  
    // for(iter = iter_begin; iter != ratioMax.end(); iter++)
	// {
		// fprintf(out,"element = %d, ratioMax = %.9e%% \n", iter->first, iter->second);
		// if((*iter).second > final_ratioMax)
		// {
			// final_z = (*iter).first;
			// final_ratioMax = (*iter).second;
			
		// }
	// }
	
	// fprintf(out,"Amongst all the elements, the ratioMax is:\nElement = %d, ratioMax = %.9e%% \n", 
					    // final_z, final_ratioMax);
		
		
	// fclose(out);
	
	

  
        
	   
	cout<<"results="<<results<<", results2="<<results2<<", results3="<<results3<<endl;
	cout<<"results1="<<results1<<endl;
	cout<<"for the following elements, all points in EPDL2014 are found in EPDL2017"
	<<endl;
	for(std::vector<int>::iterator it = resultsV.begin(); it!=resultsV.end(); it++)
	{
		cout<<*it<<endl;
	}
	
	cout<<"results4="<<results4<<" Only two elements do not have errors of overlapping energy pairs,\
	namely element 1 and 2"<<endl;
	
	cout<<"results5="<<results5<<endl;
	
	cout<<"for the following elements, it has exceptions due to the precision:"<<endl;
	
	for(std::vector<int>::iterator it = results5V.begin(); it!=results5V.end(); it++)
	{
		cout<<*it<<endl;
	}
	cout<<"results6="<<results6<<endl;
	cout<<"for the following elements, EPDL2017 and EPDL2014 has same repeated points:"<<endl;
	
	for(std::vector<int>::iterator it = results6V.begin(); it!=results6V.end(); it++)
	{
		cout<<*it<<endl;
	}
	cout<<"results7="<<results7<<endl;
	
	for(std::vector<int>::iterator it = results7V.begin(); it!=results7V.end(); it++)
	{
		cout<<*it<<endl;
	}
	
	cout<<"results8="<<results8<<endl;
	cout<<"results9="<<results9<<endl;
}