bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
		
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
	
	
	return false;
}
double eps=1e-20;//absolut difference
double releps=1e-10;//relative difference

TString sInt(Int_t number)
  {
    stringstream ss;
    ss << number;
	TString ts = ss.str();
    return ts;
  }
TString sDouble(Double_t number)
  {
    stringstream ss;
	ss << number;
    TString ts = ss.str();
    return ts;
  }
 struct RatioInfo
 {
	 int z;
	 int subshellIndex;
	 double ratioMax;
 };
  
std::vector<RatioInfo> ratioMaxV;

int Results1=0;
int Results2=0;
int Results3=0;
int Results4=0;
int Results5=0;
int Results6=0;

int results=0;
int results1=0;
std::vector<int> resultsV;
int results2=0;
int results3=0;

int results5=0;
std::vector<int> results5V;

string subShellDesignators[62] = {"K(1s1/2)",    "L(2)",     "L1(2s1/2)",  "L23(2p)",   "L2(2p1/2)", 
								  "L3(2p3/2)",   "M(3)",      "M1(3s1/2)", "M23(3p)",   "M2(3p1/2)",
								  "M3(3p3/2)",   "M45(3d)",   "M4(3d3/2)", "M5(3d5/2)", "N(4)",
								  "N1(4s1/2)",   "N23(4p)",   "N2(4p1/2)", "N3(4p3/2)", "N45(4d)", 
								  "N4(4d3/2)",   "N5(4d5/2)", "N67(4f)",   "N6(4f5/2)", "N7(4f7/2)",
								  "O(5)",        "O1(5s1/2)", "O23(5p)",   "O2(5p1/2)", "O3(5p3/2)",
								  "O45(5d)",     "O4(5d3/2)", "O5(5d5/2)", "O67(5f)",   "O6(5f5/2)",
								  "O7(5f7/2)",   "O89(5g)",   "O8(5g7/2)", "O9(5g9/2)", "P(6)",
								  "P1(6s1/2)",   "P23(6p)",   "P2(6p1/2)", "P3(6p3/2)", "P45(6d)",
								  "P4(6d3/2)",   "P5(6d5/2)", "P67(6f)",   "P6(6f5/2)", "P7(6f7/2)", 
								  "P89(6g)",     "P8(6g7/2)", "P9(6g9/2)", "P1011(6h)", "P10(6h9/2)",
								  "P11(6h11/2)", "Q(7)",      "Q1(7s1/2)", "Q23(7p)",   "Q2(7p1/2)", 
								  "Q3(7p3/2)"};




void plotComparison(int z,int index, int designator, std::vector<double>& x_1, std::vector<double>& y_1, 
                          std::vector<double>& x_2, std::vector<double>& y_2)
{
	cout<<endl;
	cout<<"------------Z = "<<z<<" shell_"<<index<<"--------------"<<endl;
	gROOT->Reset();
		
	TString S = sInt(z); 
	TString title1;
	TString designatorS = subShellDesignators[designator-1]; 
	
	TString indexS = sInt(index);
	title1 = "Cross section of photoelectric reaction by Subshell_" + indexS + " " + designatorS + " for element Z = " + S;
	
	
	
	int num1 = x_1.size();
	int num2 = x_2.size();
	
	// std::vector<int> vec1;
	// for(int j =0;j<num1;++j)
	// {
		// if(y_1[j] == y_1[j-1] && j)
		// {
			// vec1.push_back(j);
		// }
					
	// }

		
		TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",800, 50, 1200, 1000);
		
		mycanvas->SetGrid();
		mycanvas->Divide(1,2);
		
		
		
		mycanvas->cd(1);
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		TGraph *graph1 = new TGraph(num1,x_1.data(),y_1.data());
		TGraph *graph2 = new TGraph(num2,x_2.data(),y_2.data());
		
		auto mg1 = new TMultiGraph();
		
		
		
		//set graph parameters of EPDL2014
		graph1->SetMarkerStyle(7);  // red point
		graph1->SetMarkerSize(2);
		graph1->SetMarkerColor(2);
		//graph1->SetLineWidth(2);
		graph1->SetLineColor(2);	
		// graph1->Draw("PL");
		
		mg1->Add(graph1);	
		
		//set graph parameters of livermore
		graph2->SetMarkerStyle(4);  //blue circle
		graph2->SetMarkerSize(0.7);
		graph2->SetMarkerColor(4);
		graph2->SetLineColor(4);
		
	    mg1->Add(graph2);
		
		mg1->Draw("APL");
		mg1->SetTitle(title1);
	
		mg1->GetXaxis()->SetTitle("Energy (MeV)");
		mg1->GetYaxis()->SetTitle("Cross section (barn)");
		
		mg1->GetXaxis()->SetTitleSize(0.06);
		mg1->GetYaxis()->SetTitleSize(0.06);
		
		mg1->GetXaxis()->SetTitleOffset(1.2);
		mg1->GetYaxis()->SetTitleOffset(1);
		
		mg1->GetXaxis()->SetLabelSize(0.05);
		mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
	
	   
	
		
		
		// graph2->SetMaximum(5e-25); 
		// graph2->SetMinimum(1e-35); 
		
		
		TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// leg->SetTextAlign(12);
		leg->SetFillColor(0);	
		leg->SetTextSize(0.04);
		
		
		TString Tnum1 = sInt(num1);		
		TString Tnum2 = sInt(num2);	
		
		
		TString name1 = "EPDL2017 - " + Tnum1 + " points" ;
		
		
		TString name2 = "EPDL2014 - " + Tnum2 + " points" ;		
		
		leg->AddEntry(graph1,name1);
		leg->AddEntry(graph2,name2);
		//leg->DrawClone("Same");
		leg->Draw();
		
		int flag=0;
		int flag1=0;
		int flag2=0;
		int exception = 0;
		//for containing the ratio;
		
		
		
		
		std::vector<double> r(num2, 10000000000);  
		
	
		
		bool isFound = false;
		for(Int_t i=0;i<num2;++i)  //EPDL2014  
		{
			for(Int_t j=0;j<num1;++j) //EPDL2017
			{
				//  
				 
				if(IsEqual(x_1[j],x_2[i], eps, releps))
				{				
					// cout<<flag<<"-----"<<x_2[i]<<endl;
					flag1++;
					
					if(IsEqual(y_2[i],y_1[j], eps, releps)) //if(i==0)
					{
						
						r[i]=0;
						// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<r[i]<<"-------------------Same---1"<<endl;
						// printf("%d %.9e %.9e--------------------Same---1\n",i+1,x_2[i], r[i]);
					}
					else 
					{
						
						r[i] = (y_1[j] - y_2[i])/y_2[i]*100;  //percentage
						// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<" "<<r[i]<<"     1"<<endl;
						// printf("%d %.9e %.9e %.9e %.9e    1\n",i+1,x_2[i],y_2[i], y_1[j], r[i]);
						
						// if( x_1[j] ==x_1[j+1] && (j< (num1-1)))
						// {
							// double temp = (y_1[j+1] - y_2[i])/y_2[i]*100;
							// if((abs(temp) - abs(r[i]))<0)
							// {
								// // printf("1zhuxin %d %.9e %.9e %.9e %.9e %.9e  1\n",j+1,x_2[i], y_1[j], y_1[j+1], r[i], temp);
								// r[i] = temp;
								
							// }
						// }
						
						
					}
					
					//cout<<i<<"-----EPDL2014=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
					isFound = true;
					break;			
					
				}				
			}
			if(!isFound)
			{
				for(Int_t j=0;j<num1;++j) //EPDL2014
				{
					if(abs((x_1[j]-x_2[i])/x_2[i])<0.0001) // 0.0001 at first
					// if(abs(x_1[j]-x_2[i])<0.001)
					{
						flag2++;
						if(IsEqual(y_2[i],y_1[j], eps, releps)) //if(i==0)
						{
							
							r[i]=0;
							// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<r[i]<<"--------------------Same---2"<<endl;
							// printf("%d %.9e %.9e %.9e--------------------Same---2\n",i+1,x_2[i], x_1[j], r[i]);
						}
						else 
						{
							
							r[i] = (y_1[j] - y_2[i])/y_2[i]*100;  //percentage
							// cout<<flag<<" "<<i+1<<" "<<x_2[i]<<" "<<x_1[j]<<" "<<r[i]<<"     2"<<endl;
							// printf("%d %.9e %.9e %.9e %.9e %.9e   2\n",i+1,x_2[i], y_2[i],x_1[j], y_1[j], r[i]);
						}
						
						//cout<<i<<"-----EPDL2014=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
						break;
					}
				}
			}
			isFound = false;		
			
		}
		
		
		
		
		flag = flag1+flag2;
		
		double r_x[flag];
		double R[flag]; 
		int k = 0;
		
		// cout<<sizeof(r)/sizeof(r[0])<<endl;
		// cout<<sizeof(r_x)/sizeof(r_x[0])<<endl;
		
		
		// for(int j=0;j<num2;++j)
		// {
			
			// cout<<j+1<<" " <<x_2[j]<<" "<<r[j]<<endl;				
			
		// }
		bool test1 = true;
		for(int j=0;j<num2;++j)
		{
			if(r[j]==10000000000)
			{
				// cout<<j+1<<" "<<x_2[j]<<" "<<r[j]<<"----------------3"<<endl;
				// printf("%d %.9e %.9e----------------3\n",j+1,x_2[j], r[j]);
				exception++;
				
				//if this is satisfied, for this element, means the exception 
				//is due to the precision, instead of the minimum energy of EPDL2017
				if(x_2[j]>=x_1[0])  
				{
					test1 =false;
				}
				// continue;
				
			}
			else
			{
				r_x[k] = x_2[j];
				R[k] = r[j];
				k++;
			}
						
		}
		
		double max = R[0];
		for(int i=0;i<k;i++)
		{
			if(abs(R[i])>abs(max))
			{
				max = R[i];
			}
		}
		RatioInfo ratioInfo;
		ratioInfo.z = z;
		ratioInfo.subshellIndex = index;
		ratioInfo.ratioMax = max;
		ratioMaxV.push_back(ratioInfo);
		
		
		
		
		
		if(!test1) 
		{
			results5++;
			results5V.push_back(index);
			// if(exception)
			// {
				// cout<<"jjjjjjjj exceptions are all detected for element "<<z<<"jjjjjjjjjjjjjjjjjjjj"<<endl;
			// }
			// else cout<<"xxxxxxx exceptions are not all detected for element "<<z<<"xxxxxxxxxxxxxxxxxxxxx"<<endl;
			
		}
		
		
		
		// for(int i=0;i<flag;++i)
		// {
			// cout<<i+1<<" "<<R[i]<<endl;
		// }
		
	//***this part of codes are only meaningful for a subshell
		cout<<"num2="<<num2<<", flag="<<flag<<" || flag1="<<flag1<<", flag2="<<flag2<<", exception="<<exception<<endl;
		if(flag==num2) 
		{
			results++;
			resultsV.push_back(index);
			// cout<<"flag=="<<flag<<endl;
			if(flag2==0)
			{
				results2++;
				cout<<"flag==num2,totally match for all points energy for subshell_"<<index<<"****************************"<<endl;	
			}
			else
			{
				results3++;
				cout<<"flag==num2,some points are mathched with 0.001% precision for subshell_"<<index<<"##############################"<<endl;
			}
			
		}
		else{
			results1++;						
			cout<<"Some points in EPDL2014 are not found for subshell_"<<index<<"-------------------------"<<endl;
		}
		
		
		
		
		mycanvas->cd(2);
		gPad->SetLogx();
		
		// gPad->SetTopMargin(0.12);
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetBottomMargin(0.15);
		// gPad->SetGrid();
		// gStyle->SetTitleW(0.9);  //per cent of the pad width
		// gStyle->SetTitleH(0.9);
		// gStyle->SetTitleFontSize(0.9);
		
		// // pad21->SetLeftMargin(0.10); //10%
		
		
		char nameRatio[100] = "Relative difference of EPDL2017 compared to EPDL2014";	
		
		TGraph *ratio = new TGraph(k,r_x,R);
		ratio->SetTitle(nameRatio);
		ratio->Draw();
		
		ratio->GetXaxis()->SetTitle("Energy (MeV)");
		ratio->GetYaxis()->SetTitle("Relative Difference (%)");
		
		ratio->GetXaxis()->SetTitleSize(0.06);
		ratio->GetYaxis()->SetTitleSize(0.06);
		
		ratio->GetYaxis()->SetTitleOffset(1.0);
		ratio->GetXaxis()->SetTitleOffset(1.2);
		
		ratio->GetXaxis()->SetLabelSize(0.05);
		ratio->GetYaxis()->SetLabelSize(0.05);
			
		ratio->GetXaxis()->CenterTitle();
		ratio->GetYaxis()->CenterTitle();
		
		ratio->SetMarkerStyle(8);
		ratio->SetMarkerSize(0.5);
		ratio->SetMarkerColor(2);
		ratio->SetLineColor(2);
		
		// ratio->GetXaxis()->SetLimits(1e-6,100000.);
		
	
		
		TLatex latex;
		latex.SetTextSize(0.05);
		latex.SetTextAlign(22);
		latex.DrawLatexNDC(0.7,0.8,"RD = #frac{EPDL2017-EPDL2014}{EPDL2014} x 100");
		
		
		TString Tflag = sInt(k);	
		Tflag += " points in comparison";
		latex.SetTextColor(2);
		latex.DrawLatexNDC(0.7,0.7,Tflag);
		
		
		
		
		// TLegend* leg212 =  new TLegend(0.12,0.7,0.3,0.88);
		// TString Tnum4 = sInt(num2);
		// TString name4 = Tnum4 + " points in comparison";		
		// leg212->AddEntry(ratio,name4);
		// leg212->SetTextAlign(22);
		// leg212->SetFillStyle(0);
		// leg212->Draw();
		// leg212->SetTextSize(0.05);
		
		
		
		
		//***********(begin)for the zooming of the ratio 		
		
		mycanvas->Print("plots/subshellCS_comparison/2014vs2017comparison-pe-ss-"+ S + "-shell"+ indexS + ".png");
		// mycanvas->Close();
		delete mycanvas;
		mycanvas = NULL;
		
		
}

void plot_ss_cs(){
	
	gROOT->Reset();
	// create the 2 directories if they do not existif
	gSystem->Exec("mkdir -p plots/subshellCS_comparison");
	
// do not modify*****************begin	
//this is to read the binding energy for epics2017 and epics2014,
//the data read will be used to verify if the minimum energy of each subshell
//is equal to the binding energy	
	FILE*fp3 = fopen("epics2017/phot_preliminary/bindingEnergy/binding.dat","r");	
	FILE*fp4 = fopen("epics2014/phot_preliminary/bindingEnergy/binding.dat","r");	
	
	std::vector<int> designator_1[101];
	std::vector<double> be_1[101];
	
	
	std::vector<int> designator_2[101];
	std::vector<double> be_2[101];
	double d1; 
	double e1; 
	double d2; 
	double e2; 
    Int_t Ncols = 0;
	Int_t count = 0;
	
    for(int i=1; i<=100; ++i)  // there are 100 elements
	{
		
		
		while(1)
		{
			count++; // number of line of -1           -1   
			Ncols = fscanf(fp3,"%lf %lf",&d1,&e1);
			// cout<<"yes"<<endl;
			Ncols = fscanf(fp4,"%lf %lf",&d2,&e2);
			
			
			
			if(d1 ==d2 && d1 == -1)
			{
				// cout<<"---ending---Z = "<<i<<" "<<count<<endl;

				break;
			}
			else{
				
				// printf("%d %.9e %.9e %.9e %.9e\n",count, d1, e1, d2, e2);
			 
				designator_1[i].push_back(d1);
				be_1[i].push_back(e1);
				designator_2[i].push_back(d2);
				be_2[i].push_back(e2);
			 
			
			}
			 
			
		}	
		
	}
	fclose(fp3);
	fclose(fp4);
// do not modify*****************end
	double x;
	double y;
	for (Int_t z = 5;z<=5;++z)// number of element Z, from 1 to 100
	{
		
		TString s = sInt(z);
		TString datafile2017= "epics2017/phot_preliminary/pe-ss-cs-" + s + ".dat";
		
		
		ifstream  data_file_2017(datafile2017, ios::in );
        if(data_file_2017.fail()){
            cout << "Error opening data file 2017"  << endl;
        }else {
            cout << "data file " << datafile2017 << " is opened" << endl;
        }
        if(!data_file_2017) break;	
        
		int nb_subshells = be_1[z].size(); // number of subshells for the given element
		vector<double> x_1[nb_subshells]; 
		vector<double> y_1[nb_subshells]; 
		
		vector<double> x_2[nb_subshells]; 
		vector<double> y_2[nb_subshells];
		
		double x;
		double y;
        int subshell_index = -1;
        for (int N = 0; N < 99999; N++)
        {
            data_file_2017 >> x >> y;
			if(x < -1.5) 
			{ 
                break; 
                
            } 
			else if(0.0 == y) 
			{
				subshell_index++;
			}
			else if(x == -1)
			{
				
			}			
			else
			{
				x_1[subshell_index].push_back(x);
				y_1[subshell_index].push_back(y);
				
			}
		
		}
		data_file_2017.close();
		
		TString datafile2014= "epics2014/phot_preliminary/pe-ss-cs-" + s + ".dat";		
		ifstream  data_file_2014(datafile2014, ios::in );
        if(data_file_2014.fail()){
            cout << "Error opening data file 2014"  << endl;
        }else {
            cout << "data file " << datafile2014 << " is opened" << endl;
        }
        if(!data_file_2014) break;	
		
		subshell_index = -1;
        for (int N = 0; N < 99999; N++)
        {
            data_file_2014 >> x >> y;
			if(x < -1.5) 
			{ 
                break; 
                
            } 
			else if(0.0 == y) 
			{
				subshell_index++;
			}
			else if(x == -1)
			{
				
			}			
			else
			{
				x_2[subshell_index].push_back(x);
				y_2[subshell_index].push_back(y);
				
			}
		
		}
		data_file_2014.close();
		
		// int j = 3;
		// for(int i = 0; i<x_1[j].size();i++)
		// {
			// printf("%.9e %.9e\n",x_1[j][i], y_1[j][i]);
		// }
		
		// for(int i = 0; i<x_2[j].size();i++)
		// {
			// printf("%.9e %.9e\n",x_2[j][i], y_2[j][i]);
		// }
		
		for(int i = 0; i<nb_subshells; i++)
		{
			if(z!=5 || i!=0 )
			{
				
				continue;
			}
			
			plotComparison(z, i, designator_1[z][i], x_1[i], y_1[i], x_2[i], y_2[i]);
			printf("------%d %d %d\n", z, i,designator_1[z][i]);
		}
		
		
	
	
		
		// FILE* out = fopen("ratioMaxForSubShellCS.txt", "w");
		// std::vector<RatioInfo>::iterator iter;
		// std::vector<RatioInfo>::iterator iter_begin = ratioMaxV.begin() ;
		
		// RatioInfo final;
		// final.z = (*iter_begin).z;
		// final.subshellIndex = (*iter_begin).subshellIndex;
		// final.ratioMax = (*iter_begin).ratioMax;
		
		// for(iter = iter_begin; iter != ratioMaxV.end(); iter++)
		// {
			// fprintf(out,"Element = %d, subshell_%d, ratioMax = %.9e%% \n", 
					    // (*iter).z, (*iter).subshellIndex, (*iter).ratioMax);
			// if((*iter).ratioMax > final.ratioMax)
			// {
				// final.z = (*iter).z;
				// final.subshellIndex = (*iter).subshellIndex;			
				// final.ratioMax = (*iter).ratioMax;
				
			// }
		// }
		// fprintf(out,"Amongst all the subshells, the ratioMax is:\nElement = %d, subshell_%d, ratioMax = %.9e%% \n", 
					    // final.z, final.subshellIndex, final.ratioMax);
		// fclose(out);

		
	}
	
	cout<<"Results1="<<Results1<<endl;
	cout<<"Results2="<<Results2<<endl;
	cout<<"Results3="<<Results3<<endl;
	cout<<"Results4="<<Results4<<endl;
	cout<<"Results5="<<Results5<<endl;
	cout<<"Results6="<<Results6<<endl;
	
	
	// the following parts are meaningful only for one element******************
	// if runs for 100 elements, they are not indicative
	cout<<"results="<<results<<", results2="<<results2<<", results3="<<results3<<endl;
	cout<<"results1="<<results1<<endl;
	
	cout<<"for the following subshells, all points in EPDL2014 are found in EPDL2017"
	<<endl;
	for(std::vector<int>::iterator it = resultsV.begin(); it!=resultsV.end(); it++)
	{
		cout<<*it<<endl;
	}
	
	
	cout<<"results5="<<results5<<endl;
	cout<<"for the following subshells, it has exceptions due to the precision"<<endl;
	
	for(std::vector<int>::iterator it = results5V.begin(); it!=results5V.end(); it++)
	{
		cout<<*it<<endl;
	}
	
	// the following parts are meaningful only for one element******************
}